; Copyright (c) 1991-1992, John David Rohner.  All rights reserved.

;
; This routine uses DOS interrupt 21H to display text to the screen.
;
; Usage:  CALL Ansi(String$)
; Where String$ is the text to display.
;
; This routine is completely distinct from the Basic command LOCATE.  When
; you shell to DOS, the cursor jumps to where ever you were when you entered
; the program, or to whatever LOCATE values you used.
;

.Model Medium, Basic
.Code

            PUBLIC  Ansi              ;Make this routine available to LINK.

Ansi        proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp
            mov     bx,[bp + 06]      ;Get string descriptor.
            mov     cx,[bx]           ;Length of string -> CX.
            jcxz    Done              ;Exit if a null string.
            mov     bx,[bx + 02]      ;Put address of string in BX.
            mov     ah,02             ;Set up for INT 21H, subfunction 02H.
        R1: mov     dl,[bx]           ;Get character to display into DL.
            int     21H               ;Display the character.
            inc     bx                ;Point to next char
            loop    R1                ;Loop until all are done.
      Done: pop     bp
            ret     2                 ;Pop-return past our input parameter.

Ansi        endp                      ;End of routine.

End

