' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' This file contains the routines to work with archives:
'   Archiver
'   ArchiveFileInfo
'   ViewContents
'   ExtractFiles
'




        '* * * * * *
        ' This routine handles working with file archives.
        '
        ' p$  can contain a filename for the routine to work with
        '     rather than asking the user for one.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB Archiver (p$)

  SELECT CASE LEN(p$)
    CASE 0
         TT = 281
         CALL SendTT
         CALL GetFileName(p$,K)
    CASE ELSE
         TT = 10100
         CALL SendTT
         K = BiSearch(3,0,Form$(1201,p$))
  END SELECT
  IF K < 1 OR BitTest(FileIDX.Attr,7) THEN EXIT SUB
  SELECT CASE RIGHT$(p$,3)
    CASE Short$(350), Short$(351), Short$(352)
         FOR K0 = 1 to DirsSize
           K0$ = RTRIM$(FileBases(K0).Path) + p$
           IF FindF(K0$,FFile) <> 0 THEN EXIT FOR
         NEXT
         IF K0 > DirsSize THEN EXIT SUB
    CASE ELSE
         TT$ = SPACE$(14 - LEN(p$)) + BlockText2(282)
         CALL SendTT
         EXIT SUB
  END SELECT
  IF GetFilePassword(K) = 0 THEN EXIT SUB
  TT = 22
  CALL SendTT
  IF TGot > 0 THEN EXIT SUB
  K = StrSrch(1,Short$(554),RIGHT$(K0$,1))         'ziP lzH arJ
  CALL ViewContents(K0$,K)
  DO
    IF TGot < 1 THEN TT = 285 : _
                     CALL SendTT
    IF TGot < 1 THEN CALL TGet(Short$(555) + C13$)
    SELECT CASE TGot
      CASE 86
           TT = 287
           CALL SendTT
           CALL ViewContents(K0$,K)
      CASE 84
           TT = 288
           CALL SendTT
           IF CommPort > 0 THEN TT$ = Short$(749) + LTRIM$(STR$(CommPort)) _
                           ELSE TT$ = Null$
           SELECT CASE K
             CASE 1 : K1$ = Short$(557)    'PKUNZIP /t filename
             CASE 2 : K1$ = Short$(558)    'LHA t /m1 filename
             CASE 3 : K1$ = Short$(559)    'ARJ t /y filename
           END SELECT
           CALL ShellDos(1,FileNames$(30 + K) + K1$ + K0$ + TT$)
      CASE 69
           TT = 10560
           CALL SendTT
           CALL ExtractFiles(K0$,K)
      CASE ELSE
           TT = 10561
           CALL SendTT
           EXIT SUB
    END SELECT
  LOOP UNTIL NoCarrier

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to Archiver, gets and returns the
        ' information about a single archive member file.
        '
        ' p    Archieve type: 1 = ZIP, 2 = LZH, 3 = ARJ
        '
        ' p&   current position in the file.
        '
        ' p$   path and file name of member.
        '
        ' p0&  Original size
        '
        ' p1&  Stored size
        '
        ' p0   Date integer
        '
        ' p0$  Method
        '
        ' p1   opened file's handle
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB ArchiveFileInfo (p,p&,p$,p0&,p1&,p0,p0$,p1)

  SELECT CASE p
    CASE 1
         CALL FileGetLoc(p1,p& - 1,30,ZIPInfo)
         p& = p& + 30
         IF ZIPInfo.TestString <>  Short$(572) + C3$ + C4$ _
            THEN p& = FileLof&(p1,1) : _
                 p$ = Null$ : _
                 EXIT SUB
         p0& = ZIPInfo.OriginalSize
         p1& = ZIPInfo.StoredSize
         p0 = ZIPInfo.FileDate
         IF ZIPInfo.Method > 8 _
            THEN p0$ = GetLine$(296) _
            ELSE p0$ = MID$(GetLine$(297),ZIPInfo.Method * 8 + 1,8)
         p$ = SPACE$(ZIPInfo.NameLength) 'See ExtractFiles--Quirk after a line like this.
                                          'Before this p1& is ok, after, it jumps 500k.
         CALL FileGetSLoc(p1,p& - 1,p$)
         p& = p& + p1& + ZIPInfo.NameLength + ZIPInfo.HeaderLength
    CASE 2
         CALL FileGetLoc(p1,p& - 1,22,LZHInfo)
         p& = p& + 22
         p0& = LZHInfo.OriginalSize
         p1& = LZHInfo.StoredSize
         p0 = LZHInfo.FileDate
         p0$ = LZHInfo.Method
         p$ = SPACE$(AscVal(LZHInfo.NameLength))
         CALL FileGetSLoc(p1,p& - 1,p$)
         p& = p& + p1& + 2 + AscVal(LZHInfo.HeaderLength) - 22
    CASE 3
         CALL FileGetLoc(p1,p& - 1,34,ARJInfo)
         K2& = p&
         p& = p& + 34
         p0& = ARJInfo.OriginalSize
         p1& = ARJInfo.StoredSize
         p0 = ARJInfo.FileDate
         K1 = AscVal(ARJInfo.Method)
         IF K1 > 4 THEN p0$ = GetLine$(296) _
                   ELSE p0$ = MID$(GetLine$(298),K1 * 9 + 1,9)
         p$ = Null$
         K$ = C32$
         CALL FileGetSLoc(p1,p& - 1,K$)
         p& = p& + 1
         WHILE K$ <> C0$
           p$ = p$ + K$
           CALL FileGetSLoc(p1,p& - 1,K$)
           p& = p& + 1
         WEND
         p& = K2& + p1& + ARJInfo.HeaderLength + 10
         IF AscVal(ARJInfo.EntryType) <> 0 THEN p$ = Null$
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to Archiver, lists the contents of an
        ' archive.
        '
        ' p$  name of archive.
        '
        ' p   Archieve type: 1 = ZIP, 2 = LZH, 3 = ARJ
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB ViewContents (p$,p)

  TT = 536
  CALL SendTT
  K9 = FileOpen(p$)
  K& = 1
  DO
    CALL ArchiveFileInfo(p,K&,K0$,K0&,K1&,K0,K1$,K9)
    SELECT CASE LEN(K0$)
      CASE IS > 0
           IF LEN(K0$) > 26 _
              THEN TT$ = LEFT$(K0$,11) + Short$(562) + RIGHT$(K0$,12) _
              ELSE TT$ = Form$(2601,K0$)
           TT$ = Short$(563) + TT$ + Short$(78) + Form2$(11,K0&) + _
                 Short$(65) + Form2$(11,K1&) + _
                 Form$(966,PercentCalc$(K0&,K1&)) + Short$(565) + _
                 IntToDate3$(K0) + Short$(564) + RTRIM$(Form$(908,K1$)) + C1310$
           CALL SendTT
    END SELECT
  LOOP UNTIL K& + 3 >= FileLof&(K9,1) OR TGot > 0
  CALL FileClose(K9)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to Archiver, handles the extraction
        ' of files.
        '
        ' p$  name of archive.
        '
        ' p   Archieve type: 1 = ZIP, 2 = LZH, 3 = ARJ
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB ExtractFiles (p$,p)

  TT = 289
  CALL SendTT
  K9 = FileOpen(p$)
  K& = 1
  FileIndex = 1
  K1$ = RTRIM$(FileBases(FileIndex).Path) + Short$(840)
  K1& = DriveSpc&(Paths$(9))
  IF FindF(K1$,FFile) <> 0 THEN K1& = K1& - FFile.FSize
  TT$ = BlockText2(291)
  DO
    K0$ = Null$
    '
    ' BASIC PDS quirk:  A 0 instead of 0& will corrupt K1& in ArchiveFileInfo
    '                   when K0$ is given/assigned data in ArchiveFileInfo.
    '
    CALL ArchiveFileInfo(p,K&,K0$,K0&,0&,0,"",K9)      'Don't use Null$.
    K0 = LEN(K0$)
    SELECT CASE K0
      CASE IS > 0
           TT$ = TT$ + Short$(68) + K0$ + Short$(568)
           CALL SendTT
           CALL TGet(C2$ + Short$(158) + C13$)
           CALL Wipe(6)
           SELECT CASE TGot
             CASE 89
                  TT = 292
                  CALL SendTT
                  SELECT CASE K1&
                    CASE IS < K0& * 2 + Settings.MinSpace
                         CALL Wipe(15)
                         TT = 293
                         CALL SendTT
                         CALL Wipe(35 + K0)
                         TGot = -1
                         TT$ = Null$
                    CASE ELSE
                         IF p = 1 _
                            THEN TT$ = p$ + C32$ + K0$ + C32$ + Paths$(9) _
                            ELSE TT$ = Short$(570) + p$ + C32$ + _
                                       Paths$(9) + C32$ + K0$
                         TT$ = FileNames$(30 + p) + C32$ + TT$
                         CALL ShellDos(1,TT$)
                         CALL Wipe(15)
                         TT = 6
                         CALL SendTT
                         K1& = K1& - K0& * 2
                         TT$ = BlockText2(294)
                         TGot = 89
                  END SELECT
             CASE ELSE
                  CALL Wipe(3 + K0)
                  TT$ = Null$
           END SELECT
    END SELECT
  LOOP UNTIL K& + 3 >= FileLof&(K9,1) OR NoCarrier
  CALL FileClose(K9)
  IF TGot <> 89 THEN CALL Wipe(24)
  TT = 295
  CALL SendTT
  K2$ = Paths$(9) + Short$(645)
  CALL ShellDos(1,FileNames$(30) + GetLine$(545) + K1$ + C32$ + K2$)
  TT = 417
  CALL SendTT
  SELECT CASE FindF(K1$,FFile)
    CASE IS <> 0
         K1 = BiSearch(3,0,Form$(1201,Short$(840)))
         K0 = FileOpen(FileNames$(4))
         IF K1 = 0 THEN CALL CreateFileStuff(3,128,0,K0) : _
                        K1 = FileLof&(K0,119) + 1 _
                   ELSE FileIDX.FSize = FFile.FSize : _
                        CALL FilePutRec(Handle(22),K1,22,FileIDX) : _
                        K1 = FileIDX.FRec : _
                        CALL FileGetRec(K0,K1,119,FileList) : _
                        FileList.FSize = FFile.FSize
          CALL FilePutRec(K0,K1,119,FileList)
          CALL FileClose(K0)
  END SELECT
  IF FindF(K2$,FFile) <> 0 THEN DO : CALL KillFile(Paths$(9) + FFile.FName) : _
                                LOOP UNTIL FindF(K2$,FFile) = 0
                                'Can't use Null$ above because deleting changed
                                'things.

END SUB
        '
        '* * * *

