; Copyright (c) 1991-1992, John David Rohner.  All rights reserved.

;
; This routine uses gets the ASCII value of the first character of a string.
;
; Usage:  Result% = AscVal(Input$)
; Where Input$ is the text to to analyze, and Result% contains the value
; itself.  Returns 0 if the string is null, or the first character contains
; a CHR$(0) code.
;
; Essentially a direct replacement for the basic ASC function.
;

.Model Medium, Basic
.Code

            PUBLIC  AscVal            ;Make this routine available to LINK.

AscVal      proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp
            xor     ax,ax             ;Zero out AX, returns at least a 0.
            mov     bx,[bp + 06]      ;Get descriptor of the string.
            mov     cx,[bx]           ;Move size of string into CX.
            jcxz    Done              ;If a null string, then exit.
            mov     si,[bx + 02]      ;String location -> SI.
            lodsb                     ;Get the first byte.
      Done: pop     bp
            ret     2                 ;Pop-return past our input parameter.

AscVal      endp                      ;End of routine.

End

