'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' This file is to be "$INCLUDED" with all Basic modules.
'

'
' All variables integer unless defined otherwise.
'
DEFINT A-Z

'
' Some "don't let user change" strings.
'
CONST PID = "JDR_BBS.07"
CONST CopyRight = "Copygh(c) 1991-1992JohRohn.Aightsv."


'
' Create the data structures.
'

'
' UserRecord is the record structure of the USERS file.  In the program the
' current users' information is stored in USER. in just such a record.
' Other user data is read in with the AnyUser. variable.
'
TYPE UserRecord                  'Len = 384
  UserName    AS STRING * 30     'Uppercase only.
  Password    AS STRING * 15     'Uppercase only.
  CityState   AS STRING * 30     'Uppercase only.
  HomePhone   AS LONG            'See "ModHomePhone"
  BBSPhone    AS LONG            'See "ModBBSPhone"
  BirthDate   AS INTEGER         'Birthdate of user.
                                 'Date stored in integer form.
  SecLevel    AS INTEGER         '-32,767 to 32,767 security level.
  FirstCall   AS INTEGER         'First date user called.
                                 'Date stored in integer form.
  Attr        AS INTEGER         '16 bits:
                                 '1 True if user is deleted.
                                 '2 True if user is locked out.
                                 'x True if user cannot be auto-deleted.
                                 'x True if user wants full screen editor.
                                 '5 True if should trap the user's chat.
                                 '6 True if should trap the user's sessions.
                                 'x True if should show SysopNote to user
                                 '  at their next (and only next) logon.
                                 'x True if user can't send net mail.
                                 '9 True if should beep console when user calls.
                                 '0 True if user is not validated/PR.
                                 'A True if user is an AI.
                                 'B True if user doesn't want to do PR'ing.
                                 'C True if should do Phone verification.
                                 'D True if should force new pswd after call-back.
                                 'rest for the future.
  Toggles     AS INTEGER         '16 bits:
                                 '1 True if should beep after transfers.
                                 '2 True if show Enter Msg line numbers.
                                 '3 True if show Read Msg total lines.
                                 '4 True if should "turbo" out the msgs.
                                 '5 True if user is a male.
                                 '6 True if password assist is on.
                                 '7 True if want to see L&D/Point values.
                                 'rest for the future.
  Protocol    AS STRING * 1      'User's procotol default.
  Votes       AS STRING * 100    '=100 Voting questions (Byte answers).
  SubsStart   AS INTEGER         'Subscription start date.
                                 'Date stored in integer form.
  SubsEnd     AS INTEGER         'Subscription end date.
                                 'Date stored in integer form.
  SubsType    AS STRING * 1      'Subscription type.
  Monies      AS LONG            '$0.00 to $21000000.00 Current monies.
                                 'Use a shifted decimal point.
  TotalMonies AS LONG            '$0.00 to $21000000.00 Total monies ever sent.
                                 'Use a shifted decimal point.
  LastDateOn  AS INTEGER         'Last time user called.
                                 'Date stored in integer form.
  PswdChange  AS STRING * 1      'Counter towards user change password order.
                                 '0 = off, 1 to 255 ascii value.
  AlterDate   AS INTEGER         'The last date in which they exercised
                                 'their Life & Death options.
                                 'Date stored in integer form.
  JDRVerDL    AS INTEGER         '= mmyy in JDR_mmyy versions.
                                 'The last version of JDR_mmyy that they
                                 'downloaded.
  BullsRead   AS STRING * 8      'Each bit = toggle for 1 bulletin read.
  Connect     AS STRING * 1      'Last baud user connected at.
  HiFilePtr   AS LONG            '0 to 2,100,000,000
                                 'What the "HiFilePtr" number was at the last
                                 'time they called, any stuff with
                                 'numbers higher is new to them.
  HighestPtr  AS LONG            '0 to 2,100,000,000 Highest HileFilePtr they
                                 'know about.  HiFilePtr is call
                                 'dependant--it's updated after they log out,
                                 'this isn't--this is a security measure.
  PagedSysop  AS INTEGER         '0 to 32,767 Number of times they've tried to
                                 'page the sysop.
  Logons      AS INTEGER         '0 to 32,767 Number of logons.
  Attempts    AS STRING * 1      '0 to 255 Number of bad password attempts
                                 'since their last call.
  MinCredits  AS INTEGER         '-32,767 to 32,767
                                 'Number of minutes to add to their daily
                                 'that their security level gets.
  MinMegs     AS INTEGER         '-32,767 to 32,767
                                 'This number is multiplied by 1 megabyte
                                 'and then added to their "number of
                                 'bytes can download" to determine what
                                 'their download bytes limit is.
  MsgsPosted  AS INTEGER         '0 to 32,767 Total number of public messages
                                 '(excluding NetMail) they've posted.
  EMsgsPosted AS INTEGER         '0 to 32,767 Total number of private
                                 '(excluding feedback and NetMail) messages
                                 'they've posted.
  FMsgsPosted AS INTEGER         '0 to 32,767 Total number of feedback
                                 'messages they've posted.
  NetMailSent AS INTEGER         '0 to 32,767 Total number of NetMail letters
                                 'they've sent.
  NetMailRcvd AS INTEGER         '0 to 32,767 Total number of NetMail letters
                                 'they've received.
  Elapsed     AS INTEGER         '0 to 32,767 Length of previous call(s).
                                 'Never exceeds maximum daily limit for
                                 'whatever security level.
  Dnlds       AS INTEGER         '0 to 32,767 Total files downloaded.
  DLBytes     AS LONG            '0 to 2,100,000,000 Total bytes downloaded.
  MinsDLing   AS LONG            '0 to 2,100,000,000 Total number of minutes
                                 'downloading.
  BadDLs      AS INTEGER         '0 to 32,767 Total number of bad DL's.
  Uplds       AS INTEGER         '0 to 32,767 Total files uploaded.
  ULBytes     AS LONG            '-'ve to 2,100,000,000 Total bytes uploaded.
  MinsULing   AS LONG            '0 to 2,100,000,000 Total number of minutes
                                 'uploading.
  BadULs      AS INTEGER         '0 to 32,767 Total number of bad UL's.
  Doors       AS INTEGER         '0 to 32,767 Number of accesses to doors.
  Group       AS INTEGER         'undefined as yet.
  SysopNote   AS STRING * 52     'Sysop's note field about the user.
                                 'For important internal information.
  UserNote    AS STRING * 52     'User modifiable note field.
                                 'Can be used for: self-praise, some item
                                 'the sysop should know, if a sysop--then
                                 'name of their BBS, their street address,
                                 'zip, system type, etc..  Whatever you want.
END TYPE

'
' UsersNameInfo is the type used in an internal array which contains all
' the user names, and their record number in USERS file--it's an array index.
' The array is UsersName().
'
TYPE UsersNameInfo               'Len = 32
  UserName AS STRING * 30        'User name, uppercased.
  RecNum AS INTEGER              'Record number of user record in USERS.
END TYPE

'
' MessageRecord is the record structure used for each messages header in
' the MESSAGES file.  In the program, the message data is stored in the
' Message. variable with this same record.
'
TYPE MessageRecord               'Len = 128
  Attr          AS INTEGER       '16 bits:
                                 '1 True if a deleted message.
                                 '2 True if Msg body is compressed.
                                 '3 True if this is a reply.
                                 'x True if NetMail
                                 'x True if shouldn't ever NetMail out.
                                 'x True if shouldn't ever Auto delete.
                                 'x True if should never delete at all.
                                 '8 True if redirected from sysop.
                                 '9 True if redirected from AI.
                                 '10 True if redirected to sysop.
                                 '11 True if redirected to AI.
                                 '12 True if there are file attaches.
                                 '13 True if message will be completed later.
                                 'Rest are for the future.
  MsgNum        AS LONG          '1 to 2,100,000,000 message number.
                                 'Each message base has it's own message
                                 'counter.
  MsgFrom       AS STRING * 30   'Name of sender.  Uppercase.
  MsgTo         AS STRING * 30   'Name of receiver or "ALL".  Uppercase.
  MsgDateSent   AS INTEGER       'Date message was sent.
                                 'Date stored in integer form.
  MsgTimeSent   AS INTEGER       'Time stored in integer form.
                                 'HHMM and +/-'ve depending on am/pm.
  MsgDateRcvd   AS INTEGER       'Date message was received.  0 if not
                                 'received or sent to "ALL".
                                 'Date stored in integer form.
  MsgTimeRcvd   AS INTEGER       'Time stored in integer form.
                                 'HHMM and +/-'ve depending on am/pm.
  NumOfBytes    AS INTEGER       'Doesn't exceed 8192, message length.
  NumberReplies AS STRING * 1    'This message has been replied to x times.
                                 'This is not the number of active replies.
  TimesRead     AS INTEGER       'Number of times this message has been read.
  LastDateRead  AS INTEGER       'last date anybody read the message.
  MsgSubject    AS STRING * 33   'Compressed text--message subject.
  MsgBase       AS INTEGER       '0 - 32,767 Message bases.
  MsgCheckSum   AS INTEGER       'Checksum of the to/from/subject fields.
  NetAttr       AS INTEGER       'NetMail attributes.
                                 '16 bits:
                                 '1 TRUE if private mail, else public.
                                 '4 TRUE if message has been sent/exported.
  SourceAddr    AS LONG          'NetMail source address.
  DestAddr      AS LONG          'NetMail destination address.
END TYPE

'
'
' MessageInfo is the structure used the in the programs internal MsgPtr().
' array.  It's an index of all the active messages.  See NameCkSum routine
' for additional info.
'
TYPE MessageInfo                 'Len = 14
  MsgLoc  AS LONG                'Location (bytes) of start of message in
                                 'the MESSAGES file.
  MsgNum  AS LONG                'The message's number.
  MsgBase AS INTEGER             'Message base (1-32767) to which it belongs.
  MsgTo   AS INTEGER             'Numeric form of receiver's name.
  MsgFrom AS INTEGER             'Numeric form of sender's name.
END TYPE

'
' FileListRecord is the data stucture used in the FILELIST file.  The data
' file containing the information for the various potential downloads.
'
TYPE FileListRecord              'Len = 119
  FArea    AS INTEGER            '0 to 32,767 File areas.
  HiFilePtr  AS LONG             'The number each file is given, needs
                                 'not be unique, but represents to the
                                 'system and users when something is new.
                                 'Similar in concept to just checking
                                 'for new file dates since last call.
  LDCount  AS INTEGER            'Chr$(0-28), Chr$(100-199),  A symbolic
                                 'counter and guide about how long a file
                                 'will be on-line (in days), also offers
                                 'opportunity for users to "knock down" or
                                 '"raise up" the "life" of the file.
                                 '100-199 represents 00-99 file points value.
  FName    AS STRING * 12        'The file name.  Including "."
                                 'deliminator--left justified.
  FDesc    AS STRING * 51        'The file's description.
  FSize    AS Long               'The file's size.
  UserName AS STRING * 30        'Uppercased.  Name of uploader.
  FileType AS INTEGER            'x = Public
                                 'x = Private
                                 'x = NetMail attachment
                                 'rest for the future.
  Password AS INTEGER            'Two byte (checksum) password.
  Downloaded AS INTEGER          'Number of times downloaded.
  LastDLed AS INTEGER            'Last date it was downloaded.
  DateULed AS INTEGER            'Date it was uploaded.
  Attr AS INTEGER                '16 bits:
                                 '1 True if deleted.
                                 '2 If free.
                                 'x If downloading counts as an upload.
                                 'x If preferred compressed (BBS compressed).
                                 'x If virus checked.
                                 '6 If invisible.
                                 '7 If incomplete.
                                 '8 If a user created extract file.
                                 '9 If free only if callers is 9600+ baud.
                                 'rest for the future
  Group AS INTEGER               'still undefined.
END TYPE

'
' FileNameInfo is an internal record used in the FileName(). array which
' represents all active files.  An index.  See "FindF" routine.
'
TYPE FileNameInfo                'Len = 20
  FName AS STRING * 12           'File name, including "." deliminator.
                                 'Left justified.
  FSize AS LONG                  'Size of file in bytes.
  FRec  AS INTEGER               'Record in FILELIST of this file's data.
  Attr  AS INTEGER               '16 bits:
                                 '1 True if deleted.
                                 '2 If free.
                                 'x If downloading counts as an upload.
                                 'x If preferred compressed (BBS compressed).
                                 'x If virus checked.
                                 '6 If invisible.
                                 '7 If incomplete.
                                 '8 If a user created extract file.
                                 'rest for the future
  FArea AS INTEGER
END TYPE

'
' FileInfo is what "FindF" uses.  See the "FindF" routine for more info.
' In the program, this data can be found in the FFile. variable.
'
TYPE FileInfo                    'Len = 29
  FName AS STRING * 12           'File name.
  FSize AS LONG                  'File Size in bytes.
  FDate AS STRING * 9            'File date (sometimes).
END TYPE

'
' MenuTextRecord is the structure used in the MENUTEXT.DAT file.  Since
' the file is designed to be easily edited and read, while at the same
' time being accessable via random access operations, this structure was
' formed.
'
TYPE MenuTextRecord
  Index      AS STRING * 3       'To which menu (BaseIndex) the text is for.
  Filler1    AS STRING * 1       'A single space.
  HotKey     AS STRING * 1       'The hot-key for this menu command.
  Filler2    AS STRING * 1       'A single space.
  NeededSL   AS STRING * 5       'Minimum SL needed for this option
  Filler3    AS STRING * 1       'A single space.
  AnsiToDisp AS STRING * 8       'ANSI screen to show before doing this cmd.
  Filler4    AS STRING * 1       'A single space.
  ShouldDo   AS STRING * 4       'Mapped "what to do". (0-9,A-Z,a-z--any combo)
  Filler5    AS STRING * 1       'A single space.
  SpecialFX  AS STRING * 5       'A color code of what/how to output the text.
                                 '(0-9,A-Z,a-z--any combination)
                                 '1st digit = forground, 2nd = background, 
                                 '3rd = hight & blink and 4&5 = sfx
  Filler6    AS STRING * 1       'A single space.
  TextBody   AS STRING * 4       'Line number in LINES.TXT.
  Filler7    AS STRING * 2       'A "<cr><lf>" (The CR/LF).
END TYPE

'
'Record structure used in the LINKAGES.DAT file
'
TYPE LinkRecord
  UserName  AS STRING * 30
  LinkGroup AS INTEGER
END TYPE



TYPE LevelRecord
  SecLevel   AS INTEGER
  FRatio     AS INTEGER
  BRatio     AS INTEGER
  PCRatio    AS INTEGER
  MinsPerDay AS INTEGER
  StartTime  AS INTEGER
  EndTime    AS INTEGER
  VoteWeight AS INTEGER
END TYPE
                         


TYPE SettingsRecord              'Len = 259
  MaxMessages     AS INTEGER     'Maximum number of messages to keep active.
  MaxLinesInMsg   AS INTEGER     'Maximum lines allowed in a message.
  MaxWidthOfMsg   AS INTEGER     'Maximum chars per msg line.
  NewsWidth       AS INTEGER
  MaxUsers        AS INTEGER     'Maximum number of users to keep active.
  MinPassAllUsers AS INTEGER     'Minimum password length for level 5 users.
  MinPassRegUsers AS INTEGER     'Minimum password length for > level 5.
  LDDelSL         AS INTEGER
  ExchBytes       AS LONG
  ExchMins        AS INTEGER
  FellowSL        AS INTEGER     'NOT NEEDED, ELIMINATE.
  CanVoteSL       AS INTEGER
  MaxPAttempts    AS INTEGER
  MaxLAttempts    AS INTEGER
  TakeOff         AS INTEGER     '2.00 -> 200
  MaxFiles        AS INTEGER     'Maximum number of files to keep active.
  MaxFilesInDir   AS INTEGER     'Maximum number of files to keep active in any dir.
  BufferSize      AS INTEGER     'buffer is made in 4096 increments.
  MinSpace        AS LONG
  MinULSpace      AS LONG
  LDDelSpace      AS LONG
  TargetSpace     AS LONG
  BeSureSpace     AS LONG
  LogoTimeOut     AS INTEGER
  AIHelpSpace     AS LONG
  ResetConnect    AS INTEGER
  ResetNoConnect  AS INTEGER
  CommPort        AS INTEGER
  SLEachOther     AS INTEGER
  TimeOut         AS INTEGER
  AINewUserMsg    AS STRING * 3
  Node            AS INTEGER
  CoSysopSL       AS INTEGER
  StatsSize       AS INTEGER
  RambleAddSL     AS INTEGER
  WorstSL         AS INTEGER
  WorstLogons     AS INTEGER
  LogLeader       AS STRING * 5
  Init2400        AS INTEGER
  Init9600        AS INTEGER
  HiFilePtr       AS LONG
  Sysop           AS STRING * 30
  MassMail        AS INTEGER
  PPRSL           AS INTEGER
  SysopOnlyUL     AS INTEGER
  BiSL            AS INTEGER
  MaxRambles      AS INTEGER
  MaxPosts        AS INTEGER
  Addr            AS LONG
  PRMsgStart      AS STRING * 3
  PRMsgPassed     AS STRING * 3
  PRMsgFailed     AS STRING * 3
  PRMinSL         AS INTEGER
  PRMaxSL         AS INTEGER
  DrDrives        AS STRING * 5
  StartTime       AS STRING * 8
  PrefProt        AS STRING * 1       'NOT NEEDED, ELIMINATE.
  BiDayBaud       AS INTEGER
  NextEvent       AS STRING * 8
  NextEventDay    AS INTEGER
  Key1            AS STRING * 20
  Key2            AS STRING * 20
  Key3            AS STRING * 20
  PRCount         AS INTEGER
  HubAddr         AS LONG
  Phone           AS LONG
  PostRingSL      AS INTEGER
END TYPE
'When alter, search for: filenames$(75)
'as of the .07 release, all of the above settings have been implemented
'except: MaxRambles, MaxPosts, NextEventDay, PRCount



TYPE MessageBaseRecord     'Len = 108
  PostSL     AS INTEGER
  ReadSL     AS INTEGER
  ScanSL     AS INTEGER
  StartTime  AS INTEGER
  EndTime    AS INTEGER
  BufferSize AS INTEGER
  NextNumber AS LONG
  SubType    AS INTEGER                   '16 bits:
                                          '1 true if all messages are from ANON.
                                          '2 true if PRIvate (else PUBlic).
                                          '3 true if NET mail.
                                          '4 true if LOCKed.
                                          '5 true if only sysop can DEL msgs.
                                          '6 true if all messages go to ALL.
                                          '7 true if show "hidden" net info.
                                          'x true if password protected.
                                          '9 true if an EchoMail area.
                                          'rest for the future
  MsgOp      AS STRING * 30
  Title      AS STRING * 60
END TYPE

TYPE FileBaseRecord           'Len = 184
  DLSL       AS INTEGER
  ULSL       AS INTEGER
  ScanSL     AS INTEGER
  StartTime  AS INTEGER
  EndTime    AS INTEGER
  BufferSize AS INTEGER
  Attr       AS INTEGER
  HiFilePtr  AS LONG
  FileOp     AS STRING * 30
  Path       AS STRING * 64
  Title      AS STRING * 72
END TYPE


TYPE SummaryRec
  PagedSysop   AS INTEGER         'Number of times they've tried to page sysop.
  MsgsPosted   AS INTEGER         'Number of public messages posted.
  EMsgsPosted  AS INTEGER         'Number of private messages posted.
  FMsgsPosted  AS INTEGER         'Number of feedback messages posted.
  NetMailSent  AS INTEGER         'Number of NetMail letters sent.
  NetMailRcvd  AS INTEGER         'Number of NetMail letters received.
  Dnlds        AS INTEGER         'Files downloaded.
  DLBytes      AS LONG            'Bytes downloaded.
  MinsDLing    AS INTEGER         'Number of minutes downloading.
  BadDLs       AS INTEGER         'Number of bad DL's.
  Uplds        AS INTEGER         'Files uploaded.
  ULBytes      AS LONG            'Bytes uploaded.
  MinsULing    AS INTEGER         'Number of minutes uploading.
  BadULs       AS INTEGER         'Number of bad UL's.
  Doors        AS INTEGER         'Number of accesses to doors.
  RamblesMade  AS INTEGER
  RamglesAdded AS INTEGER
END TYPE


TYPE LZHHeaderType
  HeaderLength AS STRING * 2         'asci(), as only 1st char is used.
  Method       AS STRING * 5
  StoredSize   AS LONG
  OriginalSize AS LONG
  FileTime     AS INTEGER
  FileDate     AS INTEGER
  Filler1      AS STRING * 2
  NameLength   AS STRING * 1
END TYPE

TYPE ZIPHeaderType
  TestString   AS STRING * 4          '= "PK"Chr$(3)Chr$(4)
  Version      AS INTEGER
  General      AS INTEGER
  Method       AS INTEGER
  FileTime     AS INTEGER
  FileDate     AS INTEGER
  CRC32        AS LONG
  StoredSize   AS LONG
  OriginalSize AS LONG
  NameLength   AS INTEGER
  HeaderLength AS INTEGER
END TYPE

TYPE ARJHeaderType
  Filler1      AS STRING * 2
  HeaderLength AS INTEGER
  Filler3      AS STRING * 5
  Method       AS STRING * 1         'Asci().
  EntryType    AS STRING * 4         'Asci(), as only 1st char is used.
  FileDate     AS INTEGER
  StoredSize   AS LONG
  OriginalSize AS LONG
  CRC32        AS LONG
  Filler2      AS STRING * 6
END TYPE


TYPE RamblingRecord         'Len = 77
  AccessSL    AS INTEGER
  HiFilePtr   AS LONG
  LastDate    AS INTEGER
  Count       AS INTEGER
  Number      AS STRING * 3
  RambleOp    AS STRING * 30
  Title       AS STRING * 34
END TYPE


TYPE QWKType
  Status     AS STRING * 1
  MsgNum     AS STRING * 7
  DateSent   AS STRING * 8
  TimeSent   AS STRING * 5
  MsgTo      AS STRING * 25
  MsgFrom    AS STRING * 25
  MsgSubject AS STRING * 25
  Filler1    AS STRING * 12
  MsgNum2    AS STRING * 8
  NumRecs    AS STRING * 6
  Status2    AS STRING * 1
  IDXNum     AS INTEGER
  Filler2    AS STRING * 3
END TYPE


TYPE FidoPktMessage
  MsgType   AS INTEGER       '= 2
  OrigNode  AS INTEGER
  DestNode  AS INTEGER
  OrigNet   AS INTEGER
  DestNet   AS INTEGER
  Attr      AS INTEGER
  Cost      AS INTEGER
END TYPE


TYPE FidoPktHeader
  OrigNode  AS INTEGER
  DestNode  AS INTEGER
  Year      AS INTEGER
  Month     AS INTEGER
  Day       AS INTEGER
  Hour      AS INTEGER
  Minute    AS INTEGER
  Seconds   AS INTEGER
  Baud      AS INTEGER
  PktType   AS INTEGER      '= 2
  OrigNet   AS INTEGER
  DestNet   AS INTEGER
  ProdCode  AS STRING * 1
  Serial    AS STRING * 1
  Password  AS STRING * 8   'Chr$(0) terminated.
  OrigZone  AS INTEGER
  DestZone  AS INTEGER
  Filler1   AS STRING * 20  'all zero's
END TYPE




TYPE PCBoard14
  BlankScr   AS STRING * 2    '"-1" display on, " 0" display off (blank screen)
  Misc1      AS STRING * 11   '" 0 0 0 -1YA"
  BPSRate    AS STRING * 5    'DTE rate. ("19200" or " 2400")
  Connect    AS STRING * 5    'Caller's connect rate.("LOCAL"/"19200"/" 9600"/" 2400")
  RecNum     AS INTEGER       'User's record number.
  FirstName  AS STRING * 15   'User's first name.
  Password   AS STRING * 12   'User's password.
  LogonMins  AS INTEGER       'Minutes since midnight.
  TimeUsed   AS INTEGER       'Zero.
  LogonTime  AS STRING * 5    'HH:MM of current time.
  MinsAvail  AS INTEGER       'Download/door minutes left today.
  Misc3      AS STRING * 21   'All zero.
  UserName   AS STRING * 25   'User's full name.
  MinsAvail2 AS INTEGER       'Same as MinsAvail.
  Node       AS STRING * 1    'Node number. ("1" to "9")
  Misc4      AS STRING * 9    '"00:00 0-1"
  Misc5      AS LONG          'Zero.
  CommPort   AS STRING * 1    'Comm Port.
  Misc6      AS STRING * 2    'All zero.
END TYPE



TYPE PCBoard12
  BlankScr   AS STRING * 2    '"-1" display on, " 0" display off (blank screen)
  Misc1      AS STRING * 8    '" 0 0 0 0"
  BPSRate    AS STRING * 4    'DTE rate. ("1920" or "2400" or "Loca")
  UserName   AS STRING * 27   'User's full name.
  FirstName  AS STRING * 15   'User's first name.
  Misc2      AS STRING * 2    '"-1"
  Password   AS STRING * 12   'User's password.
  RecNum     AS INTEGER       'User's record number.
  LogonSecs  AS LONG          'Seconds since midnight.
  SecsAvail  AS LONG          'Download/door seconds left.
  LogonSecs2 AS LONG          'Same as LogonSecs.
  LogonTime  AS STRING * 5    'HH:MM of current time.
  Misc3      AS STRING * 36   'All zero.
  Misc4      AS STRING * 3    '"-1A"
END TYPE


TYPE DoorRecord         'len = 244
  StartTime AS INTEGER              'Access allowed start time.
  EndTime   AS INTEGER              'Access allowed end time.
  MaxTime   AS INTEGER             'Absolute maximum time allowed in the
                                   'door, if Download Minutes is less than
                                   'this, then DL minutes is used instead.
  LogType   AS STRING * 1              '"0" to "9" type of logging to do
  MinSpace  AS LONG                '
  UserName  AS STRING * 30         'Door-op--get's 255 SL when exit to door.
  Path      AS STRING * 64
  Execute   AS STRING * 67           'Actual execution line
  Note      AS STRING * 72
END TYPE

TYPE NodeRecord      'LEN = 34
  Addr     AS LONG
  BBSPhone AS LONG
  BBSName  AS STRING * 25
  Flags    AS STRING * 1          '8 bits
                                  'Bit 1 true if addr accepts mail 24 hrs (CM).
                                  'Bit 2 true if addr is a hub (HUB).
END TYPE

TYPE HelloRecord       'Len = 128
  Signal   AS INTEGER
  Version  AS INTEGER
  Product  AS INTEGER
  RevMajor AS INTEGER
  RevMinor AS INTEGER
  FullAddr AS STRING * 60
  Sysop    AS STRING * 20
  Zone     AS INTEGER
  Net      AS INTEGER
  Node     AS INTEGER
  Point    AS INTEGER
  Password AS STRING * 8
  Filler1  AS STRING * 8
  Capable  AS INTEGER
  Filler2  AS STRING * 12
END TYPE


'
'
' Declare our functions and library routines--so that they may be called
' from anywhere.
'
'
' The following routines are in ASSEMBLY.  They are called from each other.
' None are overlay's.
'
DECLARE SUB      Ansi (Inpt$)
DECLARE FUNCTION AscChr$ (BYVAL Inpt%)
DECLARE FUNCTION AscVal% (Inpt$)
DECLARE SUB      BitClear (Inpt%, BYVAL BitNum%)
DECLARE SUB      BitSet (Inpt%, BYVAL BitNum%)
DECLARE FUNCTION BitsShl% (BYVAL Inpt%, BYVAL ShiftLeft%)
DECLARE FUNCTION BitsShr% (BYVAL Inpt%, BYVAL ShiftRight%)
DECLARE FUNCTION BitTest% (BYVAL Inpt%, BYVAL BitNum%)
DECLARE SUB      BitToggle (Inpt%, BYVAL BitNum%)
DECLARE SUB      BlockOut (BYVAL CommPort%, Send$)
DECLARE SUB      BM01 ()
DECLARE SUB      BM02 ()
DECLARE SUB      BM03 ()
DECLARE SUB      BM04 ()
DECLARE SUB      BM05 ()
DECLARE SUB      BM06 ()
DECLARE SUB      BM07 ()
DECLARE SUB      BM08 ()
DECLARE SUB      BM09 ()
DECLARE SUB      BM10 ()
DECLARE FUNCTION Crunch% (Inpt$)
DECLARE SUB      CursorOff ()
DECLARE SUB      CursorOn ()
DECLARE SUB      DateDMY (BYVAL IntegerDate%, Day%, Month%, Year%)
DECLARE FUNCTION DateInt% (BYVAL Day%, BYVAL Month%, BYVAL Year%)
DECLARE SUB      Delay ()
DECLARE SUB      DelayTiny (BYVAL Amount%)
DECLARE SUB      DirUse (Inpt$)
DECLARE FUNCTION DrCurrent% ()
DECLARE FUNCTION DriveSpc& (Drive$)
DECLARE SUB      FileClose (BYVAL Handle%)
DECLARE SUB      FileGetLoc (BYVAL Handle%, BYVAL Location&, BYVAL Size%, x AS ANY)
DECLARE SUB      FileGetRec (BYVAL Handle%, BYVAL RecNum%, BYVAL Size%, x AS ANY)
DECLARE SUB      FileGetSLoc (BYVAL Handle%, BYVAL Location&, Inpt$)
DECLARE FUNCTION FileLof& (BYVAL Handle%, BYVAL Divisor%)
DECLARE FUNCTION FileOpen% (FileName$)
DECLARE SUB      FilePutLoc (BYVAL Handle%, BYVAL Location&, BYVAL Size%, x AS ANY)
DECLARE SUB      FilePutRec (BYVAL Handle%, BYVAL RecNum%, BYVAL Size%, x AS ANY)
DECLARE SUB      FilePutSEnd (BYVAL Handle%, Inpt$)
DECLARE SUB      FilePutSLoc (BYVAL Handle%, BYVAL Location&, Outpt$)
DECLARE SUB      FileSort (BYVAL Handle%, BYVAL RecSize%)
DECLARE FUNCTION FindF% (File$, Typ AS FileInfo)
DECLARE FUNCTION FosIntAX% (BYVAL Port%, BYVAL AX%)
DECLARE FUNCTION GetRndNum% (BYVAL Range%)
DECLARE SUB      IntMax (Value1%, BYVAL Value2%)
DECLARE FUNCTION IntToDate3$ (BYVAL DateValue%)
DECLARE FUNCTION KBIn% ()
DECLARE FUNCTION Make8Bit$ (Inpt$, BYVAL RecNum%, BYVAL Size%)
DECLARE FUNCTION MenuCommand% (Key1$, Key2$, Key3$, Inpt$)
DECLARE FUNCTION Power2% (BYVAL RaiseTo%)
DECLARE SUB      SameDate (BYVAL HandleOrig%, BYVAL HandleTo%)
DECLARE FUNCTION StrCkSum% (Inpt$)
DECLARE FUNCTION StripLen% (Inpt$)
DECLARE FUNCTION StrSrch% (BYVAL Start%, Inpt$, Find$)
DECLARE FUNCTION StrSrch1% (Inpt$, BYVAL Find%)
DECLARE FUNCTION StrSrchR% (Inpt$, BYVAL Ascii%)
DECLARE SUB      StrXlate (Inpt$, DefString$)
DECLARE FUNCTION TimeToInt% (TimeToUse$)
DECLARE FUNCTION TodayIs% ()
DECLARE SUB      UnSqDo (Inpt$, SqString$)
DECLARE FUNCTION UnSqPlus% (Inpt$)
DECLARE SUB      WordsCase (Inpt$)
DECLARE FUNCTION WordsCnt% (Inpt$)
DECLARE FUNCTION WordsGet$ (Inpt$, BYVAL FindNum%, Start%)
'
'
' The following routines are in BASIC1.  They are called from each other.  None
' are overlay's.
'
DECLARE SUB      AddAMessage (Inform%)
DECLARE FUNCTION AddrToInt$ (Address&, Zone%, Net%, Node%)
DECLARE SUB      AdjustProtocol (Protocol$)
DECLARE SUB      AnsiProcessor (FullInpt$, PlanOutpt$, Inpt$, Position%)
DECLARE SUB      AnsiTT ()
DECLARE FUNCTION AttrToInt% (Inpt$)
DECLARE SUB      AutoLogoff ()
DECLARE FUNCTION BiSearch% (DoWhat%, Find%, Find$)
DECLARE SUB      BuildMsgPtr ()
DECLARE SUB      Censor (LastPos%, DoWhat%, Inpt$)
DECLARE SUB      Colorize (Inpt$)
DECLARE FUNCTION Commas$ (Inpt&)
DECLARE FUNCTION CommIn% (DoWhat%)
DECLARE SUB      CommOut (Send$)
DECLARE SUB      ComputerSend (ToWhom$)
DECLARE SUB      CopyFile (DoWhat%, OrigFile$, DupFile$)
DECLARE SUB      CreateFileStuff (DoWhat%, AttrToUse%, LDCountToUse%, Handle%)
DECLARE SUB      CRsToSpaces ()
DECLARE FUNCTION DaysSince& (IntDate%)
DECLARE SUB      Dispatcher ()
DECLARE SUB      DispBlockText (BlockNum%, Quit$)
DECLARE SUB      DispCRLF ()
DECLARE SUB      DispDescLine (Which%, Quit$)
DECLARE SUB      DispFile (File$, Quit$)
DECLARE SUB      DisplayNews ()
DECLARE SUB      DispMessage (RecNum&, DoWhat%, ExitKeys$)
DECLARE SUB      DispRequests ()
DECLARE SUB      DoEvents ()
DECLARE SUB      DoEvents1 (StartTime$, EndTime$, DayOfWeek%)
DECLARE SUB      DoEvents2 (StartTime$, DayOfWeek%)
DECLARE SUB      Download ()
DECLARE FUNCTION ElapsedTime% (StartTime$, Seconds%)
DECLARE SUB      EnterMsg (ExitFlag%, Reply%, WhoTo$, Subject$)
DECLARE SUB      EnterMsg3 (i%)
DECLARE SUB      ExpandFileMsgs ()
DECLARE FUNCTION ExpandFileName$ (Inpt$)
DECLARE SUB      ExpandStr (Inpt$)
DECLARE FUNCTION FileGetBlock$ (File%, Position&, FileLength&)
DECLARE FUNCTION FileGetLine$ (File%, Position&)
DECLARE FUNCTION FileGetLineR$ (File%, Position&)
DECLARE SUB      FindMsgLine (LineNum%, Length%, DoWhat%, Outpt$, Position%, LastLine%)
DECLARE SUB      ForeignChar (Inpt$, Location%)
DECLARE FUNCTION Form$ (DoWhat%, Inpt$)
DECLARE FUNCTION Form1$ (DoWhat%, Inpt$)
DECLARE FUNCTION Form2$ (Size%, Inpt&)
DECLARE FUNCTION Form3$ (Inpt%)
DECLARE FUNCTION Form4$ (DoWhat%, WithWhat%)
DECLARE SUB      FormLine (DoWhich%)
DECLARE SUB      FWorkSort (Max%)
DECLARE SUB      GetAVote ()
DECLARE FUNCTION GetBlock$ (BlockNum%)
DECLARE FUNCTION GetLine$ (Find%)
DECLARE SUB      GetDesc (DoWhat%, DLine1$, DLine2$)
DECLARE SUB      GetFileName (Outpt$, Which%)
DECLARE SUB      GetMessageText (LineNum%)
DECLARE SUB      GetNumPlusTT (ExitKeys$)
DECLARE SUB      GetPhoneNumber (NumberType%)
DECLARE SUB      GetSLRange (SLStart%, SLEnd%)
DECLARE SUB      GetSubject ()
DECLARE SUB      GetUserNameTT (Outpt$, Which%)
DECLARE FUNCTION GetYNTT% ()
DECLARE FUNCTION GifInfo$ (Filename$)
DECLARE SUB      GiveCredit (OldDesc$, DoWhat%)
DECLARE SUB      GrammarCk (DoWhat%, Inpt$)
DECLARE SUB      HangUp ()
DECLARE SUB      Inform ()
DECLARE FUNCTION IntToAttr$ (Outpt%)
DECLARE FUNCTION IntToPhone$ (PhoneNum&)
DECLARE SUB      KillFile (FileName$)
DECLARE FUNCTION LineEditTT$ (Size%)
DECLARE SUB      ListDir (DoWhat%)
DECLARE SUB      ListDirs (DoWhat%)
DECLARE SUB      ListDirs2 (DoWhat1%, DoWhat2%)
DECLARE SUB      LogTT ()
DECLARE SUB      MainLoop (DoWhat%)
DECLARE FUNCTION MappedSL% (SLValue%)
DECLARE SUB      MenuSystemTT ()
DECLARE FUNCTION NCR$ (Inpt$)
DECLARE SUB      NetLogTT ()
DECLARE SUB      NetMailInBoundHandler ()
DECLARE SUB      NetSendContacter (DoWhat%, NetAddr&, NetPhone$)
DECLARE FUNCTION NoCarrier% ()
DECLARE SUB      OfferAreas (DoWhat%)
DECLARE SUB      Paused ()
DECLARE FUNCTION PercentCalc$ (Total&, Partial&)
DECLARE SUB      PointShoot (DoWhat%)
DECLARE SUB      PurgeComIO (CommPort%)
DECLARE SUB      QuoteTheMessage ()
DECLARE SUB      ReadMessages (DoWhat%)
DECLARE SUB      RemoveAMessage (Which%, Handle%)
DECLARE SUB      RemoveFile (FileName$)
DECLARE SUB      RemoveReview (FileName$, Showing%)
DECLARE SUB      ReturnMsgInfo (First%, Last%, FirstNew%, FirstID%, Total%, FirstTo%)
DECLARE FUNCTION RightTime$ (TimeToUse$)
DECLARE SUB      SaveIndices ()
DECLARE SUB      SendTT ()
DECLARE SUB      ShellDos (WhichDir%, CmdToDo$)
DECLARE SUB      ShowTheGauge (Total&, Partial&)
DECLARE FUNCTION Sq$ (Inpt$)
DECLARE SUB      StripExtras ()
DECLARE FUNCTION StripLeft$ (Inpt$, Length%)
DECLARE FUNCTION StripRight$ (Inpt$, Length%)
DECLARE SUB      SysopLine (Row%)
DECLARE SUB      TGet (ValidKeys$)
DECLARE SUB      UnCompressWordRec (RecNum%, Find$)
DECLARE FUNCTION UnSq$ (Inpt$)
DECLARE SUB      Upload (DoWhat%)
DECLARE FUNCTION Val2& (Inpt$)
DECLARE SUB      Welcome ()
DECLARE SUB      WFC (DoWhat%)
DECLARE SUB      Wipe (NumToWipe%)
'
'
' The following routines are in BASIC2.  They do not call each other.  They
' are also all overlays, or parts of overlays.
'
DECLARE SUB      AddARec (BlockNum%, LenSpecs$, OrigRec$, RecNum%, Inpt$, Handle%)
DECLARE FUNCTION AddEchoMailToPacket% (i%,i0%,i1%)
DECLARE FUNCTION AddNetMailToPacket% (i%,i0%,i1%,i2%,i&)
DECLARE SUB      AddRequest ()
DECLARE FUNCTION Addressees% (i%,i0%)
DECLARE SUB      AddReview ()
DECLARE SUB      AIHelpWanted ()
DECLARE SUB      AlterFilePtr ()
DECLARE SUB      AlterLD ()
DECLARE SUB      AlterSettings ()
DECLARE SUB      AlterTheFilesData ()
DECLARE SUB      AlterTheMessagesData (WhichMessage%)
DECLARE SUB      AlterTheUsersData ()
DECLARE SUB      Apply ()
DECLARE SUB      ArchiveFileInfo (ArcType%, FilePos&, Member$, Original&, Stored&, ArcDate%, Method$, Handle%)
DECLARE SUB      Archiver (FileName$)
DECLARE SUB      BBSReview ()
DECLARE SUB      BootStuff (DoWhat%)
DECLARE SUB      BootUpStatus (Which%)
DECLARE SUB      CallersLog (DoWhat%)
DECLARE SUB      Chat ()
DECLARE SUB      CommProg (Lng&,Stng$)
DECLARE SUB      CreateNodeList ()
DECLARE SUB      DataBaser ()
DECLARE SUB      DeleteARec (BlockNum%, RecNum%, Handle%)
DECLARE SUB      DLPotential ()
DECLARE SUB      DoAGrammarCheck (ExitKeys$)
DECLARE SUB      DoorSystem ()
DECLARE SUB      DoorSystemExitTT (Handle%)
DECLARE SUB      DoorSystemReturn (Which%)
DECLARE SUB      EnterMsgHeader (x%, y%, Import$, MSGID$)
DECLARE SUB      DescImport ()
DECLARE SUB      DirAnyWhere ()
DECLARE SUB      DirectryStart (DBNum$)
DECLARE SUB      DirectryView ()
DECLARE SUB      DispExpand (Specs$, Outpt$, Outpt%, RecNum%)
DECLARE SUB      DisplayRec (RecNum%, RecField$, PosInFile&, Lengths$, Rec$, Handle1%, Handle2%)
DECLARE SUB      EditSentMessage (MsgLoc%, Handle%)
DECLARE SUB      Exchange ()
DECLARE SUB      ExtractFiles (FileName$, ArcType%)
DECLARE SUB      ForwardNoteAdd (Which%, DoWhat%, Handle%)
DECLARE SUB      GetCityState ()
DECLARE SUB      GetKeyRec (RecNum%, RecField$, Handle%)
DECLARE FUNCTION IntToDate2$ (Inpt%)
DECLARE SUB      GetProtocol ()
DECLARE SUB      Hourly (OutputType%)
DECLARE SUB      ImportFidoPacket (FileName$)
DECLARE SUB      Initialize ()
DECLARE SUB      InitNewUser ()
DECLARE SUB      DoAFreeDownload (FileName$)
DECLARE SUB      KillAFile ()
DECLARE SUB      LifeDeath ()
DECLARE SUB      ListArrays ()
DECLARE SUB      ListMsgs ()
DECLARE SUB      ListRecs (Handle%)
DECLARE SUB      ListUsers (DoWhat%)
DECLARE SUB      LogOut ()
DECLARE SUB      MainLoop2 (i%,i0%,i1%)
DECLARE SUB      MakeNews ()
DECLARE SUB      MassMail ()
DECLARE SUB      MNxDisplays ()
DECLARE SUB      MoveDirectory (i&,i%,i0&)
DECLARE SUB      MsgBaseLocker (DoWhat%)
DECLARE SUB      NetMailOutBoundHandler (i%,i$)
DECLARE FUNCTION NewFidoPacket% (i&,i$)
DECLARE SUB      NewRambleRead (RambleNum%, Handle%)
DECLARE SUB      NewStuff ()
DECLARE FUNCTION PacketForHub% (i$)
DECLARE FUNCTION PacketForIndividual% (i%,i&,i$)
DECLARE SUB      PackTheDataFiles (DoWhich%)
DECLARE SUB      PeerReview ()
DECLARE SUB      Penalize ()
DECLARE SUB      POLine (LineNum%, Size%, Leader$, Max%, Handle%)
DECLARE SUB      POMessages ()
DECLARE SUB      PortDebugger ()
DECLARE SUB      ProcessLog (DoWhat%, Desc$, ToUserName$, StTime$, Protocol$)
DECLARE SUB      ProcessNetPointers (i$)
DECLARE SUB      Profile (MsgInfo$)
DECLARE SUB      ProfileMsgs (MsgInfo$, Who%)
DECLARE SUB      ProfileSLs (Who%)
DECLARE SUB      Questionaire ()
DECLARE SUB      Quote ()
DECLARE SUB      RaiseMessages ()
DECLARE SUB      RaiseUsers ()
DECLARE SUB      Login (Status%)
DECLARE SUB      Ramblings ()
DECLARE FUNCTION RecFieldLen% (FieldNum%, DoWhat%)
DECLARE SUB      ReduceCounts ()
DECLARE SUB      ReInit ()
DECLARE SUB      Reminder ()
DECLARE SUB      RemoveALine ()
DECLARE SUB      RingBackVerify ()
DECLARE SUB      GetPassword (DoWhat%)
DECLARE SUB      ResetVote ()
DECLARE SUB      SaveLines (i%,i$)
DECLARE SUB      SaveMessageFile (DoWhat%)
DECLARE SUB      SearchFile (Result%)
DECLARE SUB      SetAllLastReadsHigh ()
DECLARE SUB      ShowPRFile (i%,i0%,i$)
DECLARE SUB      SkillExchange ()
DECLARE SUB      StartUp ()
DECLARE SUB      StatsCalc ()
DECLARE SUB      StatsDisp ()
DECLARE SUB      SysopTransfer ()
DECLARE SUB      Toggle (DoWhat%)
DECLARE SUB      TypeFile ()
DECLARE SUB      UserMsgAreasDef ()
DECLARE SUB      UnLockedList ()
DECLARE SUB      Upload2 (i%,i$,i0%,i0$,i11$,i1$,i2$)
DECLARE SUB      ViewContents (FileName$, ArcType%)
DECLARE SUB      Vote (Question%)
DECLARE SUB      VoteSummary ()





DECLARE FUNCTION AnsiLocStr$ (p1%,p2%)
DECLARE FUNCTION NodeListPhoneSearch& (p$)
DECLARE FUNCTION FidoForm$ (i%,i1%,i2%)
DECLARE FUNCTION MakePathName$ (i&,i%)
DECLARE FUNCTION DateToInt% (Inpt$)
DECLARE FUNCTION CanDL& ()
DECLARE FUNCTION StrToAddr& (st$)
DECLARE FUNCTION IntToTime$ (byval inttime%)
DECLARE SUB      DirCreate (st$)
DECLARE SUB DirDelete (st$)
DECLARE SUB Flush (BYVAL Handle%)
DECLARE FUNCTION GetFilePassword% (i%)
DECLARE FUNCTION KwazyColor$ (i%,i0%)
DECLARE FUNCTION FileGetILoc% (Handle%,Position&)
DECLARE FUNCTION FileGetLLoc& (Handle%,Position&)
DECLARE FUNCTION StripAnsi$ (st$)
DECLARE FUNCTION FAccessAllowed% (i%)
DECLARE FUNCTION MAccessAllowed% (i%)
DECLARE FUNCTION DLTime% ()


'
' Make many variables global.
'
COMMON SHARED _
  C0$, C1$, C2$, C3$, C4$, C7$, C8$, C10$, C13$, C27$, C32$, Null$, C1310$,  _
  AlphaTable$, HighFilter$, HiStrip$, _
  TGot$, TT$, MessageBody$, ProtocolDn$, ProtocolUp$, _
  Connect$, LogonTime$, SqString$, SysopNote$, UserMsgInfo$, _
  ActiveMessages, BasesSize, DirsSize, LevelsSize, _
  NonStop, LESpecial, BaseIndex, TGot, TT, TT&, DoNext, _
  UserSL, MsgColor, CommPort, LogonDate, ConnectCPS, FileIndex, _
  ValidChoice$(), Work(), SWork$(), Short$(), _
  FileNames$(), BlockText&(), Paths$(), Handle(), Toggles(), _
  BlockText2() AS STRING * 3, HelpText&(), Context, _
  FWork() AS FileInfo, FileBases() AS FileBaseRecord, _
  MsgBases() AS MessageBaseRecord, MsgPtr() AS MessageInfo, _
  Levels() AS LevelRecord, _
  UserIDX AS UsersNameInfo, FileIDX AS FileNameInfo, MessageIDX AS MessageInfo, _
  Door AS DoorRecord, User AS UserRecord, AnyUser AS UserRecord, _
  FFile AS FileInfo, FileList AS FileListRecord, Message AS MessageRecord, _
  Settings AS SettingsRecord, LinkMember AS LinkRecord, _
  Menu AS MenuTextRecord, LZHInfo AS LZHHeaderType, ZIPInfo AS ZIPHeaderType, _
  ARJInfo AS ARJHeaderType, Ramble as RamblingRecord, _
  SumLog AS SummaryRec, QWKRec AS QWKType, _
  PCB14 AS PCBoard14, PCB12 AS PCBoard12, _
  FidoMsg AS FidoPktMessage, FidoPkt AS FidoPktHeader, Node AS NodeRecord



'NOTE:
'  Handle(1) = Session trap log file.
'  Handle(2) = Chat trap log file.
'  Handle(3) = MESSAGES.
'  Handle(6) = LINES.xxx

'  Handle(10) = Words0.dat
'  Handle(11) = Words1.dat
'  Handle(12) = Words2.dat
'  Handle(13) = Words3.dat
'  Handle(14) = Words4.dat
'  Handle(15) = Words5.dat
'  Handle(16) = Words6.dat
'  Handle(17) = Words7.dat
'  Handle(21) = USERS.IDX
'  Handle(22) = FILES.IDX

