; Copyright (c) 1991-1992, John David Rohner.  All rights reserved.

;
; This routine will return the status of a bit of a given integer.
;
; Usage:  Result% = BitTest (Input%, BitNum%)
; Declare: DECLARE FUNCTION BitTest% (BYVAL Input%, BYVAL BitNum%)
;
; Where Input% is the integer containing our flags, BitNum% is the bit
; number to test, and Result% contains a zero if the flag wasn't set, or a
; -1 (true) if the flag was set.
;
; Bit numbers range from 1 to 16.  Actual form: 16 15 14 ... 4 3 2 1 which
; corresponds to 64k 32k 16k ... 8 4 2 1.
;
; A zero or negative BitNum% will return 0 (false).  No error checking is done
; for numbers greater than 16, so only send 0, 1 to 16 for the BitNum%.
;

.Model Medium, Basic
.Code

            PUBLIC  BitTest           ;Make this routine available to LINK.

BitTest     proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp
            xor     ax,ax             ;Start with a zero.
            mov     cx,[bp + 06]      ;Get size, all we really want is CL.
            dec     cx                ;Real world 1-16 to our 0-15.
            js      D1                ;They sent us a zero or negative.
            mov     al,01             ;We just shift over a bit.
            shl     ax,cl             ;Do shift for size sent.
            mov     bx,[bp + 08]      ;Get integer to test.
            and     ax,bx             ;Compare the two.
            jz      Done              ;Zero, bit not set, so exit.
        D1: mov     ax,0FFFFH         ;Bit is set, exit with a -1 (true).
      Done: pop     bp
            ret     4                 ;Pop-return past our input parameters.

BitTest     endp                      ;End of routine.

End


