; Copyright (c) 1991-1992, John David Rohner.  All rights reserved.

;
; This routine will send a string out the comm port using the fossil.
;
; Usage:  CALL BlockOut(CommPort%,Send$)
; Declare: DECLARE SUB BlockOut (BYVAL CommPort%, Send$)
;
; Where CommPort% is the port number to send to (1...n) and Send$ is the
; string to output.
;
; The equivalent Basic code:
;  SUB BlockOut (K0,K$)
;  IF K0 = 0 THEN EXIT SUB
;  InRegX.AX = &H1900
;  InRegX.DX = K0 - 1
;  InRegX.CX = LEN(K$)
;  InRegX.ES = VARSEG(K$)
;  InRegX.DI = SADD(K$)
;  CALL InterruptX(&H14,InRegX,OutRegX)
;  END SUB
;

.Model Medium, Basic
.Code
 
            PUBLIC  BlockOut          ;Make this routine available to LINK.

BlockOut    proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp

            mov     dx,[bp + 08]      ;Get our Port%.
            or      dx,dx             ;They sent us a zero,
            jz      Done              ;so exit.
            dec     dx                ;The fossil wants 0 to n ports.
            mov     bx,[bp + 06]      ;Get descriptor of the string.
            mov     cx,[bx]           ;Move size of string into CX.
            jcxz    Done              ;If a null string, then exit.
            mov     di,[bx + 02]      ;String location -> DI.
            push    ds                ;Want ES to equal DS.
            pop     es                ;ES now points to data segment.
            mov     ah,19H            ;Fossil subfunction 19H.
            int     14H               ;Call the fossil.

     Done:  pop     bp
            ret     4                 ;Pop-return past our input parameters.
 
BlockOut    endp                      ;End of routine.

End





