' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine handles port and console key input.  Doing
        ' analsis for special when-caller-on keys, and logging to a
        ' file if desired.
        '
        ' p  -2 when you don't want to use the function keys below
        '       (example, WFC has its own keys).
        '    -3 when you only want 'normal' keystrokes allowed from
        '       the console.  A -3, and a check for -1 upon return,
        '       effectively shuts down the console keyboard for this
        '       node.
        '    -4 for 'like 0 but with <ctrl>Fx keys'
        '    -5 for 'like -2 but with <ctrl>Fx keys'
        '    returns -1 if from KB, 0 if from Port or none.
        '
        ' returns  -1          for no input
        '          0 - 255     for ASCII input
        '          <> -1, <> 0 for keyboard extended key input
        '
        ' For input from port, the values are -1, 0 to 255.  Never
        ' anything else, so 'large' values can be assumed to have come
        ' from the KB.
        '
        ' When no user is logged in, the arrow keys act like normal
        ' arrow keys.
        '
        ' Date last checked for perfection: Sep 18 1992
        '
FUNCTION CommIn% (p)

  op = p
  IF NOT BitTest(Toggles(2),11) THEN p = -3
  '
  ' Check the keyboard.
  '
  K = KBIn
  IF K = 0 THEN K = -1
  '
  ' <esc><esc> to logoff user handling.  Identical to <alt>h, but a lot more
  ' easier and fun.
  '
  IF K = 27 AND (p > -2 OR p = -4) _
     THEN DO : K = KBIn : _
          LOOP UNTIL K <> 0 OR NoCarrier : _
          IF K = 27 _
             THEN K = 8960 _
             ELSE IF K = 99 THEN K = 32766 _
                            ELSE IF K = 49 THEN K = 32765 _
                                           ELSE IF K = 50 THEN K = 32764 _
                                                          ELSE K = -1
  SELECT CASE p
    CASE -4, -5
         K0 = 0
         SELECT CASE K
           CASE 24064 : K0 = 851                '<ctrl>F1 sysop defined.
           CASE 24320 : K0 = 852                '<ctrl>F2 sysop defined.
           CASE 24576 : K0 = 853                '<ctrl>F3 sysop defined.
           CASE 24832 : K0 = 854                '<ctrl>F4 sysop defined.
           CASE 25088 : K0 = 855                '<ctrl>F5 sysop defined.
           CASE 25344 : K0 = 856                '<ctrl>F6 sysop defined.
           CASE 25600 : K0 = 857                '<ctrl>F7 sysop defined.
           CASE 25856 : K0 = 858                '<ctrl>F8 sysop defined.
           CASE 26112 : K0 = 859                '<ctrl>F9 sysop defined.
           CASE 26368 : K0 = 860                '<ctrl>F10 sysop defined.
         END SELECT
         IF K0 <> 0 THEN CommIn = K : _
                         TT$ = Short$(K0) : _
                         EXIT FUNCTION
  END SELECT
  IF p = -4 THEN p = 0
  IF p = -5 THEN p = -2
  SELECT CASE p
    CASE -3 : IF (K < 0 OR K > 255) AND K <> 17152 THEN K = -1
    CASE IS > -2
         K7 = 0
         SELECT CASE K
           CASE 0 TO 255
           CASE 32764, 32765, 32766             'For when in Chat.
           CASE 18432, 20480, 19712, 19200
                SELECT CASE ConnectCPS
                  CASE 11500 : K7 = 1       'If at console.
                  CASE ELSE
                       SELECT CASE K
                         CASE 18432                 'Up arrow: +5 mins to user.
                              IF CommPort <> 0 _
                                 THEN User.Elapsed = User.Elapsed - 5 : _
                                      SysopNote$ = Short$(600)
                         CASE 20480               'Down arrow: -5 mins to user.
                              IF CommPort <> 0 _
                                 THEN User.Elapsed = User.Elapsed + 5 : _
                                      SysopNote$ = Short$(601)
                         CASE 19712                 'Right arrow: +1 SL
                              IF CommPort <> 0 _
                                 THEN IF UserSL <> LevelsSize _
                                         THEN UserSL = UserSL + 1 : _
                                              SysopNote$ = Short$(607) _
                                         ELSE SysopNote$ = Short$(608)
                         CASE 19200                  'Left arrow: -1 SL
                              IF CommPort <> 0 _
                                 THEN IF UserSL <> 1 _
                                         THEN UserSL = UserSL - 1 : _
                                              SysopNote$ = Short$(610) _
                                         ELSE SysopNote$ = Short$(655)
                       END SELECT
                END SELECT
           CASE 7936                            '<alt>s  shell to DOS.
                TT$ = Short$(577) + Form$(20,Settings.Sysop) + GetLine$(174)
                CALL CommOut(TT$)
                CALL AnsiTT
                CALL ShellDos(1,Null$)
                TT$ = Short$(578) + GetLine$(175)
                CALL CommOut(TT$)
                CALL AnsiTT
           CASE 8960                            '<alt>h  hang up caller.
                CALL Quote
                CALL HangUp
           CASE 11776                           '<alt>c  chat with caller.
                TT = 364
                CALL SendTT
                IF BitTest(Toggles(1),5) THEN TT = 374 : _
                                              CALL AnsiTT
                IF BitTest(User.Attr,5) THEN TT = 601 : _
                                             CALL AnsiTT
                CALL DispCRLF
                IF BitTest(Toggles(1),5) OR BitTest(User.Attr,5) _
                   THEN IF DriveSpc&(FileNames$(52)) > Settings.MinSpace _
                           THEN Handle(2) = FileOpen(FileNames$(52)) : _
                                K$ = C1310$ + Short$(581) + _
                                     IntToDate3$(LogonDate) + Short$(137) + _
                                     TIME$ + Short$(585) + _
                                     NCR$(User.UserName) + Short$(591) + _
                                     C1310$ : _
                                CALL FilePutSEnd(Handle(2),K$)
                CALL Chat1
                IF BitTest(Toggles(1),5) OR BitTest(User.Attr,5) _
                   THEN CALL FileClose(Handle(2))
                SysopNote$ = Null$
                K = 13
           CASE 12288                           '<alt>b  beep the caller.
                TT$ = C7$ + C7$
                CALL CommOut(TT$)
                CALL AnsiTT
           CASE 18688                           '<pgup>  send text file.
                KK = CommPort
                CommPort = 0
                TT = 72
                CALL AnsiTT
                K0$ = Null$
                DO
                  K = KBIn
                  IF K > 0 AND K <> 13 AND K <> 8 THEN K0$ = K0$ + AscChr$(K) : _
                                                       CALL Ansi(AscChr$(K))
                  IF K = 8 THEN CALL Wipe(1) : _
                                K0$ = LEFT$(K0$,LEN(K0$) - 1)
                LOOP UNTIL K = 13
                CommPort = KK
                IF K0$ <> Null$ THEN CALL DispFile(K0$,Null$)
           CASE 20736, 15104                     '<pgdn> or <f1>  trap all toggle.
                CALL BitToggle(Toggles(2),8)
                IF BitTest(Toggles(2),8) AND NOT BitTest(User.Attr,6) _
                   THEN TT = 856 : _
                        Handle(1) = FileOpen(FileNames$(51)) _
                   ELSE TT = 857 : _
                        CALL FileClose(Handle(1)) : _
                        CALL BitClear(User.Attr,6)
                CALL AnsiTT
           CASE 15360                           'F2  trap chat toggle.
                CALL BitToggle(Toggles(1),5)
                IF BitTest(Toggles(1),5) AND NOT BitTest(User.Attr,5) _
                   THEN TT = 639 _
                   ELSE TT = 688 : _
                        CALL BitClear(User.Attr,5)
                CALL AnsiTT
           CASE 15616                           'F3  sysop chat avail. toggle.
                CALL BitToggle(Toggles(1),4)
           CASE 16128                           'F5  sysop on next toggle.
                CALL BitToggle(Toggles(2),3)
           CASE 16384                           'F6  blank the screen toggle.
                TT$ = Short$(67)
                CALL AnsiTT
                CALL BitToggle(Toggles(2),2)
                CALL AnsiTT
           CASE 11520                           '<alt>x immediate exit to DOS.
                IF CommPort = 0 THEN CALL ShellDos(9,Null$)
           CASE 5632                             '<alt>u  user maintenance
                K = CommPort
                CommPort = 0
                CALL AlterTheUsersData
                CommPort = K
                K = 13
           CASE 29440                            '<ctrl><left>   ''
                K = 27
         END SELECT
         IF K > 255 AND K < 32764 AND K7 = 0 THEN K = -1

  END SELECT
  '
  ' Check the port.  &H2000 returns -1 for an empty port, and 0 when CommPort = 0.
  '
  p = 0
  IF K = -1 AND CommPort > 0 THEN K = FosIntAX(CommPort,&H2000) _
                             ELSE p = -1
  CommIn = K
  IF K = 174 THEN IF op <> -2 AND RTRIM$(User.UserName) = Null$ _
                     THEN CALL NetMailInBoundHandler
  IF K >= 0 AND K < 256 AND BitTest(Toggles(2),8) _
     THEN IF DriveSpc&(FileNames$(51)) > Settings.MinSpace _
             THEN CALL FilePutSEnd(Handle(1),AscChr$(K))

END FUNCTION
        '
        '* * * *

