'
' In all cases, Handle or Alias fields are ignored in favor of Real Name
' fields.
'
' Not converted: toggles/settings (ansi/width/protocol/etc.)
' (users)        attribute flags (deleted/etc.)
'                high msg ptr's (last message read)
'                time/dates (last on/etc.)
'                phone numbers (home/bbs/etc.)
'                time usage (used today, avail today, etc.)
'                msg/conference/file area information
'                hack attempts
'                temporary stuff (DL's today/etc.)
'                address or zip code fields (only city & state)
'
' Not converted: time/date fields
' (messages)     attribute fields
'                cost field



DEFINT A-Z
'
'
' Create the data structures.
'
'
' UserRecord is the record structure of the USERS file.
'
TYPE UserRecord                  'Len = 384
  UserName    AS STRING * 30     'Uppercase only.
  Password    AS STRING * 15     'Uppercase only.
  CityState   AS STRING * 30     'Uppercase only.
  HomePhone   AS LONG            'See "ModHomePhone"
  BBSPhone    AS LONG            'See "ModBBSPhone"
  BirthDate   AS INTEGER         'Birthdate of user.
                                 'Date stored in integer form.
  SecLevel    AS INTEGER         '-32,767 to 32,767 security level.
  FirstCall   AS INTEGER         'First date user called.
                                 'Date stored in integer form.
  Attr        AS INTEGER         '16 bits:
                                 '1 True if user is deleted.
                                 '2 True if user is an AI.
                                 'x True if user cannot be auto-deleted.
                                 'x True if user wants full screen editor.
                                 '5 True if should trap the user's chat.
                                 '6 True if should trap the user's sessions.
                                 'x True if should show SysopNote to user
                                 '  at their next (and only next) logon.
                                 'x True if user can't send net mail.
                                 'x True if user doesn't get UL credit for 
                                 '  .GIF's/.FLI's/.GL's/.MOD's.
                                 'rest for the future.
  Toggles     AS INTEGER         '16 bits:
                                 '1 True if should beep after transfers.
                                 '2 True if show Enter Msg line numbers.
                                 '3 True if show Read Msg total lines.
                                 '4 True if should "turbo" out the msgs.
                                 '5 True if user is a male.
                                 'rest for the future.
  Protocol    AS STRING * 1      'User's procotol default.
  Votes       AS STRING * 100    '=100 Voting questions (Byte answers).
  SubsStart   AS INTEGER         'Subscription start date.
                                 'Date stored in integer form.
  SubsEnd     AS INTEGER         'Subscription end date.
                                 'Date stored in integer form.
  SubsType    AS STRING * 1      'Subscription type.
  Monies      AS LONG            '$0.00 to $21000000.00 Current monies.
                                 'Use a shifted decimal point.
  TotalMonies AS LONG            '$0.00 to $21000000.00 Total monies ever sent.
                                 'Use a shifted decimal point.
  LastDateOn  AS INTEGER         'Last time user called.
                                 'Date stored in integer form.
  PswdChange  AS STRING * 1      'Counter towards user change password order.
                                 '0 to 255 ascii value.
  AlterDate   AS INTEGER         'The last date in which they exercised
                                 'their Life & Death options.
                                 'Date stored in integer form.
  JDRVerDL    AS INTEGER         '= mmyy in JDR_mmyy versions.
                                 'The last version of JDR_mmyy that they
                                 'downloaded.
  BullsRead   AS STRING * 8      'Each bit = toggle for 1 bulletin read.
  Connect     AS STRING * 1      'Last baud user connected at.
  HiFilePtr   AS LONG            '0 to 2,100,000,000
                                 'What the "HiFilePtr" number was at the last
                                 'time they called, any stuff with
                                 'numbers higher is new to them.
  HighestPtr  AS LONG            '0 to 2,100,000,000 Highest HileFilePtr they
                                 'know about.  HiFilePtr is call
                                 'dependant--it's updated after they log out,
                                 'this isn't--this is a security measure.
  PagedSysop  AS INTEGER         '0 to 32,767 Number of times they've tried to
                                 'page the sysop.
  Logons      AS INTEGER         '0 to 32,767 Number of logons.
  Attempts    AS STRING * 1      '0 to 255 Number of bad password attempts
                                 'since their last call.
  MinCredits  AS INTEGER         '-32,767 to 32,767
                                 'Number of minutes to add to their daily
                                 'that their security level gets.
  MinMegs     AS INTEGER         '-32,767 to 32,767
                                 'This number is multiplied by 1 megabyte
                                 'and then added to their "number of
                                 'bytes can download" to determine what
                                 'their download bytes limit is.
  MsgsPosted  AS INTEGER         '0 to 32,767 Total number of public messages
                                 '(excluding NetMail) they've posted.
  EMsgsPosted AS INTEGER         '0 to 32,767 Total number of private
                                 '(excluding feedback and NetMail) messages
                                 'they've posted.
  FMsgsPosted AS INTEGER         '0 to 32,767 Total number of feedback
                                 'messages they've posted.
  NetMailSent AS INTEGER         '0 to 32,767 Total number of NetMail letters
                                 'they've sent.
  NetMailRcvd AS INTEGER         '0 to 32,767 Total number of NetMail letters
                                 'they've received.
  Elapsed     AS INTEGER         '0 to 32,767 Length of previous call(s).
                                 'Never exceeds maximum daily limit for
                                 'whatever security level.
  Dnlds       AS INTEGER         '0 to 32,767 Total files downloaded.
  DLBytes     AS LONG            '0 to 2,100,000,000 Total bytes downloaded.
  MinsDLing   AS LONG            '0 to 2,100,000,000 Total number of minutes
                                 'downloading.
  BadDLs      AS INTEGER         '0 to 32,767 Total number of bad DL's.
  Uplds       AS INTEGER         '0 to 32,767 Total files uploaded.
  ULBytes     AS LONG            '-'ve to 2,100,000,000 Total bytes uploaded.
  MinsULing   AS LONG            '0 to 2,100,000,000 Total number of minutes
                                 'uploading.
  BadULs      AS INTEGER         '0 to 32,767 Total number of bad UL's.
  Doors       AS INTEGER         '0 to 32,767 Number of accesses to doors.
  Group       AS INTEGER         'undefined as yet.
  SysopNote   AS STRING * 52     'Sysop's note field about the user.
                                 'For important internal information.
  UserNote    AS STRING * 52     'User modifiable note field.
                                 'Can be used for: self-praise, some item,
                                 'the sysop should know, if a sysop--then
                                 'name of their BBS, their street address,
                                 'zip, system type, etc..  Whatever you want.
END TYPE
'
' Spitfire 3.1 user record.
'
TYPE SFUserRecord                'Len = 315
  LenUserName      AS STRING * 31
  LenCallingFrom   AS STRING * 31
  LenPassword      AS STRING * 15
  LenTimeDate      AS STRING * 15
  LenPhoneNumber   AS STRING * 13
  LenBirthDate     AS STRING * 9
  SecurityLevel    AS INTEGER
  Uploads          AS LONG
  Downloads        AS LONG
  TotalUK          AS LONG
  TotalDK          AS LONG
  TimesOn          AS INTEGER
  TimeLeft         AS INTEGER
  LastMConf        AS INTEGER
  LastFArea        AS INTEGER
  TransPro         AS INTEGER
  Defaults         AS STRING * 1
  LenFirstLogDate  AS STRING * 9
  SubscriptionDate AS LONG
  ConfQueue        AS STRING * 32
  ExtraBytes       AS STRING * 75
  AllowPurge       AS STRING * 1
  BadLastOff       AS STRING * 1
  ScrollBack       AS STRING * 1
  Xpert            AS STRING * 1
  LockedOut        AS STRING * 1
  Deleted          AS STRING * 1
  Linelen          AS STRING * 1
  Pagelen          AS STRING * 1
  OnToday          AS STRING * 1
  Illegal          AS STRING * 1
  DLToday          AS STRING * 1
  ForeGround       AS STRING * 1
  ExtraWord        AS INTEGER
  DLBytes          AS LONG
  LenNewFCheck     AS STRING * 9
  OrgSecurity      AS INTEGER
  ChatsToday       AS INTEGER
  Extra            AS STRING * 21
END TYPE
'
' Telegard 2.7 user record.
'
TYPE TGUserRecord                'Len = 2089
  LenHandle    AS STRING * 37    '/* user name */
  LenName      AS STRING * 37    '/* real name */
  LenAddress   AS STRING * 31    '/* mailing address */
  LenCityState AS STRING * 31    '/* city, state */
  LenZipCode   AS STRING * 11    '/* zipcode */
  LenPhone     AS STRING * 13    '/* user phone # */
  LenBirthDate AS STRING * 9     '/* user birthdate */
  Gender       AS STRING * 1     '/* user sex */
  LenPassword  AS STRING * 21    '/* user password */
  LenFirstCall AS STRING * 9     '/* firston date */
  LenLastOn    AS STRING * 9     '/* laston date */
  LenComputer  AS STRING * 31    '/* type of computer */
  LenJob       AS STRING * 41    '/* occupation */
  LenBBSRef    AS STRING * 41    '/* BBS reference */
  LenSysopNote AS STRING * 40    '/* SysOp note */
  LenLockOut   AS STRING * 9     '/* lockout msg to print */
  Colors       AS STRING * 20    '/* user colors */
  LineLength   AS STRING * 1     '/* line length (# cols) */
  PageLength   AS STRING * 1     '/* page length (# rows) */
  MacroPtr     AS LONG           '/* pointer to entry in MACRO.LST */
  LenMenu      AS STRING * 9     '/* menu to start user out on */
  Toggles      AS STRING * 2     '/* flags (see above) */
  SecLevel     AS STRING * 1     '/* SL */
  DSL          AS STRING * 1     '/* DSL */
  Attr         AS STRING * 3     '/* user flags */
  ARFlags      AS STRING * 4     '/* AR flags */
  LastMsgBase  AS STRING * 1     '/* last message base # */
  MsgsPosted   AS INTEGER        '/* # public posts */
  EMsgsPosted  AS INTEGER        '/* # private posts */
  NetMailSent  AS INTEGER        '/* # NetMail posts */
  FwdToUserNum AS INTEGER        '/* forward mail to user # */
  CreditMonies AS LONG           '/* NetMail points (credit) */
  DebitMonies  AS LONG           '/* NetMail points (debit) */
  LastRead     AS STRING * 1536  '/* NewScan high message pointers */
  MBasesTogs   AS STRING * 32    '/* NewScan message bases */
  BoardSysop   AS STRING * 5     '/* msg board SysOp */
  LastFileBase AS STRING * 1     '/* last file base # */
  Uplds        AS INTEGER        '/* # of ULs */
  Dnlds        AS INTEGER        '/* # of DLs */
  ULBytesK     AS LONG           '/* amount ULed (kilobytes) */
  DLBytesK     AS LONG           '/* amount DLed (kilobytes) */
  FilePoints   AS INTEGER        '/* # of file points */
  ListType     AS STRING * 1     '/* type of file list type to use */
  FBasesTogs   AS STRING * 32    '/* NewScan file bases */
  TotalMins    AS LONG           '/* total mins spent on */
  Logons       AS INTEGER        '/* # times logged on */
  MinsLeft     AS INTEGER        '/* # min left today */
  TimesOnToday AS STRING * 1     '/* # times on today */
  Attempts     AS STRING * 1     '/* # illegal logon attempts */
  VoteData     AS STRING * 20    '/* voting data */
  BankedMins   AS INTEGER        '/* # mins in Time Bank */
  BankedToday  AS INTEGER        '/* time added to timebank TODAY */
END TYPE
'
' RemoteAccess 1.11 user record.
'
TYPE RAUserRecord                'Len = 158
  LenName       AS STRING * 36
  LenLocation   AS STRING * 26
  LenPassword   AS STRING * 16
  LenDataPhone  AS STRING * 13
  LenVoicePhone AS STRING * 13
  LenLastTime   AS STRING * 6
  LenLastDate   AS STRING * 9
  Attr          AS STRING * 1
  Flags         AS STRING * 4
  Credit        AS INTEGER
  Pending       AS INTEGER
  MsgsPosted    AS INTEGER
  LastRead      AS INTEGER
  Security      AS INTEGER
  NoCalls       AS INTEGER
  Uploads       AS INTEGER
  Downloads     AS INTEGER
  UploadsK      AS INTEGER
  DownloadsK    AS INTEGER
  TodayK        AS INTEGER
  Elapsed       AS INTEGER
  ScreenLength  AS INTEGER
  LastPwdChange AS STRING * 1
  Toggles       AS STRING * 1
  Group         AS STRING * 1
  XIrecord      AS INTEGER
  ExtraSpace    AS STRING * 3
END TYPE
'
'
' MessageRecord is the record structure used for each messages header in
' the MESSAGES file.
'
TYPE MessageRecord               'Len = 128
  Attr          AS INTEGER       '16 bits:
                                 '1 True if a deleted message.
                                 '2 True if Msg body is compressed.
                                 '3 True if this is a reply.
                                 'x True if NetMail
                                 'x True if shouldn't ever NetMail out.
                                 'x True if shouldn't ever Auto delete.
                                 'x True if should never delete at all.
                                 '8 True if redirected from sysop.
                                 '9 True if redirected from AI.
                                 '10 True if redirected to sysop.
                                 '11 True if redirected to AI.
                                 'Rest are for the future.
  MsgNum        AS LONG          '1 to 2,100,000,000 message number.
                                 'Each message base has it's own message
                                 'counter.
  MsgFrom       AS STRING * 30   'Name of sender.  Uppercase.
  MsgTo         AS STRING * 30   'Name of receiver or "ALL".  Uppercase.
  MsgDateSent   AS INTEGER       'Date message was sent.
                                 'Date stored in integer form.
  MsgTimeSent   AS INTEGER       'Time stored in integer form.
                                 'HHMM and +/-'ve depending on am/pm.
  MsgDateRcvd   AS INTEGER       'Date message was received.  0 if not
                                 'received or sent to "ALL".
                                 'Date stored in integer form.
  MsgTimeRcvd   AS INTEGER       'Time stored in integer form.
                                 'HHMM and +/-'ve depending on am/pm.
  NumOfBytes    AS INTEGER       'Doesn't exceed 8192, message length.
  NumberReplies AS STRING * 1    'This message has been replied to x times.
                                 'This is not the number of active replies.
  TimesRead     AS INTEGER       'Number of times this message has been read.
  LastDateRead  AS INTEGER       'last date anybody read the message.
  MsgSubject    AS STRING * 33   'Compressed text--message subject.
  MsgBase       AS INTEGER       '0 - 32,767 Message bases.
  MsgCheckSum   AS INTEGER       'Checksum of the to/from/subject fields.
  NetAttr       AS INTEGER       'NetMail attributes.
  SourceAddr    AS LONG          'NetMail source address.
  DestAddr      AS LONG          'NetMail destination address.
END TYPE
'
' Spitfire 3.1 message header record.
'
TYPE SFMsgHeaderRec              'Len = 256
  LenMDate        AS STRING * 18
  LenFromWho      AS STRING * 31
  LenToWho        AS STRING * 31
  LenOrgTo        AS STRING * 31
  LenSubject      AS STRING * 41
  NetMail         AS STRING * 1
  MsgSent         AS STRING * 1
  PurgeWhenSent   AS STRING * 1
  ThreadMsg       AS STRING * 1
  ThreadStart     AS STRING * 1
  Private         AS STRING * 1
  Deleted         AS STRING * 1
  Received        AS STRING * 1
  Where           AS INTEGER
  NumberofRecords AS INTEGER
  Conference      AS INTEGER
  MsgNumber       AS LONG
  OrgMsgNumber    AS LONG
  Extra           AS STRING * 82
END TYPE
'
' Telegard 2.7 message header record.
'
TYPE TGMsgHeaderRec              'Len = 345
  TextPtr    AS LONG             '/* pointer to message text */
  MsgLength  AS INTEGER          '/* length of message text */
  Cost       AS INTEGER          '/* cost to send message (NetMail only) */
  FAnonFlag  AS STRING * 1       '/* anonymous type (0=no, 1/2=yes, 3="Abby", */
  FUserRec   AS INTEGER          '/* user number (0=none) */
  FZone      AS INTEGER          '/* zone (0=none) */
  FNet       AS INTEGER          '/* net (0=none) */
  FNode      AS INTEGER          '/* node (0=none) */
  FPoint     AS INTEGER          '/* point (0=none) */
  FLenHandle AS STRING * 37      '/* user name (all caps) if anon=3..5, */
  FLenName   AS STRING * 37      '/* user real name (all caps) */
  FLenAlias  AS STRING * 37      '/* user alias (all caps) */
  TAnonFlag  AS STRING * 1       '/* anonymous type (0=no, 1/2=yes, 3="Abby", */
  TUserRec   AS INTEGER          '/* user number (0=none) */
  TZone      AS INTEGER          '/* zone (0=none) */
  TNet       AS INTEGER          '/* net (0=none) */
  TNode      AS INTEGER          '/* node (0=none) */
  TPoint     AS INTEGER          '/* point (0=none) */
  TLenHandle AS STRING * 37      '/* user name (all caps) if anon=3..5, */
  TLenName   AS STRING * 37      '/* user real name (all caps) */
  TLenAlias  AS STRING * 37      '/* user alias (all caps) */
  LenTitle   AS STRING * 72      '/* title of message */
  LenDate    AS STRING * 20      '/* Net/Echo/Group original msg date */
END TYPE
'
' RemoteAccess 1.11 message header record.
'
TYPE RAMsgHeaderRec              'Len = 187
  MsgNum      AS INTEGER
  PrevReply   AS INTEGER
  NextReply   AS INTEGER
  TimesRead   AS INTEGER
  StartBlock  AS INTEGER
  NumBlocks   AS INTEGER
  DestNet     AS INTEGER
  DestNode    AS INTEGER
  OrigNet     AS INTEGER
  OrigNode    AS INTEGER
  DestZone    AS STRING * 1
  OrigZone    AS STRING * 1
  Cost        AS INTEGER
  MsgAttr     AS STRING * 1
  NetAttr     AS STRING * 1
  Board       AS STRING * 1
  LenPostTime AS STRING * 6
  LenPostDate AS STRING * 9
  LenWhoTo    AS STRING * 36
  LenWhoFrom  AS STRING * 36
  LenSubject  AS STRING * 73
END TYPE


DECLARE FUNCTION Adjust$ (st$)
DECLARE FUNCTION StrCkSum% (st$)
DECLARE FUNCTION IntToAddr& (i%,i0%,i1%)


COMMON SHARED _
  User AS UserRecord, _
  SFUser AS SFUserRecord, _
  TGUser AS TGUserRecord, _
  RAUser AS RAUserRecord, _
  Message AS MessageRecord, _
  SFMsg AS SFMsgHeaderRec, _
  TGMsg AS TGMsgHeaderRec, _
  RAMsg AS RAMsgHeaderRec


'
' Start of actual code.
'
CLS
PRINT "This program converts the users and messages of SF, Telegard, or RA to"
PRINT "JDR_BBS format.  The USERS file is created new, but MESSAGES is appended"
PRINT "onto.  All files must be in the current directory.  Make backups."
PRINT
PRINT "Convert FROM                                             TO"
PRINT "1. *    Spitfire 3.1 SFUSERS.DAT                         JDR_BBS .07 USERS"
PRINT "2. *    Telegard 2.7 USER.LST                            JDR_BBS .07 USERS"
PRINT "3. *    RemoteAccess 1.11 USERS.BBS                      JDR_BBS .07 USERS"
PRINT "4. *    Spitfire 3.1 SFMSGxx.PTR/SFMSGxx.DAT             JDR_BBS .07 MESSAGES"
PRINT "5. *    Telegard 2.7 x.BRD                               JDR_BBS .07 MESSAGES"
PRINT "6. *    RemoteAccess 1.11 MSGHDR.BBS/MSGTXT.BBS          JDR_BBS .07 MESSAGES"
PRINT "(Those with '*' have not yet been tested.)"
PRINT "IF the conversion doesn't work, or isn't to your liking, tell me and I'll"
PRINT "fix the problem, and put up a working/better version the next day."
PRINT
PRINT "Do which [1..6]";
INPUT K
PRINT
SELECT CASE K
  CASE 1 : PRINT "Working..."
           CALL SFtoJDR
  CASE 2 : PRINT "Working..."
           CALL TGtoJDR
  CASE 3 : PRINT "Working..."
           CALL RAtoJDR
  CASE 4 : CALL SFMsgToJDR
  CASE 5 : CALL TGMsgToJDR
  CASE 6 : PRINT "Working..."
           CALL RAMsgToJDR
END SELECT
IF K > 0 AND K < 7 THEN PRINT "Done."
END


SUB SFtoJDR
OPEN "SFUSERS.DAT" FOR BINARY AS #1
OPEN "USERS" FOR BINARY AS #2
CALL InitNewUser
FOR K0 = 1 TO LOF(1) \ 315
  GET #1,K0,SFUser
  User.UserName  = Adjust$(SFUser.LenUserName)
  User.Password  = Adjust$(SFUser.LenPassword)
  User.CityState = Adjust$(SFUser.LenCallingFrom)
  User.SecLevel  = SFUser.SecurityLevel
  User.Logons    = SFUser.TimesOn
  User.Dnlds     = SFUser.Downloads
  User.DLBytes   = SFUser.TotalDK * 1024&
  User.Uplds     = SFUser.Uploads
  User.ULBytes   = SFUser.TotalUK * 1024&
  PUT #2,K0 + 1,User
NEXT
CLOSE 1, 2
END SUB


SUB TGtoJDR
OPEN "USER.LST" FOR BINARY AS #1
OPEN "USERS" FOR BINARY AS #2
CALL InitNewUser
FOR K0 = 2 TO LOF(1) \ 2089      'Start at second record.
  GET #1,K0,TGUser
  User.UserName    = Adjust$(TGUser.LenName)
  User.Password    = Adjust$(TGUser.LenPassword)
  User.CityState   = Adjust$(TGUser.LenCityState)
  User.SecLevel    = ASC(TGUser.SecLevel)
  User.Monies      = TGUser.CreditMonies
  User.TotalMonies = TGUser.DebitMonies
  User.Logons      = TGUser.Logons
  User.MinCredits  = TGUser.FilePoints
  User.MsgsPosted  = TGUser.MsgsPosted
  User.EMsgsPosted = TGUser.EMsgsPosted
  User.NetMailSent = TGUser.NetMailSent
  User.Dnlds       = TGUser.Dnlds
  User.DLBytes     = TGUser.DLBytesK * 1024&
  User.Uplds       = TGUser.Uplds
  User.ULBytes     = TGUser.ULBytesK * 1024&
  User.SysopNote   = Adjust$(TGUser.LenSysopNote)
  PUT #2,K0,User
NEXT
CLOSE 1, 2
END SUB


SUB RAtoJDR
OPEN "USERS.BBS" FOR BINARY AS #1
OPEN "USERS" FOR BINARY AS #2
CALL InitNewUser
FOR K0 = 1 TO LOF(1) \ 158
  GET #1,K0,RAUser
  User.UserName   = Adjust$(RAUser.LenName)
  User.Password   = Adjust$(RAUser.LenPassword)
  User.CityState  = Adjust$(RAUser.LenLocation)
  User.SecLevel   = RAUser.Security
  User.Logons     = RAUser.NoCalls
  User.Dnlds      = RAUser.Downloads
  User.DLBytes    = RAUser.DownloadsK * 1024&
  User.Uplds      = RAUser.Uploads
  User.ULBytes    = RAUser.UploadsK * 1024&
  User.MinCredits = RAUser.Credit
  User.MsgsPosted = RAUser.MsgsPosted
  PUT #2,K0 + 1,User
NEXT
CLOSE 1, 2
END SUB


SUB SFMsgToJDR
INPUT "Full path\filename to use [no extension] (a .PTR file): ";K$
IF K$ = "" THEN EXIT SUB
PRINT "Working..."
OPEN K$ + "PTR" FOR BINARY AS #1
OPEN K$ + "DAT" FOR BINARY AS #2
OPEN "MESSAGES" FOR BINARY AS #3
CALL InitMsg
SEEK #3,LOF(3)
DO
  GET #1,,SFMsg
  Message.MsgNum      = SFMsg.MsgNumber
  Message.MsgFrom     = Adjust$(SFMsg.LenFromWho)
  Message.MsgTo       = Adjust$(SFMsg.LenToWho)
  Message.MsgSubject  = Adjust$(SFMsg.LenSubject)
  Message.MsgBase     = SFMsg.Conference
  Message.MsgCheckSum = StrCkSum(Message.MsgTo + Message.MsgFrom + Message.MsgSubject)
  MessageBody$ = ""
  K$ = SPACE$(128)
  FOR K = SFMsg.Where TO SFMsg.Where + SFMsg.NumberofRecords - 1
    K& = (K - 1) * 128& + 1
    GET #2,K&,K$
    MessageBody$ = LEFT$(MessageBody$ + Adjust$(K$),8192)
  NEXT
  Message.NumOfBytes = LEN(MessageBody$)
  PUT #3,,Message
  PUT #3,,MessageBody$
LOOP UNTIL EOF(1)
CLOSE 1, 2, 3
END SUB


SUB TGMsgToJDR
INPUT "Full path\filename to use (a .BRD file): ";K$
IF K$ = "" THEN EXIT SUB
INPUT "Message base number to use (1..n): ";K0
PRINT "Working..."
OPEN K$ FOR BINARY AS #1
OPEN "MESSAGES" FOR BINARY AS #2
CALL InitMsg
SEEK #2,LOF(2)
K = 0
DO
  GET #1,,TGMsg
  K = K + 1
  Message.MsgNum      = K
  Message.MsgFrom     = Adjust$(TGMsg.FLenName)
  Message.MsgTo       = Adjust$(TGMsg.TLenName)
  Message.MsgSubject  = Adjust$(TGMsg.LenTitle)
  MsgBase             = K0
  Message.MsgCheckSum = StrCkSum(Message.MsgTo + Message.MsgFrom + Message.MsgSubject)
  Message.SourceAddr  = IntToAddr&(TGMsg.FZone,TGMsg.FNet,TGMsg.FNode)
  Message.DestAddr    = IntToAddr&(TGMsg.TZone,TGMsg.TNet,TGMsg.TNode)
  MessageBody$ = SPACE$(TGMsg.MsgLength)
  GET #1,,MessageBody$
  MessageBody$ = LEFT$(MessageBody$,8192)
  Message.NumOfBytes = LEN(MessageBody$)
  PUT #2,,Message
  PUT #2,,MessageBody$
LOOP UNTIL EOF(1)
CLOSE 1, 2
END SUB


SUB RAMsgToJDR
OPEN "MSGHDR.BBS" FOR BINARY AS #1
OPEN "MSGTXT.BBS" FOR BINARY AS #2
OPEN "MESSAGES" FOR BINARY AS #3
CALL InitMsg
SEEK #3,LOF(3)
DO
  GET #1,,RAMsg
  Message.MsgNum      = RAMsg.MsgNum
  Message.MsgFrom     = Adjust$(RAMsg.LenWhoFrom)
  Message.MsgTo       = Adjust$(RAMsg.LenWhoTo)
  Message.TimesRead   = RAMsg.TimesRead
  Message.MsgSubject  = Adjust$(RAMsg.LenSubject)
  Message.MsgBase     = ASC(RAMsg.Board)
  Message.MsgCheckSum = StrCkSum(Message.MsgTo + Message.MsgFrom + Message.MsgSubject)
  Message.SourceAddr  = IntToAddr&(ASC(RAMsg.OrigZone),RAMsg.OrigNet,RAMsg.OrigNode)
  Message.DestAddr    = IntToAddr&(ASC(RAMsg.DestZone),RAMsg.DestNet,RAMsg.DestNode)
  MessageBody$ = ""
  K$ = SPACE$(256)
  FOR K = RAMsg.StartBlock TO RAMsg.StartBlock + RAMsg.NumBlocks - 1
    K& = (K - 1) * 256& + 1
    GET #2,K&,K$
    MessageBody$ = LEFT$(MessageBody$ + Adjust$(K$),8192)
  NEXT
  Message.NumOfBytes = LEN(MessageBody$)
  PUT #3,,Message
  PUT #3,,MessageBody$
LOOP UNTIL EOF(1)
CLOSE 1, 2, 3
END SUB


SUB InitMsg
Message.Attr          = 0
Message.MsgNum        = 0
Message.MsgFrom       = ""
Message.MsgTo         = ""
Message.MsgDateSent   = 0
Message.MsgTimeSent   = 0
Message.MsgDateRcvd   = 0
Message.MsgTimeRcvd   = 0
Message.NumOfBytes    = 0
Message.NumberReplies = CHR$(0)
Message.TimesRead     = 0
Message.LastDateRead  = 0
Message.MsgSubject    = ""
Message.MsgBase       = 0
Message.MsgCheckSum   = 0
Message.NetAttr       = 0
Message.SourceAddr    = 0
Message.DestAddr      = 0
END SUB


SUB InitNewUser
User.UserName    = ""
User.Password    = ""
User.CityState   = ""
User.HomePhone   = 0
User.BBSPhone    = 0
User.BirthDate   = 0
User.SecLevel    = 0
User.FirstCall   = 0
User.Attr        = 0
User.Toggles     = 0
User.Protocol    = "Z"
User.Votes       = ""
User.SubsStart   = 0
User.SubsEnd     = 0
User.SubsType    = "0"
User.Monies      = 0
User.TotalMonies = 0
User.LastDateOn  = 0
User.PswdChange  = CHR$(0)
User.AlterDate   = 0
User.JDRVerDL    = 0
User.BullsRead   = STRING$(8,0)
User.Connect     = ""
User.HiFilePtr   = 0
User.HighestPtr  = 0
User.PagedSysop  = 0
User.Logons      = 0
User.Attempts    = CHR$(0)
User.MinCredits  = 0
User.MinMegs     = 0
User.MsgsPosted  = 0
User.EMsgsPosted = 0
User.FMsgsPosted = 0
User.NetMailSent = 0
User.NetMailRcvd = 0
User.Elapsed     = 0
User.Dnlds       = 0
User.DLBytes     = 0
User.MinsDLing   = 0
User.BadDLs      = 0
User.Uplds       = 0
User.ULBytes     = 0
User.MinsULing   = 0
User.BadULs      = 0
User.Doors       = 0
User.Group       = 0
User.SysopNote   = ""
User.UserNote    = ""
PUT #1,1,User
END SUB


FUNCTION Adjust$ (K$)
Adjust$ = MID$(K$,2,ASC(K$))
END FUNCTION


FUNCTION StrCkSum% (K$)
K = 0
FOR K0 = 1 TO LEN(K$)
  K = K + ASC(MID$(K$,K0,1))
NEXT
StrCkSum = K
END FUNCTION


FUNCTION IntToAddr& (i,i0,i1)
IntToAddr& = (32768& + i0) * 32768& + i1
END FUNCTION
