;
; This routine will create a directory.
;
; Usage:  CALL DirCreate (Input$)
;
; Where Input$ is a "\" terminated directory name to create.
;
; If the parent directories don't exist, they too are created.
;
; It's assumed there is a "x:\" for the first 3 characters of Input$.
;

.Model Medium, Basic
.Code

            PUBLIC  DirCreate         ;Make this routine available to LINK.

DirCreate   proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp

            mov     si,[bp + 06]      ;Descriptor of Input$.
            mov     cx,[si]           ;size of input$
            mov     dx,[si + 02]      ;Address of Input$.
            mov     si,dx
            inc     si                ;Past the "x" in "x:\".
            inc     si                ;Past the ":" in "x:\".
            inc     si                ;Past the "\" in "x:\".
            dec     cx                ;Three less characters to do.
            dec     cx
            dec     cx
            dec     cx
            js      Done              ;There weren't 3 chars to start with.
            inc     cx

            cld                       ;Forward string work.
        R1: lodsb                     ;get the character.
            cmp     al,'\'            ;if a path terminator,
            je      R2                ;then create the path so far.
            loop    R1                ;check out each character.
            jmp     Done

        R2: dec     si                ;Point SI to the '\'
            mov     ah,0              ;Replace with an ASCII 0.
            mov     [si],ah
            mov     ah,39H            ;Subfunction to create directories.
            int     21H               ;CALL DOS Services to do it.
            mov     ah,'\'            ;Replace the ASCII 0 with a '\'.
            mov     [si],ah
            inc     si
            jmp     R1                ;continue working on our string.

      Done: pop     bp
            ret     2                 ;Pop-return past our input parameter.

DirCreate   endp                      ;End of routine.

End





