' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' This file contains door related routines:
'   DoorSystem
'   DoorSystemExitTT
'   IntToDate2$
'   DoorSystemReturn



        '* * * * * *
        ' This routine handles the exiting to doors.  Including the
        ' creation of the necessary files and the exit from the BBS.
        '
        ' Date last checked for perfection: Sep 16 1992
        '
SUB DoorSystem

  '
  ' Get our door information.
  '
  K = FileOpen(FileNames$(37))
  CALL FileGetRec(K,Val2&(RIGHT$(Menu.ShouldDo,2)),244,Door)
  CALL FileClose(K)
  K0$ = UCASE$(RTRIM$(Door.Path))
  IF LEN(K0$) = 0 THEN K0$ = Paths$(2)
  IF DriveSpc&(K0$) <= Door.MinSpace THEN TT = 144 : _
                                          CALL SendTT : _
                                          EXIT SUB
  IF Right$(K0$,1) <> Short$(426) THEN K0$ = K0$ + Short$(426)
  K1 = AscVal(MID$(Menu.ShouldDo,2,1))
  '
  ' Output a DORINFOx.DEF file, an alternate door file, and JDRBBSxx.DEF.
  '
  FOR K = 1 TO 3
    SELECT CASE K
      CASE 1                  'RBBS's/'standard'  DORINFOx.DEF door file.
           K$ = Short$(427) + LTRIM$(STR$(Settings.Node)) + Short$(428)
           K0 = 65
           TT = 189
      CASE 2
           K0 = K1
           IF K0 > 96 THEN CALL BitClear(K0,6)
           SELECT CASE K0
             CASE 65          'WWIV's CHAIN.TXT door file.
                  K$ = Short$(429)
                  TT = 229
             CASE 66          'Spitfire's SFDOORS.DAT door file.
                  K$ = Short$(430)
                  TT = 259
             CASE 67          'DOOR.SYS 07/07/90 version (GAP/RG, RC, DT,
                              'and 'KG's door file.)
                  K$ = Short$(431)
                  TT$ = GetBlock$(40)
             CASE 68          'PCBOARD.SYS version 14.x  (PCBoard door file.)
                  K$ = Short$(432)
                  PCB14.Misc1 = Short$(433)
                  PCB14.Misc4 = Short$(434)
                  TT = 299
             CASE 69          'PCBOARD.SYS version 12.x  (PCBoard door file.)
                  K$ = Short$(432)
                  PCB12.Misc1 = Short$(435)
                  PCB12.Misc2 = Short$(1020)
                  PCB12.Misc4 = Short$(437)
                  TT = 318
             CASE ELSE :K$ = Null$
            END SELECT
      CASE 3
           K$ = Short$(438) + _
                 RIGHT$(Short$(628) + LTRIM$(STR$(Settings.Node)),2) + Short$(428)
           K0 = 65
           TT = 321
    END SELECT
    SELECT CASE LEN(K$)
      CASE IS > 0
           CALL KillFile(K0$ + K$)
           K2 = FileOpen(K0$ + K$)
           IF (K0 > 64 AND K0 < 70) THEN CALL DoorSystemExitTT(K2)
           IF K0 = 68 THEN CALL FilePutRec(K2,1,128,PCB14)
           IF K0 = 69 THEN CALL FilePutRec(K2,1,128,PCB12)
           CALL FileClose(K2)
    END SELECT
  NEXT
  K1$ = Door.Execute
  CALL ExpandStr(K1$)
  '
  ' Create RUN_DOOR.BAT if not a shell exit.
  '
  SELECT CASE K1
    CASE IS < 97
         CALL KillFile(FileNames$(54))
         K2 = FileOpen(FileNames$(54))
         K1$ = Short$(440) + RIGHT$(Menu.ShouldDo,2) + C1310$ + LEFT$(K0$,2) + _
               C1310$ + Short$(441) + MID$(K0$,3,LEN(K0$) - 3) + C1310$ + K1$
         K1$ = K1$ + C1310$ + LEFT$(Paths$(2),2) + C1310$ + _
               Short$(441) + MID$(Paths$(2),3,LEN(Paths$(2)) - 3) + C1310$
         K1$ = K1$ + FileNames$(55) + C1310$
         CALL FilePutSEnd(K2,K1$)
         CALL FileClose(K2)
  END SELECT
  IF RTRIM$(User.UserName) <> Null$ _
     THEN K2 = FileOpen(FileNames$(1)) : _
          kz = BiSearch(5,0,User.UserName) : _
          CALL FilePutRec(K2,kz,384,User) : _
          CALL FileClose(K2) : _
          K2 = FileOpen(FileNames$(3)) : _
          CALL FilePutSLoc(K2,1& * (kz - 1) * LEN(UserMsgInfo$),UserMsgInfo$) : _
          CALL FileClose(K2)
  SumLog.Doors = SumLog.Doors + 1
  IF K1 < 97 THEN CALL SaveIndices : _
                  CALL UpdateSumLog(0) : _
                  K = FosIntAX(CommPort,&H1D00) : _
                  CALL ShellDos(9,Null$)
  IF BitTest(Toggles(2),8) OR BitTest(User.Attr,6) _
     THEN CALL FileClose(Handle(1))
  CALL ShellDos(2,K1$)
  K = Val2&(RIGHT$(Menu.ShouldDo,2))
  CALL DoorSystemReturn(K)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to DoorSystem, converts a door specs
        ' string into a door file.
        '
        ' p  file handle of door exit file.
        '
        ' TT/TT$  is the string of what to do.
        '
        ' Date last checked for perfection: Sep 16 1992
        '
SUB DoorSystemExitTT (p)

  IF TT > 0 THEN TT$ = GetLine$(TT) : _
                 TT = 0
  K0$ = Null$
  FOR K = 1 TO LEN(TT$) \ 3
    K$ = Null$
    K& = 0 
    SELECT CASE Val2&(MID$(TT$,K * 3 - 2,3))
      CASE  1 : K$ = User.UserName                      'User's full name.
                K& = BiSearch(5,0,User.UserName)        'User's record number.
                PCB14.UserName = K$
                PCB14.RecNum = K&
                PCB12.UserName = K$
                PCB12.RecNum = K&
      CASE  2 : K$ = User.CityState                     'User's location.
      CASE  3 : K$ = Form$(16,User.UserName)            'User's first name.
                K& = Levels(UserSL).SecLevel            'User's SL value.
                PCB14.FirstName = K$
                PCB12.FirstName = K$
      CASE  4 : K$ = User.Password                      'User's password.
                PCB14.Password = K$
                PCB12.Password = K$
      CASE  5 : K$ = Door.UserName                      'Sysop's name.
      CASE  6 : K& = User.Uplds                         'User's total files uploaded.
      CASE  7 : K& = User.Dnlds                         'User's total files downloaded.
      CASE  8 : K& = User.Logons                        'User's total logons.
      CASE  9 : K& = User.ULBytes \ 1024&               'Total K uploaded.
      CASE 10 : K& = User.DLBytes \ 1024&               'Total K downloaded.
      CASE 11 : K& = User.MsgsPosted + User.EMsgsPosted + User.FMsgsPosted + _
                     User.NetMailSent                   'Total messages posted.
      CASE 12 : K0 = DLTime
                IF Door.MaxTime < K0 THEN K0 = Door.MaxTime
                K& = K0 * 60&                            'Time left (in seconds).
                K$ = STR$(K&) + Short$(445)
                PCB12.SecsAvail = K&
      CASE 13 : K0 = DLTime
                IF Door.MaxTime < K0 THEN K0 = Door.MaxTime
                K& = K0                                 'Time left (in minutes).
                PCB14.MinsAvail = K0
                PCB14.MinsAvail2 = K0
      CASE 14 : K$ = User.Protocol                      'Default protocol.
                K& = CanDL&                             'Number of allowed DL bytes.
      CASE 15 : IF BitTest(Toggles(2),10) THEN K& = Settings.Init9600 _
                                          ELSE K& = Settings.Init2400
                                                        'Fossil initialization.
      CASE 16 : K$ = IntToPhone$(User.HomePhone)        'Home phone number.
      CASE 17 : K$ = IntToPhone$(User.BBSPhone)         'Work/data/BBS phone number.
      CASE 18 : K& = 24                                 'Height of user's screen.
      CASE 19 : K$ = User.UserNote                      'Comment on user.
      CASE 20 : K$ = IntToDate2$(User.LastDateOn)       'Last date user called.
                                                        'Last new files scan date.
      CASE 21 : K$ = Short$(1022 + BitTest(Toggles(2),2))
                PCB12.BlankScr = Short$(1020 + BitTest(Toggles(2),2))
                PCB14.BlankScr = PCB12.BlankScr
      CASE 22 : K$ = Short$(1021)
      CASE 23 : K& = 8                                  'Parity.
                K$ = Short$(450)                        'Ansi graphics.
      CASE 24 : K& = 0
                K$ = Short$(452)
      CASE 25 : K& = 1
                K$ = Short$(451)
      CASE 26 : K$ = IntToDate2$(User.SubsEnd)          'User expiration date.
      CASE 27 : K$ = IntToDate2$(User.BirthDate)        'User's birthdate.
      CASE 28 : K$ = Paths$(2)                          'Path to main/BBS files.
      CASE 29 : K$ = Door.Path                          'Path to door files.
      CASE 30 : K& = -1
                'I also use this one for K$ = NULL$ (blank line).
      CASE 31 : K& = User.Doors                         'Number of doors user opened.
      CASE 32 : PCB14.Connect = Connect$
                K& = Val2&(PCB14.Connect)
                K$ = Short$(451)
                IF CommPort = 0 THEN K& = 0 : _
                                     K$ = Short$(452) : _
                                     PCB14.Connect = Short$(458)
      CASE 33 : K$ = Time$                              'Current time in HH:MM:SS.
      CASE 34 : K$ = LogonTime$                         'Logon time in HH:MM:SS.
      CASE 35 : K$ = IntToDate2$(LogonDate)             'Logon date in MM/DD/YY.
      CASE 36 : K$ = Connect$                           'Connection string$
                K& = ConnectCPS
      CASE 37 : K& = Settings.ExchMins                  'Exchange rate-mins.
      CASE 38 : K& = Settings.ExchBytes                 'Exchange rate-bytes.
      CASE 39 : K& = Val2&(Menu.Index)                  'Menu exited to door from.
                                                        'Message base left off at.
                                                        'Current menu number.
                K$ = LEFT$(Short$(234),36)              'Conferences/Forums Registered In.
      CASE 40 : K$ = Short$(459)                        'Time of next event.
      CASE 41 : K& = Val2&(LEFT$(Menu.SpecialFX,2))     'BBS's default color.
                K$ = Menu.AnsiToDisp                    'Ansi of exit/return menu.
      CASE 43 : K$ = Settings.LogLeader
      CASE 44 : K0 = ElapsedTime(Short$(394),K1)        'Current time since midnight.
                K& = K0 * 60&                           'In seconds.
                K$ = LEFT$(TIME$,5)                     'Current time in HH:MM.
                                                        'Time of this call.
                                                        'Time of last call.
                PCB14.LogonMins = K0                    'Minutes since midnight.
                PCB14.LogonTime = K$                    'HH:MM of current time.
                PCB12.LogonTime = K$                    'HH:MM of current time.
                PCB12.LogonSecs = K&                    'Seconds since midnight.
                PCB12.LogonSecs2 = K&                   'Same as LogonSecs.
      CASE 45 : K$ = Short$(1022)
      CASE 46 : K$ = Door.LogType
      CASE 48 : K& = CommPort                            'Comm port being used.
                PCB14.CommPort = LTRIM$(STR$(CommPort))
                K$ = Short$(354) + PCB14.CommPort + Short$(229)
      CASE 49 : K0 = 0
                IF BitTest(Toggles(2),2) THEN CALL BitSet(K0,2)
                IF BitTest(Toggles(2),3) THEN CALL BitSet(K0,1)
                IF BitTest(Toggles(1),5) THEN CALL BitSet(K0,3)
                IF BitTest(User.Attr,6) OR BitTest(Toggles(2),8) _
                   THEN CALL BitSet(K0,4)
                                                       'Toggles:
                                                       'set: 1 = Sysop on next.
                                                       '     2 = Keep screen blank.
                                                       '     3 = Trap chat to file.
                                                       '     4 = Trap all to file.
      CASE 50 : K& = DaysSince&(User.BirthDate) \ 365&   'User's age.
      CASE 51 : IF BitTest(User.Toggles,5) THEN K$ = Short$(463) _
                                           ELSE K$ = Short$(464) 'User's gender.
      CASE 52 : K& = User.MinCredits
                K$ = STR$(K&) + Short$(445)              'User's 'gold'.
      CASE 53 : K& = 80                                  'Width of user's screen.
      CASE 54 : IF BitTest(Toggles(2),10) THEN K$ = Short$(455) : _
                                               K& = 19200 : _
                                               PCB14.BPSRate = K$ _
                                          ELSE K$ = Short$(280) : _
                                               K& = 2400 : _
                                               PCB14.BPSRate = Short$(453)
                PCB12.BPSRate = K$
                IF CommPort = 0 THEN K$ = Short$(468) : _
                                     K& = 0 : _
                                     PCB12.BPSRate = Short$(469) 'DTE baud rate.
      CASE 55 : K$ = FileNames$(25)          'Path and filename of the log file.
      CASE 56 : K$ = FileNames$(52)                      'Trap chat file.
      CASE 57 : K$ = FileNames$(51)                      'Trap all file.
      CASE 58 : IF User.SecLevel = Settings.CoSysopSL THEN K& = 1 _
                                                      ELSE K& = 0
                                                         'User = co-sysop.
      CASE 60 : K$ = GetLine$(2)                         'BBS's name.
      CASE 61 : K$ = Form$(20,Door.UserName)             'Sysop's first name.
      CASE 62 : K$ = Form1$(1,Door.UserName)             'Sysop's last name.
      CASE 63 : K$ = Short$(354) + LTRIM$(STR$(CommPort)) 'Comm port being used.
      CASE 64 : K$ = Short$(471 + BitTest(Toggles(2),10))
                IF CommPort = 0 THEN K$ = Short$(472)    'DTE baud and parity
      CASE 65 : IF User.UserName = Door.UserName _
                   THEN K$ = Short$(473) : _
                        K& = 255 _
                   ELSE K$ = Form$(16,User.UserName) : _
                        K& = UserSL                      'User's first name.
                                                       'User's SL.
      CASE 66 : IF User.UserName <> Door.UserName _
                   THEN K$ = Form1$(1,User.UserName) _
                   ELSE K& = 1                           'User's last name.
                                                         'User = sysop.
                'Don't change, opposite (we want) is K$ = NULL and K& = 0.
      CASE 67 : K$ = Short$(474)                         'Comm parameters.
      CASE 69 : K$ = Short$(452 + BitTest(Toggles(2),3)) 'Sysop next.
      CASE 70 : IF BitTest(Toggles(2),10) THEN K$ = Short$(452) : _
                                               K& = 19200 _ 
                                          ELSE K$ = Short$(451) : _
                                               K& = 2400   'Not Locked DTE.
                                                           'Maximum baud.
      CASE 71 : K& = Settings.Node
                PCB14.Node = LTRIM$(STR$(Settings.Node)) 'Node number. ('1' to '9')
      CASE 72 : K& = User.DLBytes                        'User's downloaded bytes.
      CASE 73 : K& = User.ULBytes                        'User's uploaded bytes.
    END SELECT
    '
    ' Output the line (maybe).
    '
    SELECT CASE MID$(TT$,K * 3 - 2,1)
      CASE Short$(475)    'Use K&, write to own line.
           K0$ = K0$ + LTRIM$(STR$(K&)) + C1310$
      CASE Short$(476)    'Use K$, write to own line.
           K0$ = K0$ + UCASE$(LTRIM$(RTRIM$(K$))) + C1310$
      CASE Short$(477)    'Use K$, no modifications, write to own line.
           K0$ = K0$ + K$ + C1310$
    END SELECT
  NEXT
  CALL FilePutSEnd(p,K0$)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to DoorSystemExitTT, will convert an
        ' integer date to string of the form mm/dd/yy.
        '
        ' Date last checked for perfection: Sep 16 1992
        '
FUNCTION IntToDate2$ (p)

  CALL DateDMY(p,K0,K1,K2)
  IntToDate2$ = Form4$(2,K1) + Short$(674) + Form4$(2,K0) + Short$(674) + _
                Form4$(2,K2 + 80)

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine handles the returning from door exits.  Only
        ' JDRBBSxx.DEF is checked for alterations.
        '
        ' p  is the door number we're returning from.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB DoorSystemReturn (p)

  '
  ' Get our door information.
  '
  K0 = FileOpen(FileNames$(37))
  IF p <= FileLof&(K0,244) THEN CALL FileGetRec(K0,p,244,Door) _
                           ELSE CALL FileClose(K0) : _
                                EXIT SUB
  CALL FileClose(K0)
  '
  ' Process the JDRBBSxx.DEF file.
  '
  K$ = RTRIM$(Door.Path)
  IF LEN(K$) = 0 THEN K$ = Paths$(2)
  K4 = FileOpen(K$ + Short$(709) + Form4$(2,Settings.Node) + Short$(710))
  K0& = 0
  FOR K2 = 1 TO LEN(GetLine$(321)) \ 3
    K$ = LTRIM$(RTRIM$(FileGetLine$(K4,K0&)))
    K& = Val2&(K$)
    K0 = (AscVal(K$) = 43)
    K1 = (AscVal(K$) = 45)
    SELECT CASE K2
      CASE 1
           kz = K&
           IF K& <> 0 _
              THEN K0 = FileOpen(FileNames$(1)) : _
                   CALL FileGetRec(K0,kz,384,User) : _
                   CALL FileClose(K0) : _
                   K0 = FileOpen(FileNames$(3)) : _
                   CALL FileGetSLoc(K0,1& * (kz - 1) * LEN(UserMsgInfo$),UserMsgInfo$) : _
                   CALL FileClose(K0) : _ 
                   UserSL = MappedSL(User.SecLevel)
      CASE 2 : CommPort = K&
      CASE 3 : K1 = ElapsedTime(K$,K3)
      CASE 4 : LogonDate = DateToInt(K$)
      CASE 5 : LogonTime$ = K$
      CASE 6 : Connect$ = K$
      CASE 7
           K3 = FosIntAX(CommPort,&H1C00)       'fossil on.
           K3 = K&
           K3 = FosIntAX(CommPort,K3)
      CASE 8 : Menu.Index = Right$(STR$(1000 + K&),3)
      CASE 9 : Menu.AnsiToDisp = K$
      CASE 28
           IF K0 THEN UserSL = UserSL + K& : _
                      User.SecLevel = Levels(UserSL).SecLevel
           IF K1 THEN UserSL = UserSL - K& : _
                      User.SecLevel = Levels(UserSL).SecLevel
      CASE 29
           IF K0 THEN User.Uplds = User.Uplds + K&
           IF K1 THEN User.Uplds = User.Uplds - K&
      CASE 30
           IF K0 THEN User.Dnlds = User.Dnlds + K&
           IF K1 THEN User.Dnlds = User.Dnlds - K&
      CASE 31
           IF K0 THEN User.ULBytes = User.ULBytes + K&
           IF K1 THEN User.ULBytes = User.ULBytes - K&
      CASE 32
           IF K0 THEN User.DLBytes = User.DLBytes + K&
           IF K1 THEN User.DLBytes = User.DLBytes - K&
      CASE 33
           IF BitTest(K&,1) THEN CALL BitSet(Toggles(2),3)
           IF BitTest(K&,2) THEN CALL BitSet(Toggles(2),2)
           IF BitTest(K&,3) THEN CALL BitSet(Toggles(1),5)
           IF BitTest(K&,4) THEN CALL BitSet(Toggles(2),8)
      CASE 34
           IF K0 AND K& + User.MinCredits < 32767& _
              THEN User.MinCredits = User.MinCredits + K&
           IF K1 AND K& + User.MinCredits > -32767& _
              THEN User.MinCredits = User.MinCredits - K&
      CASE 35 : ConnectCPS = K&
    END SELECT
  NEXT
  CALL FileClose(K4)
  CALL KillFile(FileNames$(54))
  CALL SharedWriteEOF(54,0,Short$(711))
  K$ = RTRIM$(Door.Path)
  IF LEN(K$) = 0 THEN K$ = Paths$(2)
  CALL KillFile(K$ +  Short$(709) + Form4$(2,Settings.Node) + Short$(710))
  CALL KillFile(K$ +  Short$(712) + LTRIM$(STR$(Settings.Node)) + Short$(710))
  FOR K = 0 TO 3
    CALL KillFile(K$ + Short$(713 + K))
  NEXT
  IF DriveSpc&(Paths$(1)) < Settings.MinSpace THEN CALL KillFile(FileNames$(11))
  IF BitTest(User.Attr,6) AND NOT BitTest(Toggles(2),8) AND RTRIM$(User.UserName) <> Null$ _
     THEN Handle(1) = FileOpen(FileNames$(51))
  CALL AI(5,Null$,K1,0,0,0,0,0&,0&)
  K0 = FosIntAX(CommPort,&H1C00)       'fossil on.
  IF BitTest(Toggles(2),10) THEN K0 = FosIntAX(CommPort,&H0003) _
                            ELSE K0 = FosIntAX(CommPort,163)

END SUB
        '
        '* * * *


