' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved. 




        '* * * * * *
        ' This routine handles the transmissions (user downloading) of
        ' files.  This routine is entirely separate from the Point
        ' and Shoot routine.
        '
        ' Users can be multiply linked with each other, but only a
        ' single set of the user's numbers are used.  Any members' of
        ' that group will have their numbers included.
        '
        ' Users start out with 1 upload byte and 1 download byte--this
        ' is to protect from division by zero errors.
        '
        ' Since the wanted-for-download file names and paths are sent
        ' to a file, whatever protocol we use must be able to read in
        ' this file.  The protocol must accept '@filename.ext'.
        '
        ' If the user selects auto-logoff, and at least one file was
        ' not sent, then auto-logoff is ignored and the user is
        ' returned to the system.
        '
        ' Date last checked for perfection: Sep 18 1992
        '
SUB Download

  TT = 10100
  CALL SendTT
  K1& = User.DLBytes
  K0& = User.ULBytes
  K3 = FileOpen(FileNames$(18))
  K4 = FileOpen(FileNames$(1))
  FOR K = 1 TO FileLof&(K3,32)
    CALL FileGetRec(K3,K,32,LinkMember)
    K0 = LinkMember.LinkGroup
    IF User.UserName <> LinkMember.UserName THEN K0 = 0
    SELECT CASE K0
      CASE IS > 0
           FOR K2 = 1 TO FileLof&(K3,32)
             CALL FileGetRec(K3,K2,32,LinkMember)
             IF LinkMember.LinkGroup = K0 AND User.UserName <> LinkMember.UserName _
                THEN K1 = BiSearch(5,0,LinkMember.UserName) : _
                     IF K1 > 0 _
                        THEN CALL FileGetRec(K4,K1,384,AnyUser) : _
                             User.DLBytes = User.DLBytes + AnyUser.DLBytes : _
                             User.ULBytes = User.ULBytes + AnyUser.ULBytes
           NEXT
    END SELECT
  NEXT
  CALL FileClose(K3)
  CALL FileClose(K4)
  IF User.DLBytes = 0 THEN User.DLBytes = 1
  IF User.ULBytes = 0 THEN User.ULBytes = 1
  CALL AdjustProtocol(User.Protocol)
  kz$ = RTRIM$(MID$(TT$,20,34))
  TT$ = BlockText2(342) + Commas$(User.ULBytes) + BlockText2(343) + _
        Commas$(User.DLBytes) + BlockText2(344) + _
        LTRIM$(STR$(User.DLBytes \ User.ULBytes))
  SELECT CASE CanDL&
    CASE IS < 0
         TT$ = TT$ + BlockText2(345) + _
               LTRIM$(STR$(Levels(UserSL).BRatio)) + BlockText2(347) + _
               Commas$(Levels(UserSL).BRatio + (- CanDL&) \ Levels(UserSL).BRatio) + _
               BlockText2(349)
         CALL SendTT
         CALL Paused
         User.DLBytes = K1&
         User.ULBytes = K0&
         EXIT SUB
  END SELECT
  TT$ = TT$ + BlockText2(350) + Commas$(CanDL&) + BlockText2(351)
  K = DLTime
  kk$ = Null$
  IF User.Elapsed > 0 THEN kk$ = Short$(862) + STR$(User.Elapsed)
  IF User.MinCredits > 0 THEN kk$ = kk$ + Short$(898) + STR$(User.MinCredits)
  IF User.MinCredits < 0 THEN kk$ = kk$ + Short$(862) + STR$(- User.MinCredits)
  IF LEN(kk$) > 0 THEN kk$ = STR$(Levels(UserSL).MinsPerDay) + kk$ + Short$(863)
  TT$ = TT$ + kk$ + STR$(K) + Short$(326) + kz$ + BlockText2(352) + _
        Connect$ + BlockText2(353)
  CALL SendTT
  '
  ' K$  is the total download list (doesn't include K0$).
  ' K0$ current file name edit buffer.
  ' K& is the total size of the downloads.
  ' K2 is the Files.IDX file location if the file in K0$ was found.
  ' K is the users' available download minutes.
  '
  K$ = Null$
  K& = 0
  K2 = 0
  DO
    IF K2 <> -2 THEN CALL GetFileName(K0$,K2)
    SELECT CASE K2
      CASE -2
           SELECT CASE LEN(K$)
             CASE IS > 0
                  K4 = WordsCnt(K$)
                  TT$ = WordsGet$(K$,K4,K0)
                  K1 = BiSearch(3,0,Form$(1201,TT$))
                  IF NOT (BitTest(FileIDX.Attr,2) _
                     OR (BitTest(FileIDX.Attr,9) AND ConnectCPS >= 800)) _
                     THEN K& = K& - FileIDX.FSize
                  K1 = LEN(TT$)
                  K$ = LEFT$(K$,K0 - 1)
                  CALL Wipe(K1 + 2)
                  TT$ = Short$(334) + Commas$(K&) + Short$(335) + _
                        STR$(K& \ (ConnectCPS * 57&)) + _
                        Short$(1026 + (K& \ (ConnectCPS * 57&) = 1))
                  IF K4 = 2 THEN TT$ = Short$(337) + TT$ _
                            ELSE TT$ = STR$(K4 - 1) + Short$(338) + TT$
                  TT$ = Short$(339) + Form$(4902,TT$) + Short$(346)
                  CALL SendTT
           END SELECT
           K2 = 0
      CASE IS > 0
           K$ = K$ + K0$ + C32$
           IF NOT (BitTest(FileIDX.Attr,2) _
              OR (BitTest(FileIDX.Attr,9) AND ConnectCPS >= 800)) _
              THEN K& = K& + FileIDX.FSize
           K4 = WordsCnt(K$)
           TT$ = Short$(334) + Commas$(K&) + Short$(335) + _
                 STR$(K& \ (ConnectCPS * 57&)) + _
                 Short$(1026 + (K& \ (ConnectCPS * 57&) = 1))
           IF K4 = 1 THEN TT$ = Short$(337)  + TT$ _
                     ELSE TT$ = STR$(K4) + Short$(338) + TT$ 
           TT$ = Short$(339) + Form$(4902,TT$)
           CALL SendTT
           CALL AI(2,Null$,K,0,0,0,0,K&,0&)
           '
           ' If we couldn't help them, tell them so.
           '
           IF K& > (K * (ConnectCPS * 57&)) _
              THEN TT = 356 : _
                   K2 = -2 _
              ELSE IF K& > CanDL& THEN TT = 357 : _
                                       K2 = -2 _
                                  ELSE TT = 10349
           CALL SendTT
           IF LEN(K$) > 40 AND K2 <> -2 THEN K2 = -1
    END SELECT
  LOOP UNTIL K2 = -1 OR NoCarrier
  User.DLBytes = K1&
  User.ULBytes = K0&
  IF (LEN(K$) = 0 AND LEN(K0$) = 0) OR NoCarrier THEN EXIT SUB
  CALL KillFile(FileNames$(49))
  K2 = FileOpen(FileNames$(49))
  K = 0
  'K& = 0
  K5 = FileOpen(FileNames$(4))
  FOR K0 = 1 to DirsSize
    FOR K1 = 1 TO WordsCnt(K$)
      SELECT CASE FindF(RTRIM$(FileBases(K0).Path) + WordsGet$(K$,K1,K3),FFile)
        CASE IS <> 0
             K3 = GetFilePassWord(BiSearch(3,0,FFile.FName))
             IF K3 <> 0 _
                THEN K = K + 1 : _
                     CALL FilePutSEnd(K2,RTRIM$(FileBases(K0).Path) + FFile.FName + C1310$)
              'or, instead of the previous two statements, possibly use:
              '
              'DO : _
              '  CALL FilePutSEnd(K2,RTRIM$(FileBases(K0).Path) + FFile.FName + C1310$) : _
              '  K = K + 1 : _
              '  K& = K& + FFile.FSize : _
              'LOOP UNTIL FindF(Null$,FFile) = 0
              '
              ' The above allows the handling of wildcards--since I don't like
              ' them, the TGet's farther back would need to be changed to make
              ' use of them (include ? and *).  Heck, the whole previous
              ' routine would need re-writing, or some sort of exit after a
              ' wildcard file name is entered.  My limits provide the 'necessity'
              ' of users 'hanging around' for extremely long download sessions.
              ' Allowing wildcards would provide no deterent to users spending
              ' hours in massive download sessions.  K and K& above can also be
              ' used to make a 'x downloads totaling y bytes ready to send' type
              ' of output line.
              '
      END SELECT
    NEXT
  NEXT
  CALL FileClose(K2)
  CALL FileClose(K5)
  IF K = 0 THEN TT = 358 : _
                CALL SendTT : _
                EXIT SUB
  TT = 359
  K = GetYNTT
  TT = 335
  K1 = 2
  CALL ShellDownload(K1)
  IF K AND K1 = -1 THEN CALL AutoLogoff

END SUB
        '
        '* * * *

