; Copyright (c) 1991-1992, John David Rohner.  All rights reserved.

;
; This routine will open a file using DOS's file handle abilities.
;
; Usage:  Result% = FileOpen (FileName$)
; Declare:  DECLARE SUB FileOpen (FileName$)
;
; Where FileName$ is a string containing the drive\path\filename of the file
; to open.  Result% contains the file handle DOS has given us to use.
;
; If the file doesn't exist, it will be created.  If the string is null,
; nothing is done, and 3D42H is returned.
;

.Model Medium, Basic
.Code


DGROUP      group   _DATA

_DATA       segment word public 'DATA'

FileNam2Buf DB      65 dup (0)

_DATA       ends

;
; Actual program code begins.
;

            PUBLIC  FileOpen          ;Make this routine available to LINK.

FileOpen    proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp
            cld                       ;Move forward in string.

            mov     si,[bp + 06]      ;Descriptor of FileName$.
            lodsw                     ;Put it's size
            xchg    cx,ax             ; in CX.
            jcxz    Done              ;Do nothing if null.

            push    cx                ;Save the length for later.
            lodsw                     ;Get the address for FileName$
            xchg    si,ax             ; in SI for later.

            push    ds                ;STOSB wants ES:DI,
            pop     es                ; so give it ES,
            lea     di,FileNam2Buf    ; and DI for FileNam2Buf.
            push    di                ;Save it for the MOVSB.
            xor     ax,ax             ;Clear out the filename area.
            mov     cx,20H            ;32 x 2 bytes.  This allows us to not
            rep     stosw             ;need an ASCIIZ file name--we always
                                      ;give DOS 64 characters and a CHR$(0).

            pop     di                ;Location of FileNam2Buf.
            pop     cx                ;Get our length back.
            mov     dx,di             ;Save location for the DOS call.
            rep     movsb             ;Copy (ES:DI) <- (DS:SI).

            mov     ax,3D42H          ;Subfunction 3DH.
                                      ;Modes: Read/Write Access
                                      ;       Sharing Deny None
                                      ;       Subprocesses Inherit
            int     21H               ;DOS Services: Open a file handle.

            cmp     ax,0002           ;If AX <> 2,
            jne     Done              ;  then we succeeded, so exit.

            mov     ah,3CH            ;Subfunction 3CH.
            xor     cx,cx             ;Normal file attributes.
            int     21H               ;DOS Services: Create a file.
                                      ;Also returns a handle.

      Done: pop     bp
            ret     2                 ;Pop-return past our input parameter.

FileOpen    endp                      ;End of routine.

End

