;for now, this can only handle files up to 64k.  To fix, need a looping
;file read and file write--but first need to modify the sort to handle
;> 64k.
;DECLARE SUB FileSort (BYVAL Handle%,BYVAL RecSize%)


.Model Medium
.Code

DGROUP      group   _DATA

_DATA       segment word public 'DATA'

FileSize    DW      0

_DATA       ends


extrn       B$SETM:far                ;From Basic PDS 7.x


            PUBLIC  FileSort          ;Make this routine available to LINK.

FileSort    proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp
            ;
            ; Get size of file (in bytes and paragraphs).
            ;
            xor     cx,cx
            mov     dx,cx
            mov     bx,[bp + 08H]
            mov     ax,4202H          ;Subfunction to get a file size.
            int     21h               ;Have DOS Services  do it.
            mov     FileSize,ax       ;DX:AX = file size.
            mov     bx,16
            div     bx                ;AX = DX:AX \ 16 = paragraphs.
            or      ax,ax
            jz      Done
            ;
            ; Allocate the memory.
            ;
            mov     bx,ax             ;Paragraphs (size \ 16) to allocate.
            inc     bx                ;For possible remainder.
            xor     ax,ax
            cwd   
            push    dx
            push    ax
            call    B$SETM            ;DX:AX = SetMem(0&)  to get max avail.
            push    dx                ;Save for when to release.
            push    ax
            mov     ax,FileSize
            inc     ax                ;Adjustment for method.
            add     ax,16             ;For possible remainder.
            neg     ax
            cwd
            push    dx
            push    ax
            call    B$SETM            ;DX:AX = SetMem(-FileSize)
            mov     ah,48H            ;Subfunction to allocate memory.
            int     21h               ;Have DOS Services do it.
            jc      D1                ;An error, be safe, exit.
            push    ax                ;Store the returned segment start.
            mov     es,ax
            ;
            ; Go to start of file.
            ;
            xor     cx,cx
            mov     dx,cx
            mov     bx,[bp + 08H]
            mov     ax,4200H          ;Subfunction to seek location in file.
            int     21h               ;Have DOS Services do it.
            ;
            ; Read the file into memory.
            ;
            mov     bx,[bp + 08H]
            mov     ah,3FH            ;Subfunction to read from a file.
            mov     cx,FileSize
            push    ds
            push    es
            pop     ds
            int     21h               ;Have DOS Services do it.
            pop     ds
            ;
            ; Sort the memory.
            ;
            mov     di,FileSize
            mov     dx,[bp + 06H]
            sub     di,dx
            push    ds
            push    es
            pop     ds
            call    QSort
            pop     ds
            ;
            ; Go to start of file.
            ;
            xor     cx,cx
            mov     dx,cx
            mov     bx,[bp + 08H]
            mov     ax,4200H          ;Subfunction to seek location in file.
            int     21h               ;Have DOS Services do it.
            ;
            ; Write the memory back out to disk.
            ;
            mov     bx,[bp + 08H]
            mov     ah,40H            ;Subfunction to write to a file.
            mov     cx,FileSize
            push    ds
            push    es
            pop     ds
            int     21h               ;Have DOS Services do it.
            pop     ds
            ;
            ; De-allocate the memory.
            ;
            pop     es                ;Recover memory segment start.
            mov     ah,49H            ;Subfunction to release memory.
            int     21h               ;Have DOS Services do it.
            call    B$SETM            ;DX:AX = SetMem(MAX&)  restore all mem.
            jmp     Done

        D1: pop     ax
            pop     ax

      Done: pop     bp
            ret     4                 ;Pop-return past our input parameter.

FileSort    endp                      ;End of routine.



;
;Subroutine, internal to FileSort, to QuickSort a memory segment.
;At present, it only handles up to a single 64k segment and 32767 records.
;Call with: DS:DI = address of start of last record.
;           DX    = size of record.
;           The first element is assumed to be at DS:0000.
;Comparisons always start with the first character of the record.
;
;This is essentially Robert Sedgewick's non-recursive QuickSort algorithm
;From pages 106 and 110 of Algorithms.
;He mentions three improvements that I haven't implemented:
;  1. Ignore partions of size 1.
;  2. Use Insertion sort for small partitions.
;  3. Median-of-three partioning schemes (either random or other).
;If I expected really large numbers of records, these would be useful.  But
;with this implementation, it's too much extra code and time for the job.
;

QSort       proc    near

            mov     ax,0FFFFH        ;End-of-stack is -2's.
            push    ax               ;Push end-of-stack SI
            push    ax               ;Push end-of-stack DI
            xor     si,si            ;Start at DS:0000

        R1: cmp     si,di            ;If left boundary is smaller than right,
            jl      R2               ; then sort the partition.
            pop     di               ; else pop off new partition coordinates.
            pop     si
            jmp     R8               ;Go see if we're done.
        
            ;
            ; Sort the file (under the guise of finding the next partition BX).
            ; Improving this is the only real speed improvement possible
            ; (exceptions noted above).
            ; The goal is to produce two partitions containing unsorted
            ; records--but all in partition 1 are smaller than partition 2, and
            ; all in partition 2 are smaller than partition 1.
            ;
            ; Partition algorithm used:
            ;   I = LEFT - 1
            ;   J = RIGHT
            ;   zz:
            ;   do : I = I + 1
            ;   loop until a(I) >= a(RIGHT)
            ;   do : J = J - 1
            ;   loop until a(J) <= a(RIGHT)
            ;   IF J <= I THEN SWAP (a(I),a(J)) : _
            ;                  GOTO zz
            ;   SWAP a(RIGHT),a(I)
            ;
        R2: push    si           ;Save left boundary.
            mov     bx,si        ;Starting at left boundary.
            sub     bx,dx        ;Adjustment for method.
            mov     si,di        ;Starting at right boundary.
        R3: push    si           ;Now SI is the right partition boundary.
            ;
            ; Move in the left side of the partition until we come across a
            ; record that is larger than the one on the right side.  The main
            ; "partition handling"/strength of the code.
            ;
        R4: mov     cx,dx
            add     bx,dx        ;Compare the next one with DS:DI.
            push    di
            mov     si,bx
            repz    cmpsb        ;Compare the DS:DI and DS:BX strings.
            pop     di
            jl      R4           ;Until it's greater than or equal.
            ;
            ; Move in the right side of the partition until we come across a
            ; record that is smaller than the one on the left side.  More
            ; minor, takes advantage of our last swap.
            ;
            pop     si
        R5: mov     cx,dx
            sub     si,dx        ;Starting with the previous one.
            push    di
            push    si
            repz    cmpsb        ;Compare the DS:DI and DS:SI strings.
            pop     si
            pop     di
            jg      R5           ;Until it's smaller than or equal.
            ;
            ; If we haven't crossed, then swap the records and continue
            ; processing the partition.
            ;
            cmp     si,bx        ;If no more partition,
            jle     R6           ; then quit
            call    Exch         ;Swap the DS:SI and DS:BX strings.
            jmp     R3           ;Do next string.
        R6: mov     si,di
            call    Exch         ;Swap the DS:SI and DS:BX strings.
            pop     si

            ;
            ; We have two partitions (SI->BX and BX<-DI), one we put on the
            ; stack, one we go back and process.
            ;
            mov     ax,bx
            sub     ax,si        ;(BX - SI) = size of partition 1.
            mov     cx,di
            sub     cx,bx        ;(DI - BX) = size of partition 2.
            cmp     ax,cx        ;Find which partition is larger.
            jle     R7
            push    si           ;Push LEFT partition boundary onto stack.
            mov     si,bx
            add     si,dx        ;Set LEFT = boundary+1.
            sub     bx,dx
            push    bx           ;Push boundary-1 onto the stack.
            jmp     R8
        R7: mov     ax,bx
            add     ax,dx
            push    ax           ;Push boundary+1 onto the stack.
            push    di           ;Push RIGHT partition boundary onto stack.
            mov     di,bx
            sub     di,dx        ;Set RIGHT = boundary-1.

        R8: cmp     di,0FFFFH    ;If DI = -1 (65534) then we're done,
            jne     R1           ;otherwise we process the smaller partition.

            ret

QSort       endp



;
;Subroutine, internal to QSort, to exchange two records.
;Called with: DS:SI and DS:BX containing the record locations.
;             DX containing the record length.
;

Exch        proc    near
            mov     cx,dx
            push    bx
            push    si
       ER1: mov     al,[si]
            xchg    al,[bx]
            mov     [si],al
            inc     bx
            inc     si
            loop    ER1
            pop     si
            pop     bx
            ret
Exch        endp

End

