' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
'Various small formatting routines:
'  AddrToInt$
'  AnsiLocStr$
'  AttrToInt
'  Commas$
'  CRsToSpaces
'  DateToInt
'  ExpandFileName$
'  FidoForm$
'  Form$
'  Form1$
'  Form2$
'  Form3$
'  IntToAttr$
'  IntToPhone$
'  KwazyColor$
'  MakePathName$
'  NCR$
'  ReplaceCharacters
'  ReplaceStrings
'  RightTime$
'  Sq$
'  StripAnsi$
'  StripLeft$
'  StripRight$
'  UnSq$
'  Val2&




        '* * * * * *
        ' This routine takes a node address in long integer form and
        ' returns with it in three integers form and in string form.
        '
        ' p&  node address to use
        '
        ' p   zone
        '
        ' p0  net
        '
        ' p1  node
        '
        ' Long-integer node address form:
        '   32 bit word (read from left to right):
        '     First 3 bits = zone (values 0 to 7)
        '     Next 14 bits = net (values 0 to 16383)
        '     Final 15 bits = node (values 0 to 32767)
        '   Can recoup a bit off the node probably.  Only a couple
        '   net or node numbers actually exceed 8k, also.
        '   Clean this up when do it in assembly--am losing zone bit
        '   (I estimate) and will need to fix that.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION AddrToInt$ (p&,p,p0,p1)

  p1 = p&                                       'Make addr an integer.,
  p1 = BitsShr(BitsShl(p1,1),1)                 'Clear off a net bit, get node.
  p0 = p& \ 32768&                              'Clear off node bits. (lost 32nd bit!)
  p = BitsShr(p0,13)                            'Shift and get our zone.
  p0 = BitsShr(BitsShl(p0,3),3)                 'Shift and get our net
  AddrToInt$ = FidoForm$(p,p0,p1)

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will convert two numbers into an ansi location
        ' placement string.
        '
        '     p1  x-coordinate value
        '     p2  y-coordinate value
        '
        ' Date last checked for perfection: Sep 5 1992
        '
FUNCTION AnsiLocStr$ (p1,p2)

  AnsiLocStr$ = Short$(685) + LTRIM$(STR$(p1)) + Short$(690) + _
                LTRIM$(STR$(p2)) + Short$(864)

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will convert a string to an integer according
        ' to the bit formula: 1234567890ABCDEF.
        '
        ' p$  is the input string.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION AttrToInt% (p$)

  k = 0
  k$ = UCASE$(p$)
  FOR k0 = 1 to 16
    IF StrSrch(1,k$,MID$(Short$(812),k0,1)) > 0 THEN CALL BitSet(k,k0)
  NEXT
  AttrToInt = k

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will add commas to a number, returning a
        ' string.
        '
        ' p&  number to use.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION Commas$ (p&)

  k$ = STR$(p&)
  k = LEN(k$)
  IF k > 4 THEN k$ = LEFT$(k$,k - 3) + Short$(501) + RIGHT$(k$,3)
  IF k > 7 THEN k$ = LEFT$(k$,k - 6) + Short$(501) + RIGHT$(k$,7)
  IF k > 10 THEN k$ = LEFT$(k$,k - 9) + Short$(501) + RIGHT$(k$,11)
  Commas$ = LTRIM$(k$)

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will 'unwrap' a message so it can be
        ' 're-wrapped'.  That is, it converts all CR's to spaces.
        ' Used for such things as Reviews.
        '
        ' The routine does try to preserve 'hard' CR's--a 'hard' CR is
        ' a 'really hard CR/LF', it's a blank line.  The routine will
        ' remove the blank lines, but it won't tack the new line onto
        ' the end of the previous line--they'll be separated by a CR.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB CRsToSpaces

  k0 = LEN(MessageBody$) - 3
  k = StrSrch1(MessageBody$,13)
  WHILE k > 0 AND k < k0
    IF AscVal(MID$(MessageBody$,k + 1,1)) <> 32 _
       THEN MID$(MessageBody$,k,1) = C32$
    k = StrSrch(k + 1,MessageBody$,C13$)
  WEND

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will convert the date in string form to
        ' integer-date form.
        '
        ' p$  the string to convert.
        '
        ' Will convert 'dd-mm-yy' and 'dd-mm-yyyy'.
        '
        ' Date last checked for perfection: Sep 22 1992
        '
FUNCTION DateToInt% (p$)

  DateToInt = DateInt(Val2&(MID$(p$,4,2)),Val2&(LEFT$(p$,2)),Val2&(p$) - 80)

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will take 'filename.exe' and make
        ' 'filename ext', or 'file.ext' to make 'file     ext', and
        ' 'file' to make 'file        '.
        '
        ' p$  string to process
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION ExpandFileName$ (p$)

  k = StrSrch1(p$,46)
  IF k = 0 THEN ExpandFileName$ = Form$(1201,p$) _
           ELSE ExpandFileName$ = Form$(901,LEFT$(p$,k - 1)) + _
                                  Form$(301,MID$(p$,k + 1))

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will make a FidoNet address from 3 integers.
        '
        ' p1  zone.  If zero, then the BBS's zone is used.
        '     If negative, then add a '@' to the start of the output.
        '
        ' p2  node.  If negative, then add an '@FidoNet.Org' to
        '     the end of the output.
        '
        ' p3  net.
        '
        ' returns with: [@]zzzzz:nnnnn/ttttt[@FidoNet.Orj]
        '
        ' Date last checked for perfection: Oct 25 1992
        '
FUNCTION FidoForm$ (p1,p2,p3)

  IF p1 = 0 THEN k = Settings.Addr \ 32768& : _
                 p1 = BitsShr(k,13)
  IF p1 < 0 THEN p1 = - p1 : _
                 k$ = Short$(360) _
            ELSE k$ = Null$
  IF p2 < 0 THEN p2 = - p2 : _
                 k0$ = Short$(939) _
            ELSE k0$ = Null$
  FidoForm$ = k$ + LTRIM$(STR$(p1)) + Short$(229) + LTRIM$(STR$(p2)) + _
              Short$(674) + LTRIM$(STR$(p3)) +  k0$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine handles a variety of minor formatting of text.
        '
        ' p  Breaks up into K0 and K:
        '    k   maximum size of returned string (0 means 'whatever
        '        comes naturally'--except when 8 is used).
        '    k0   attribute (what to do):
        '         1 then LSET the result in spaces to size K.
        '         2 then RSET the result in spaces to size K.
        '         4 do a Wordscase on it. 
        '         8 to center it.
        '        16 to get/use only the first word.
        '        32 to add a leading space.
        '        64 to add a trailing space.
        '        can't use combinations that add up to > 99.
        '
        ' p$ is the input string.
        '
        ' The Centering routine is kinda slow--but it needs to be able
        ' to handle null strings as well as strings longer than k, so
        ' the mathematical alternative was really quite complex.
        '
        ' Any leading spaces are removed (the string is first left
        ' justified before operations begin).
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION Form$ (p,p$)

  k = p \ 100
  k0 = p - k * 100
  IF BitTest(k0,3) THEN k$ = NCR$(p$) _ 
                   ELSE k$ = LTRIM$(RTRIM$(p$))
  IF BitTest(k0,5) THEN k$ = k$ + C32$ : _
                        k$ = LEFT$(k$,StrSrch1(k$,32) - 1)
  IF BitTest(k0,1) THEN k$ = StripLeft$(k$ + SPACE$(k),k)
  IF BitTest(k0,2) THEN k$ = StripRight$(SPACE$(k) + k$,k)
  IF BitTest(k0,4) THEN WHILE StripLen(k$) < k : _
                          k$ = C32$ + k$ + C32$ : _
                        WEND : _
                        k$ = StripRight$(k$,k)
  IF BitTest(k0,6) THEN k$ = C32$ + k$
  IF BitTest(k0,7) THEN k$ = k$ + C32$
  Form$ = k$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This is a couple of useful formatting routines.
        '
        ' p   1 to 5 can be used for specific stuff (maybe I can go
        '     higher if needed):
        '     1 return NCR'd 'last name' (last word).
        '     2 uppercase and trim a string.
        '     3 visibly shrink a message subject.
        '
        ' p$  string to use
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION Form1$ (p,p$)

  SELECT CASE p
    CASE 1
         k$ = NCR$(p$)
         Form1$ = MID$(k$,StrSrchR(k$,32) + 1)
    CASE 2
         Form1$ = UCASE$(LTRIM$(RTRIM$(p$)))
    CASE 3
         K = LEN(p$)
         WHILE LEN(Sq$(LEFT$(p$,K))) > LEN(Message.MsgSubject)
           K = K - 1
           CALL Wipe(1)
         WEND
         K0 = LEN(RTRIM$(UnSq$(Message.MsgSubject))) - K
         IF K0 > 0 THEN TT$ = SPACE$(K0) : _
                        CALL SendTT
         Form1$ = Sq$(LTRIM$(RTRIM$(LEFT$(p$,K))))
    CASE ELSE
         Form1$ = p$ + Short$(213) + LTRIM$(STR$(p - StripLen(p$))) + Short$(214)
  END SELECT

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine RSET's and comma-deliminate's a long integer.
        '
        ' p   size of resulting string
        '
        ' p&  number to use
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION Form2$ (p,p&)

  Form2$ = RIGHT$(SPACE$(p) + Commas$(p&),p)

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine returns a formatted string such that the number
        ' is right justified into a width of three characters.
        '
        ' p  number to use.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION Form3$ (p)

  Form3$ = RIGHT$(C32$ + STR$(p),3)

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine returns a formatted string such that the
        ' number is right justified into a width of two or three
        ' characters with leading zeros.  And other formats.
        '
        ' p   which format to use
        '
        ' p0  number to use
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION Form4$ (p,p0)

  SELECT CASE p
    CASE 2 : Form4$ = RIGHT$(STR$(100 + p0),2)                ' '##',    '00'
    CASE 3 : Form4$ = RIGHT$(STR$(1000 + p0),3)               ' '###',   '000'
    CASE 4 : Form4$ = LEFT$(STR$(p0) + C32$,4)                ' ' #  ',  ' ###'
    CASE 5 : Form4$ = LEFT$(STR$(p0) + Short$(188),5)         ' ' #   ', ' ####'
    CASE 6 : Form4$ = RIGHT$(Short$(296) + STR$(p0),5) + C32$ ' '    # '
  END SELECT

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will convert an integer to a 16 byte string.
        ' The formula is 1234567890ABCDEF and what isn't on will have
        ' a space.
        '
        ' p   is the integer to use.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION IntToAttr$ (p)

  k$ = Short$(812)
  FOR k = 1 to 16
    IF NOT BitTest(p,k) THEN MID$(k$,k,1) = C32$
  NEXT
  IntToAttr$ = k$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will convert a long integer phone number into a
        ' string.
        '
        ' p&  is the long integer form of the phone number to use.
        '
        ' Long distance phone numbers have their first and second
        ' digit swapped when it's a long integer.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION IntToPhone$ (p&)

  k$ = LTRIM$(STR$(p&))
  IF LEN(k$) = 9 THEN k$ = Short$(628) + k$
  IF LEN(k$) = 10 _
     THEN k$ = MID$(k$,2,1) + LEFT$(k$,1) + MID$(k$,3,1) + Short$(492) + _
               MID$(k$,4,3) + Short$(492) + RIGHT$(k$,4)
  IF LEN(k$) = 7 THEN k$ = LEFT$(k$,3) + Short$(492) + RIGHT$(k$,4)
  IF k$ = Short$(628) THEN k$ = Null$
  IntToPhone$ = k$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will return the next cycled color string.
        '
        ' p   last color used.
        '
        ' p0  background color being used.
        '
        ' returns with the color string to use.
        '
        ' Date last checked for perfection: Oct 24 1992
        '
FUNCTION KwazyColor$ (p,p0)

  p = p + 1
  IF p > 15 THEN p = 0
  IF p + 40 = p0 THEN p = p + 1
  IF p < 8 THEN k$ = Short$(175) + LTRIM$(STR$(30 + p)) _
           ELSE k$ = Short$(174) + LTRIM$(STR$(30 + p - 8))
  KwazyColor$ = k$ + Short$(690) + LTRIM$(STR$(p0)) + Short$(861)

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will make a file name out of two numbers.
        '
        ' p&  value for first 8 characters of file name.
        '
        ' p   value for last 3 characters of file name.
        '
        ' Date last checked for perfection: Oct 25 1992
        '
FUNCTION MakePathName$ (p&,p)

  MakePathName$ = Paths$(5) + LTRIM$(STR$(p&)) + Short$(379) + _
                  LTRIM$(STR$(p)) + Short$(811)

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' Combines both RTrim$ and WordsCase into a single function.
        '
        ' p$  string to use
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION NCR$ (p$)

  k$ = RTRIM$(p$)
  CALL WordsCase(k$)
  NCR$ = k$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine replaces characters in a string.
        '
        ' p$   string to do replacing on.
        '
        ' p    > -1 to replace a single character (p) with another
        '           single character (p0).
        '        -1 to replace a single character (p0) with a string of
        '           characters (p0$).
        '        -2 to replace a string of characters (p0$) with a
        '           single character (p0).
        '        -3 to replace a single character (p0) with nothing.
        '        -4 to replace a string of characters (p0$) with
        '           nothing.
        '
        ' p0$  to to replace with.
        '
        ' p0   charcter to replace with.
        '
        ' Date last checked for perfection: Sep 22 1992
        '
SUB ReplaceCharacters (p$,p,p0$,p0)

  SELECT CASE p
    CASE -1
         '
         ' Replace a single character with a string of characters.
         '
         k = StrSrch1(p$,p0)
         WHILE k > 0
           p$ = LEFT$(p$,k - 1) + p0$ + MID$(p$,k + 1)
           k = StrSrch1(p$,p0)
         WEND
    CASE -2
         '
         ' Replace a string of characters with a single character.
         '
         k$ = AscChr$(p0)
         k = StrSrch(1,p$,p0$)
         WHILE k > 0
           p$ = LEFT$(p$,k - 1) + k$ + MID$(p$,k + LEN(p0$))
           k = StrSrch(k,p$,p0$)
         WEND
    CASE -3
         '
         ' Replace a single character with nothing.
         '
         k = StrSrch1(p$,p0)
         WHILE k > 0
           p$ = LEFT$(p$,k - 1) + MID$(p$,k + 1)
           k = StrSrch1(p$,p0)
         WEND
    CASE -4
         '
         ' Replace a string of characters with nothing.
         '
         k = StrSrch(1,p$,p0$)
         WHILE k > 0
           p$ = LEFT$(p$,k - 1) + MID$(p$,k + LEN(p0$))
           k = StrSrch(k,p$,p0$)
         WEND
    CASE ELSE
         '
         ' Replace a single character with a single character.
         '
         k$ = AscChr$(p0)
         k = StrSrch1(p$,p)
         WHILE k > 0
           MID$(p$,k,1) = k$
           k = StrSrch1(p$,p)
         WEND
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine replaces all occurances of a string with
        ' another string within a string.
        '
        ' p$   String to modify.
        '
        ' p0$  String to search for.
        '
        ' p1$  String to replace with.
        '
        ' Date last checked for perfection: Sep 22 1992
        '
SUB ReplaceStrings (p$,p0$,p1$)

  k = LEN(p1$)
  k0 = StrSrch(1,p$,p0$)
  WHILE k0 > 0
    p$ = LEFT$(p$,k0 - 1) + p1$ + MID$(p$,k0 + k)
    k0 = StrSrch(k0 + k,p$,p0$)
  WEND

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will return with the time in 'human' format.
        '
        ' p$  contains the time to use in 'HH:MM:SS' format.
        '
        ' Returns with the time in 'HH:MM xm' format.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION RightTime$ (p$)

  IF LEN(p$) = 0 THEN k$ = LEFT$(TIME$,5) _
                 ELSE k$ = LEFT$(p$,5)
  k = Val2&(MID$(k$,1,2))
  k0 = Val2&(MID$(k$,3))
  SELECT CASE k
    CASE 0        : k$ = Short$(631) + MID$(k$,3) + Short$(632)
    CASE 1 TO 9   : k$ = MID$(k$,2) + Short$(632)
    CASE 10 TO 11 : k$ = k$ + Short$(632)
    CASE 12       : k$ = Short$(631) + MID$(k$,3) + Short$(145)
    CASE 13 TO 23 : k$ = LTRIM$(STR$(k - 12))  + MID$(k$,3) + Short$(145)
  END SELECT
  RightTime$ = k$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine compresses a text string.
        '
        ' p$ is the string to compress.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION Sq$ (p$)

  k$ = p$
  FOR k = 0 TO 127
    CALL ReplaceCharacters(k$,-2,MID$(SqString$,k * 2 + 1,2),128 + k)
  NEXT
  Sq$ = k$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine replaces ansi codes with spaces,
        ' returning a new string.
        '
        ' p$  is the string to work on.  Not changed.
        '
        ' returns with p$ without ansi codes.
        '
        ' Date last checked for perfection: Nov 6 1992
        '
FUNCTION StripAnsi$ (p$)

  k$ = p$
  K2 = LEN(k$)
  k = StrSrch1(k$,27)
  WHILE k > 0
    MID$(k$,k,1) = C32$
    k1 = k + 2
    DO
      MID$(k$,k1 - 1,1) = C32$
      k0 = AscVal(MID$(k$,k1,1))
      k1 = k1 + 1
    LOOP UNTIL k0 <> 59 AND (K0 < 48 OR k0 > 57) OR K1 > K2
    MID$(k$,k1 - 1,1) = C32$
    k = StrSrch1(k$,27)
  WEND
  StripAnsi$ = k$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine returns LEFT$(st$,i%) while ignoring color
        ' codes.
        '
        ' p$  is the string to examine.
        '
        ' p   is the 'true' length we wish to utilize.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION StripLeft$ (p$,p)

  k = 0
  k0 = 0
  DO
    k0 = k0 + 1
    SELECT CASE AscVal(MID$(p$,k0,1))
      CASE 125
           k1 = AscVal(MID$(p$,k0 + 1,1))
           IF (k1 > 48 AND k1 < 58) THEN k0 = k0 + 1 _
                                         ELSE k = k + 1
      CASE 27
           DO : k0 = k0 + 1
           LOOP UNTIL StrSrch(1,Short$(814),MID$(p$,k0,1)) > 0 OR k0 = LEN(p$)
      CASE ELSE : k = k + 1
    END SELECT
  LOOP UNTIL k = p OR k0 = LEN(p$)
  StripLeft$ = LEFT$(p$,k0)

END FUNCTION
        '
        '* * * *




        '* * * * * *
        'This routine returns RIGHT$(st$,i%) while ignoring color
        ' codes.
        '
        ' p$  is the string to process.
        '
        ' p   is the length (no color codes) we want.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION StripRight$ (p$,p)

  k$ = p$
  WHILE StripLen(k$) > p
    SELECT CASE AscVal(k$)
      CASE 125 : k = AscVal(MID$(k$,2,1))
                 IF (k > 48 AND k < 58) THEN k$ = MID$(k$,2)
      CASE 27  : DO : k$ = MID$(k$,2)
                 LOOP UNTIL StrSrch1(Short$(814),AscVal(k$)) > 0 OR k$ = Null$
    END SELECT
    k$ = MID$(k$,2)
  WEND
  StripRight$ = k$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' The routine uncompresses text compressed with Sq.
        '
        ' p$ is the text to uncompress.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION UnSq$ (p$)

  k$ = STRING$(UnSqPlus(p$),4) + p$
  CALL UnSqDo(k$,SqString$)
  UnSq$ = k$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will convert a string to a number.
        '
        ' p$  is the number in string form to use.
        '
        ' This routine returns the value as seen from the opposite
        ' end, and stops when it reaches the first backwards
        ' non-number.  Under VAL() '123xyz' = 123, here it = 0.  Under
        ' VAL() 'xyz123' = 0, here it equals 123.
        '
        ' Found no use for negatives.  So, the negative symbol will be
        ' just another 'nonnumeric stop flag'.
        '
        ' Trailing spaces are ignored.
        '
        ' Leading spaces and zero's are ignored.  Although '  xx yy'
        ' will still only return yy, as the space between two numbers
        ' is a stopper.
        '
        ' It only works with integers, thus sending '101.50' will
        ' return 50.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION Val2& (p$)

  k& = 0
  k0& = 1
  FOR k = LEN(RTRIM$(p$)) TO 1 STEP -1
    k0 = StrSrch1("0123456789",AscVal(MID$(p$,k,1)))    'Don't use Short$().
    IF k0 = 0 THEN EXIT FOR
    k& = k& + k0& * (k0 - 1)
    k0& = 10 * k0&
  NEXT
  Val2& = k&

END FUNCTION
        '
        '* * * *

