' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' Included in this package:
'   Initializer1
'   BootStuff
'   BootUpStatus




        '* * * * * *
        ' This routine will initialize various variables.  It will
        ' also do general array loading of externally defined stuff.
        '
        ' It's called when the BBS is started up, and when the system
        ' is restarted after a shutdown (for doors).
        '
        ' Date last checked for perfection: Sep 16 1992
        '
SUB Initializer1

  ' 
  ' Make whatever strings or arrays I can FAR.
  '
  '$DYNAMIC
  '
  ' Turn the cursor off--a cursor jumping all over the screen is not a pretty
  ' sight.
  '
  CALL CursorOff
  '
  ' CHR$ variables.
  '
  C0$   = AscChr$(0)
  C1$   = AscChr$(1)
  C2$   = AscChr$(2)
  C3$   = AscChr$(3)
  C4$   = AscChr$(4)
  C7$   = AscChr$(7)
  C8$   = AscChr$(8)
  C10$  = AscChr$(10)
  C13$  = AscChr$(13)
  C27$  = ""
  C32$  = " "
  Null$ = ""
  '
  ' Miscellaneous other variables.
  '
  K$ = SPACE$(256)
  FOR K = 0 to 255
    MID$(K$,K + 1,1) = AscChr$(K)
  NEXT
  AlphaTable$ = SPACE$(65) + MID$(K$,66,26) + "      " + MID$(K$,66,26) + SPACE$(133)
  C1310$      = C13$ + C10$
  HiStrip$    = LEFT$(K$,127) + SPACE$(129)
  HighFilter$ = SPACE$(127) + MID$(K$,128)
  '
  ' Read in the path/file information.  Load up Paths$() and FileNames$().
  '
  IF FindF("PATHS.DAT",FFile) = 0 THEN CALL BootStuff(1) : _
                                       CommPort = -1 _
                                  ELSE CommPort = 0
  DIM Paths$(12)
  DIM FileNames$(85)
  K0 = FileOpen("PATHS.DAT")
  K$ = SPACE$(40)
  FOR K = 1 TO 97
    CALL FileGetSLoc(K0,(K - 1) * 40&,K$)
    IF K < 13 THEN Paths$(K) = LTRIM$(RTRIM$(K$)) _
              ELSE FileNames$(K - 12) = LTRIM$(RTRIM$(K$))
  NEXT
  CALL FileClose(K0)
  '
  ' Load up the Short$() array from SHORT.TXT.
  '
  K = FileOpen(FileNames$(60))
  K& = FileLof&(K,1)
  IF FileLof&(K,1) < 1 _
     THEN CALL Ansi("[1;32mCould not find: " + FileNames$(60) + C1310$) : _
          CALL Ansi("Please be sure the d:\BBS directory tree structure is correct.") : _
          SYSTEM
  K1& = K&
  DO : K0 = Val2&(LEFT$(FileGetLineR$(K,K&),4))
  LOOP UNTIL K0 > 0
  DIM Short$(K0)
  K0& = 0
  DO
    K$ = FileGetBlock$(K,K0&,K1&)
    K1 = 1
    K2 = StrSrch(K1,K$,C13$) - K1
    WHILE K2 > 0
      K0$ = MID$(K$,K1,K2)
      IF AscVal(K0$) <> 39 THEN Short$(Val2&(LEFT$(K0$,4))) = MID$(K0$,5)
      K1 = K1 + K2 + 2
      K2 = StrSrch(K1,K$,C13$) - K1
    WEND
  LOOP UNTIL K0& = K1&
  CALL FileClose(K)
  '
  ' Read in RUN_DOOR.BAT, see if we are returning or not.
  '
  K = FileOpen(FileNames$(54))
  NonStop = Val2&(FileGetLine$(K,0&))          'If not zero then don't show.
  CALL FileClose(K)
  K$ = Null$                            'So we don't distort initial string size.
  '
  ' Load up some stuff.  Done this way to help readablity (and keeps it in
  ' order).
  '
  FOR K = 1 TO 4
    SELECT CASE K
      CASE 1 : K0 = 77
      CASE 2 : K0 = 71
      CASE 3 : K0 = 20
      CASE 4 : K0 = 38
    END SELECT
    K1 = FileOpen(FileNames$(K0))
    SELECT CASE K
      CASE 1
           '
           ' Load up the compression string.
           '
           SqString$ = SPACE$(256)
           CALL FileGetSLoc(K1,0&,SqString$)
           CALL BootUpStatus(1)
      CASE 2
           '
           ' Read in the security level information.  Load up Levels().
           '
           LevelsSize = FileLof&(K1,16)
           DIM Levels(LevelsSize) AS LevelRecord
           FOR K2 = 1 TO LevelsSize
             CALL FileGetRec(K1,K2,16,Levels(K2))
           NEXT
      CASE 3
           '
           ' Read in the file areas.  Load up FileBases().
           '
           DirsSize = FileLof&(K1,184)
           DIM FileBases(DirsSize) AS FileBaseRecord
           FOR K2 = 1 TO DirsSize
             CALL FileGetRec(K1,K2,184,FileBases(K2))
           NEXT
      CASE 4
           '
           ' Read in the message bases.  Load up MsgBases().
           '
           BasesSize = FileLof&(K1,108) - 1
           DIM MsgBases(BasesSize) AS MessageBaseRecord
           FOR K2 = 0 TO BasesSize
             CALL FileGetRec(K1,K2 + 1,108,MsgBases(K2))
           NEXT
           UserMsgInfo$  = STRING$(BasesSize * 5 + 5,0)
           SELECT CASE CommPort
             CASE -1
                  FOR K2 = 1 TO BasesSize
                    IF BitTest(MsgBases(K2).SubType,4) _
                       THEN MID$(UserMsgInfo$,K2 * 4 + 1,4) = MKL$(-1)
                  NEXT
                  K2 = FileOpen(FileNames$(3))
                  CALL FilePutSLoc(K2,0&,UserMsgInfo$)
                  CALL FileClose(K2)
           END SELECT
    END SELECT
    CALL FileClose(K1)
  NEXT
  '
  ' Build initial batch files.
  '
  SELECT CASE CommPort
    CASE -1
         K = FileOpen(FileNames$(55))
         CALL FilePutSLoc(K,0&,Short$(171) + C1310$ + Short$(922) + C1310$ + _
                               FileNames$(54) + C1310$)
         CALL FileClose(K)
         K = FileOpen(FileNames$(54))
         CALL FilePutSLoc(K,0&,Short$(711) + C1310$)
         CALL FileClose(K)
  END SELECT
  '
  ' Read in the system settings and toggles.
  '
  K = FileOpen(FileNames$(75) + Form4$(3,1))
  CALL FileGetLoc(K,0&,259,Settings)
  IF CommPort = -1 THEN Settings.CommPort = 0 : _
                        Settings.DrDrives = AscChr$(65 + DrCurrent) : _
                        CALL FilePutLoc(K,0&,259,Settings)
  CALL FileClose(K)
  CommPort = 0
  DIM Toggles(5)
  K = FileOpen(FileNames$(13))
  CALL FileGetLoc(K,2300&,2,Toggles(1))
  CALL FileGetLoc(K,2302&,2,Toggles(2))
  CALL FileGetLoc(K,2283&,2,Toggles(3))
  CALL FileGetLoc(K,2281&,2,Toggles(4))
  CALL FileGetLoc(K,2279&,2,Toggles(5))
  CALL FileClose(K)
  '
  ' Tell the sysop what's happening.
  '
  IF NonStop > 0 AND NOT BitTest(Toggles(2),2) _
     THEN CALL Ansi(Short$(439))
  '
  ' The DIM's below set system maximum's.
  '
  DIM MsgPtr(Settings.MaxMessages) AS MessageInfo    'Total active messages.
  DIM FWork(Settings.MaxFilesInDir) AS FileInfo      'Max files per directory.
  DIM Work(Settings.MaxFilesInDir * 2)               'Simple integer workspace.
  DIM SWork$(Settings.MaxFilesInDir)                 'Simple string workspace.
  DIM BlockText&(99)                                 '99 max BLOCK.TXT blocks.
  DIM Handle(30)                                     '30 file handles.
  '
  ' Locate the positions of the various external text lines.
  ' Load up BlockText2().
  '
  ' BlockText2(700) AS STRING * 3 adds about 8K to the .EXE size over
  ' BlockText2$(700).  BlockText2$(700) reduces the string space by about 7K
  ' over BlockText2(700) AS STRING * 3.  I went with the string space savings
  '
  ' We save K for later.
  '
  K0 = FileOpen(FileNames$(6) + Form4$(3,1))
  K& = FileLof&(K0,1)
  DO : K = Val2&(LEFT$(FileGetLineR$(K0,K&),4))
  LOOP UNTIL K > 0
  CALL FileClose(K0)
  DIM BlockText2(K) AS STRING * 3
  K0 = FindF(FileNames$(6) + Form4$(3,1),FFile) 'C:\BBS\TEXT\LINES.001
  K1 = FindF(FileNames$(12) + Short$(885),FFile)  'C:\BBS\RAMTEXT\LINES001.$$$
  K2 = FindF(FileNames$(61) + Short$(886),FFile)  'C:\BBS\SYSTEM\INDEX\LINES001.IDX
  IF K0 <> K1 OR K0 <> K2 THEN CALL BootStuff(2)
  '
  ' Move RAM drive files to drive.
  '
  K0 = 1
  Work(K0) = FindF(Paths$(3) + Short$(645),FWork(K0))
  WHILE Work(K0) <> 0
    K0 = K0 + 1
    Work(K0) = FindF(Null$,FWork(K0))
  WEND
  FOR K1 = 1 TO K0 - 1
    K1$ = Paths$(3) + FWork(K1).FName
    K2$ = Paths$(4) + FWork(K1).FName
    IF Work(K1) <> FindF(K2$,FFile) _
       THEN CALL KillFile(K2$) : _
            K2 = FindF(K1$,FFile) : _
            IF DriveSpc&(K2$) < FFile.FSize _
               THEN CALL Ansi(C1310$ + Short$(436) + C1310$) : _
                    SYSTEM _
               ELSE CALL CopyFile(0,K1$,K2$)
  NEXT
  '
  ' Fix drive paths that are to be referenced on the ram drive.
  '
  SELECT CASE Paths$(3)
    CASE IS <> Paths$(4)
         K0 = LEN(Paths$(3))
         FOR K1 = 1 TO 85
           IF LEFT$(FileNames$(K1),K0) = Paths$(3) _
              THEN FileNames$(K1) = Paths$(4) + MID$(FileNames$(K1),K0 + 1)
         NEXT
         Paths$(3) = Paths$(4)
  END SELECT
  '
  ' Open our always-opened files.
  '
  Handle(6) = FileOpen(FileNames$(12) + Short$(885))
  Handle(3) = FileOpen(FileNames$(2))
  '
  ' Load, or build, the LINESxxx.IDX index.  Uses the K we created earlier.
  '
  K$ = FileNames$(61) + Short$(886)
  K0 = FindF(K$,FFile)
  IF K0 = 0 THEN CALL BootUpStatus(3) _
            ELSE CALL BootUpStatus(4)
  K1 = FileOpen(K$)
  FOR K2 = 1 TO K
    IF K0 = 0 THEN CALL FilePutSLoc(K1,(K2 - 1) * 3&,BlockText2(K2)) _
              ELSE CALL FileGetSLoc(K1,(K2 - 1) * 3&,BlockText2(K2))
  NEXT
  K2 = FileOpen(FileNames$(6) + Form4$(3,1))
  CALL SameDate(K2,K1)
  CALL FileClose(K1)
  CALL FileClose(K2)
  '
  ' Build the BLOCKxxx.IDX files.  Load up BlockText&().
  '
  K$ = FileNames$(62) + Short$(886)
  SELECT CASE FindF(FileNames$(7) + Form4$(3,1),FFile)
    CASE IS <> FindF(K$,FFile)
         CALL BootStuff(3)
    CASE ELSE
         CALL BootUpStatus(6)
         K = FileOpen(K$)
         K& = FileLof&(K,1)
         FOR K0 = 1 TO K&
           IF NonStop = 0 THEN K0& = K0 : _
                               CALL ShowTheGauge(K&,K0&)
           CALL FileGetRec(K,K0,4,BlockText&(K0))
         NEXT
         CALL FileClose(K)
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to initializer, does some of the
        ' work.
        '
        ' p  1 to rebuild PATHS.DAT from BLOCK.INI (very first time
        '      stuff).
        '    2 to rebuild LINES.$$$ from LINES.TXT.
        '    3 to rebuild BLOCK.IDX from BLOCK.TXT.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB BootStuff (p)

  SELECT CASE p
    CASE 1
         '
         ' Can't put any of the following strings into a file because we don't
         ' know for sure where SHORT.TXT will be.
         '
         CALL KillFile("BLOCK.001")
         K0 = FileOpen("BLOCK.INI")
         K1 = FileOpen("BLOCK.001")
         IF FileLof&(K0,1) > 0 _
            THEN CALL Ansi("[1;32mFirst time set up, hang on...") _
            ELSE CALL Ansi("[1;32mYou must have BLOCK.INI in this directory to recreate PATHS.DAT.") : _
                 SYSTEM
         K0$ = AscChr$(65 + DrCurrent) + ":\"
         K& = 0
         K0& = FileLof&(K0,1)
         DO
           K$ = FileGetBlock$(K0,K&,K0&)
           CALL ReplaceStrings(K$,"C:\",K0$)
           CALL ReplaceStrings(K$,"c:\",K0$)
           CALL FilePutSend(K1,K$)
         LOOP UNTIL K& = K0&
         CALL FileClose(K0)
         CALL FileClose(K1)
         CALL KillFile("BLOCK.INI")
         CALL KillFile("PATHS.DAT")
         K1 = FileOpen("PATHS.DAT")
         K2 = FileOpen("BLOCK.001")
         K9$ = C10$ + "46"
         K& = 0
         K0& = FileLof&(K2,1)
         DO : K$ = FileGetBlock$(K2,K&,K0&)
         LOOP UNTIL K& = K0& OR StrSrch(1,K$,K9$) > 0
         K& = K& - LEN(K$)
         DO : K$ = FileGetLine$(K2,K&)
         LOOP UNTIL K& = -1 OR LEFT$(K$,2) = "46"
         DO
           K$ = LEFT$(MID$(K$,3) + SPACE$(40),40)
           CALL FilePutSEnd(K1,K$)
           K$ = FileGetLine$(K2,K&)
         LOOP UNTIL K& = -1 OR LEFT$(K$,2) <> "46"
         CALL FileClose(K1)
         CALL FileClose(K2)
         CALL CopyFile(1,"BLOCK.001","TEXT\BLOCK.001")
         K0 = FindF("SYSTEM\*.DAT",FFile)
         WHILE K0 <> 0
           IF FFile.FSize < 8192 _
              THEN K0 = FileOpen("SYSTEM\" + FFile.FName) : _
                   K$ = SPACE$(FileLof&(K0,1)) : _
                   CALL FileGetSLoc(K0,0&,K$) : _
                   CALL ReplaceStrings(K$,"C:\",K0$) : _
                   CALL ReplaceStrings(K$,"c:\",K0$) : _
                   CALL FilePutSLoc(K0,0&,K$) : _
                   CALL FileClose(K0)
           K0 = FindF(Null$,FFile)
         WEND
    CASE 2
         CALL BootUpStatus(2)
         CALL KillFile(FileNames$(61) + Short$(886))
         K$ = FileNames$(12) + Short$(885)
         CALL KillFile(K$)
         K2 = FileOpen(FileNames$(6) + Form4$(3,1))
         K0 = FileOpen(K$)                              'LINES.$$$ image file.
         K0& = FileLof&(K2,1)
         K = 1
         K& = 0
         DO
           CALL ShowTheGauge(K0&,K&)
           K$ = FileGetLine$(K2,K&)
           IF AscVal(K$) <> 39 _
              THEN K1 = Val2&(LEFT$(K$,4)) : _
                   K$ = MID$(K$,5) + C1310$ : _
                   CALL FilePutSEnd(K0,K$) : _
                   IF K1 > 0 THEN BlockText2(K1) = C3$ + MKI$(K) : _
                                  K = K + LEN(K$) _
                             ELSE K = K + LEN(K$)
         LOOP UNTIL K& = -1
         CALL SameDate(K2,K0)
         CALL FileClose(K0)
         CALL FileClose(K2)
    CASE 3
         CALL BootUpStatus(5)
         K$ = FileNames$(62) + Short$(886)
         CALL KillFile(K$)
         K1 = FileOpen(FileNames$(7) + Form4$(3,1))
         K2 = FileOpen(K$)
         K1& = FileLof&(K1,1)
         K0 = 1
         K& = 0
         DO
           CALL ShowTheGauge(K1&,K&)
           K0& = K&
           K$ = FileGetLine$(K1,K&)
           IF Val2&(LEFT$(K$,2)) = K0 _
              THEN BlockText&(K0) = K0& + 1 : _
                   CALL FilePutRec(K2,K0,4,BlockText&(K0)) : _
                   K0 = K0 + 1
         LOOP UNTIL K& = -1
         CALL SameDate(K1,K2)
         CALL FileClose(K1)
         CALL FileClose(K2)
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to Initializer, displays the 'what's
        ' happening during initialization' messages.
        '
        ' p   which message to display.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB BootUpStatus (p)

  IF NonStop <> 0 THEN EXIT SUB
  SELECT CASE p
    CASE 1 : TT$ = Short$(887) + UnSq$(CopyRight) + C1310$ + Short$(906) + _
                   Form2$(17,FRE(0)) + Form2$(8,FRE(-2)) + Form2$(12,FRE(-1))
    CASE 2 : TT = 10949             'Short: Building line image.
    CASE 3 : TT = 10907             'Short: Building line index.
    CASE 4 : TT = 10908             'Short: Loading line index.
    CASE 5 : TT = 222               'Lines: Building block index.
    CASE 6 : TT = 223               'Lines: Loading block index.
  END SELECT
  CALL AnsiTT

END SUB
        '
        '* * * *

