' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' This file contains various inputting routines:
'   LineEditTT
'   Censor
'   GrammarCk
'   UnCompressWordRec




        '* * * * * *
        ' This routine will get from the user a line (or two) of text.
        '
        ' The CR/LF is removed.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
FUNCTION LineEditTT$ (p)

  km = tt
  km$ = tt$
  CALL SendTT             'Convience, since we always send something out first.
  K0$ = SPACE$(p)
  '
  ' Special processing.  Password, Name and Location all are stored as
  ' uppercase, and NameCase'd out.  Location and Name also have their
  ' input heavily filtered.
  '
  SELECT CASE LESpecial
    CASE 1      : K0 = 1 : LESpecial = 0              'description
    CASE IS < 0 : K0 = 2                              'password
    CASE 2      : K0 = 4 : LESpecial = 0              'name
    CASE 3      : K0 = 8 : LESpecial = 0              'location
    CASE ELSE   : K0 = 0
  END SELECT
  K1 = 0
  K$ = TIME$
  DO
    K3 = CommIn(0)
    SELECT CASE K0
      CASE 2 : IF K3 = 27 THEN K3 = -1
      CASE 4
           SELECT CASE K3
             CASE 9, 27, 33, 36, 37, 40, 41, 43, 48 TO 62, 64, 91 TO 96, _
                  123 TO 126, 128 TO 255 : K3 = -1
           END SELECT
           IF K3 = 35 AND (UserSL <> LevelsSize OR K1 > 0) THEN K3 = -1
      CASE 8
           '
           ' A filter, hopefully smaller than a 256 byte StrXLate string.
           '
           SELECT CASE K3
             CASE 9, 27, 33, 35 TO 37, 41 TO 43, _
                  60 TO 64, 91 TO 96, 123 TO 126, 128 TO 255 : K3 = -1
           END SELECT
    END SELECT
    '
    ' No excessive inactivity message since that would cause all sorts of
    ' data entry display problems should the user decide to continue the
    ' session.  Also, the cursor could be positioned anywhere.
    '
    K4 = ElapsedTime(K$,K2)
    IF K4 = Settings.TimeOut OR NoCarrier OR _
       (K0 = 4 AND K4 = Settings.LogoTimeOut) THEN CALL Quote : _
                                                   CALL HangUp : _
                                                   K0$ = Null$ : _
                                                   EXIT DO
    '
    ' Except for 8, 13, and 27, everything below 32 and above 126 is ignored.
    '
    SELECT CASE K3
      CASE 8, 127
           SELECT CASE K1
             CASE IS > 0
                  K1 = K1 - 1
                  CALL Wipe(1)
                  SELECT CASE LESpecial
                    CASE IS < 0
                         IF K1 = 1 THEN LESpecial = LESpecial - 5 _
                                   ELSE LESpecial = LESpecial - 1  
                         IF LESpecial < -32 + GetRndNum(5) _
                            THEN CALL Wipe(K1) : _
                                 TT$ = RTRIM$(User.UserName) + _
                                       GetLine$(171) : _
                                 CALL LogTT : _
                                 CALL HangUp     'For hackers...hangup.
                  END SELECT
           END SELECT
      CASE 13, 27, 32 TO 126
           K4 = -1
           IF K0 = 4 AND (K3 = 42 OR K3 = 63) _
              THEN CALL UserNameMatcher(K0$,k1,km,km$,k3) : _
                   K4 = 0
           SELECT CASE K3
             CASE 13, 32
                  IF K1 > 0 AND K0 = 1 THEN K2 = 2 : _
                                            CALL Censor(K1,K2,K0$) : _
                                            IF K2 = 0 THEN K4 = 0
                  IF K3 = 13 THEN K0$ = LEFT$(K0$,K1) : _
                                  IF K0$ = Short$(379) THEN K0$ = C32$
                  IF K3 = 13 THEN EXIT DO
           END SELECT
           K$ = TIME$
           SELECT CASE K4
             CASE -1
                  TT$ = AscChr$(K3)
                  K1 = K1 + 1
                  SELECT CASE K0
                    CASE 2, 4, 8
                         MID$(K0$,K1,1) = UCASE$(TT$)
                         TT$ = K0$
                         CALL WordsCase(TT$)
                         TT$ = MID$(TT$,K1,1)
                    CASE ELSE : MID$(K0$,K1,1) = TT$
                  END SELECT
                  CALL CommOut(TT$)
                  CALL AnsiTT
                  IF K0 = 2 AND LEFT$(K0$,K1) = RTRIM$(User.Password) _
                     THEN K0$ = LEFT$(K0$,K1) : _
                          EXIT DO
                  IF K1 > 2 THEN IF MID$(K0$,K1,1) = MID$(K0$,K1 - 2,1) _
                                    THEN CALL ForeignChar(K0$,K1)
                  IF K1 = p THEN EXIT DO
           END SELECT
    END SELECT
  LOOP UNTIL NoCarrier
  LineEditTT$ = K0$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will 'censor' out various stuff.
        '
        ' p   the ending position (1..n) of the current line of text
        '     ('length of p$').  The space or CR/LF having not yet
        '     been added.  The last character of the string we're
        '     going to check.
        '
        ' p0  1 to check only case.  Active grammar check also.
        '     2 to check a description (censor superlatives) and case.
        '     When censoring was done, p will point to the character
        '     before the the current word--this may be 0, it may point
        '     to a space or a CR.
        '
        ' p$  The string to check.
        '
        ' Checks the 'word' in p$ from p back to the previous blank
        ' space (checks the 'word' ending at p).  When censoring, you
        ' want to call this routine whenever a space or CR/LF is hit
        ' (that is, check it after each word) but before said space or
        ' CR/LF is displayed.
        '
        ' There are actually 3 levels: case, non-words, and
        ' superlatives.  If both non-words and superlatives are turned
        ' off, then so is case.  If either non-words or superlatives
        ' is turned on, then so is case.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB Censor (p,p0,p$)

  IF NOT BitTest(Toggles(1),9) AND NOT BitTest(Toggles(1),10) THEN EXIT SUB
  K1$ = LEFT$(p$,p)
  K1$ = WordsGet$(K1$,WordsCnt(K1$),K1)
  K2 = LEN(K1$)
  IF K2 = 0 OR p < 1 THEN EXIT SUB
  '
  ' Fix any blantant case errors.
  '
  IF K1$ = Short$(102) THEN MID$(p$,K1,1) = Short$(103)
  IF LEFT$(K1$,3) = Short$(51) THEN MID$(p$,K1,3) = Short$(111)
  FOR K6 = 50 TO 64
    K5 = LEN(Short$(K6))
    K0$ = RIGHT$(K1$,K5)
    IF K0$ = Short$(K6) AND K5 > 0 _
       THEN MID$(p$,K1 + K2 - K5,K5) = UCASE$(K0$) : _
            EXIT FOR
  NEXT
  IF p0 = 1 AND K1$ = Short$(882) THEN CALL BitToggle(User.Toggles,8) : _
                                       CALL Wipe(K2) : _
                                       p = p - K2 : _
                                       p0 = 0
  CALL StrXLate(K1$,AlphaTable$)
  '
  ' Eliminate 'non-words'.
  '
  SELECT CASE BitTest(Toggles(1),10)
    CASE -1
         '
         'L8TR became 'L TR'
         'C00L became 'C  L'
         'K00L became 'K  L'
         '
         FOR K5 = 40 TO 49
           K6 = LEN(Short$(K5))
           IF LEFT$(K1$,K6) = Short$(K5) AND K6 > 0 THEN CALL Wipe(K2) : _
                                                         p = p - K2 : _
                                                         p0 = 0 : _
                                                         EXIT FOR
         NEXT
  END SELECT
  IF p0 = 1 AND BitTest(User.Toggles,8) _
     THEN K1 = 0 : _
          K2$ = LTRIM$(RTRIM$(K1$)) : _
          CALL GrammarCk(K1,K2$) : _
          IF K1 = -1 THEN IF CommPort = 0 THEN CALL Ansi(C7$) _
                                          ELSE CALL CommOut(C7$)
  IF p0 < 2 OR NOT BitTest(Toggles(1),9) THEN EXIT SUB
  '
  ' Eliminate superlatives (for descriptions).  If any sub-words are bad, then
  ' we zap the whole string.
  '
  FOR K1 = 1 TO WordsCnt(K1$)
    K0$ = WordsGet$(K1$,K1,K4)
    K3 = LEN(K0$)
    FOR K5 = 1 TO 49
      K6 = LEN(Short$(K5))
      IF K6 > K3 THEN EXIT FOR
      IF LEFT$(K0$,K6) = Short$(K5) AND K6 > 0 THEN p0 = 0 : _
                                                    EXIT FOR
    NEXT
    IF p0 = 0 THEN CALL Wipe(K2) : _
                   p = p - K2 : _
                   EXIT FOR
  NEXT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will spell check a string.
        '
        ' p   0 or less to process a full string (the highlighting
        '     routine).  A -1 is returned if a word wasn't found.
        '     Anything else to process MessageBody$--even though
        '     looping, we work one word at a time since the user can
        '     type anything for the correct word (the editing
        '     routine).
        '
        ' p$  the string to process.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB GrammarCk (p,p$)

  K0 = 0
  K0$ = StripAnsi$(p$)
  CALL StrXLate(K0$,AlphaTable$)
  FOR K1 = 1 TO WordsCnt(K0$)
    K1$ = Null$
    K2$ = WordsGet$(K0$,K1,K2)
    K3  = LEN(K2$)
    SELECT CASE K3
      CASE 2, 3     : K2$ = LEFT$(K2$ + Short$(658),4)
      CASE 4 TO 12
      CASE 13 TO 18 : K2$ = Form$(1801,K2$)
      CASE ELSE     : K2$ = K1$
    END SELECT
    SELECT CASE K2$
      CASE IS <> K1$
           K1$ = K2$
           '
           ' The below was hacked in to avoid lack of handles errors.
           '
           IF LEN(K1$) < 12 _
              THEN CALL UnCompressWordRec(0,K1$) _
                   ELSE IF LEN(K1$) = 12 _
                           THEN Handle(18) = FileOpen(FileNames$(9) + Short$(488)) : _
                                CALL UnCompressWordRec(0,K1$) : _
                                CALL FileClose(Handle(18)) _
                           ELSE Handle(19) = FileOpen(FileNames$(9) + Short$(489)) : _
                                CALL UnCompressWordRec(0,K1$) : _
                                CALL FileClose(Handle(19))
    END SELECT
    '
    ' Case < 1 handles the highlighting for the initial test (returns with the
    ' string modified to contain highlight codes.
    ' Case ELSE asks for the correction, and will actually alter the text in
    ' MessageBody$.
    '
    SELECT CASE K2$
      CASE IS <> K1$
           SELECT CASE p
             CASE IS < 1
                  p = -1
                  p$ = LEFT$(p$,K2 + K0 - 1) + Short$(748) + _
                       MID$(p$,K2 + K0,K3) + Short$(77) + _
                       MID$(p$,K2 + K3 + K0)
                  K0 = K0 + LEN(Short$(748)) + LEN(Short$(77))
             CASE ELSE
                  TT$ = BlockText2(180) + MID$(p$,K2 + K0,K3) + Short$(104)
                  K3$ = LineEditTT$(30)
                  CALL DispCRLF
                  IF AscVal(p$) < 91 AND AscVal(K3$) > 96 _
                     THEN MID$(K3$,1,1) = AscChr$(AscVal(K3$) - 32)
                  IF LEN(K3$) = 0 _
                     THEN Handle(20) = FileOpen(FileNames$(9) + Short$(490)) : _
                          CALL FilePutSEnd(Handle(20),p$ + C1310$) : _
                          CALL FileClose(Handle(20)) _
                     ELSE MessageBody$ = LEFT$(MessageBody$,p + K2 - 2) + K3$ + _
                                         MID$(MessageBody$,p + K2 + K3 - 1)
           END SELECT
    END SELECT
  NEXT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to GrammarCk, will either get or try
        ' to locate a word in the various WORDS files.
        '
        ' p   0 to find p$, returns the record number if found.
        '
        ' p$  contains the word to find (if K = 0) and returns the
        '     word found at K if K > 0.  Either way, p$ must be the
        '     length of the word to find, that is, the routine
        '     determines which file to search based on the length of
        '     p$.
        '
        ' All the WORDS files should be opened approriately before
        ' calling this.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB UnCompressWordRec (p,p$)

  K0 = LEN(p$)
  SELECT CASE K0
    CASE 1 TO 4
         K0 = 4
         K1 = 1
    CASE 5 TO 12 : K1 = K0 - 3
    CASE 13 TO 18
         K0 = 18
         K1 = 10
    CASE ELSE : EXIT SUB
  END SELECT
  K1$ = SPACE$(K0 + 2)
  SELECT CASE p
    CASE 0
         K2 = 1
         K3 = (FileLof&(Handle(K1 + 9),1) * 8&) \ (K0 * 5)
         K0$ = p$
         K4 = 0
         WHILE K3 >= K2 AND K4 = 0
           p = (K2 + K3) \ 2
           K& = (K0 * 5& * (p - 1)) \ 8
           CALL FileGetSLoc(Handle(K1 + 9),K&,K1$)
           p$ = Make8Bit$(K1$,p,K0)
           SELECT CASE K0$
             CASE IS < p$ : K3 = p - 1
             CASE p$      : K4 = p
             CASE IS > p$ : K2 = p + 1
           END SELECT
         WEND
         IF K4 <> p THEN p = 0
    CASE ELSE
         K& = (K0 * 5& * p) \ 8
         CALL FileGetSLoc(Handle(K1 + 9),K&,K1$)
         p$ = Make8Bit$(K1$,p,K0)
  END SELECT

END SUB
        '
        '* * * *



