; Copyright (c) 1991-1992, John David Rohner.  All rights reserved.

;
; This routine returns a date string of the dd-mmm-yy form given a DOS
; standard integer date.
; 
; Usage:  Result$ = IntToDate3$ (IntDate%)
; Declare:  DECLARE FUNCTION IntToDate3$ (BYVAL IntDate%)
;
; Where IntDate% is the DOS standard integer date and Result$ is the returned
; date string.
;
; A "DOS standard" format means that to get the correct year one needs to add
; 1980 to the year value from the integer (or just 80 to get the yy version).
;
; The (more or less) equivalent Basic source code:
;
; FUNCTION IntToDate3$ (K0)
; K = K0 - (K0 \ 32) * 32
; IF K > 0 AND K < 32 THEN K$ = RIGHT$(STR$(K),2) _
;                     ELSE K$ = "xx"
; K = K0 \ 32 - (K0 \ 512) * 16
; IF K > 0 AND K < 13 THEN K$ = K$ + MID$(MonthNames$,K * 4 + 1,5) _
;                     ELSE K$ = K$ + "-xxx-"
; K = K0 \ 512 + 80
; IF K > 80 AND K < 99 THEN IntToDate3$ = K$ + LTRIM$(STR$(K)) _
;                      ELSE IntToDate3$ = K$ + "xx"
; END FUNCTION
;


.Model Medium, Basic
.Code


DGROUP      group   _DATA

_DATA       segment word public 'DATA'

DateBuf     DB      9,0,0,0,"  -   -  xxxJanFebMarAprMayJunJulAugSepOctNovDec"

_DATA       ends


;
; Actual program code begins.
;

            PUBLIC  IntToDate3        ;Make this routine available to LINK.

IntToDate3  proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp
            cld                       ;Move forward in string.

            lea     di,DateBuf        ;Location of output buffer to DI.
            push    di                ;We want to pop for SI later.
            add     di,4              ;Start of data.
            push    di                ;Save this too.
            push    ds                ;Want ES to equal DS.
            pop     es
            mov     bx,030AH          ;Multiplication and division numbers.
            mov     ax,[bp + 06]      ;Get the Integer Date.
            push    ax                ;Save it for later.

            and     ax,1FH            ;Screen out all but the right 5 bits.
            div     bl                ;Divide by 10.
            add     ax,3030H          ;Make the results ASCII characters.
            cmp     al,48             ;A "0"?
            jne     D1                ;Nope.
            mov     al,32             ;Yep, make it a space.
        D1: stosw                     ;Store those characters.

            mov     cl,05             ;Want to shift right 5 bits.
            pop     ax                ;Get the original date again.
            shr     ax,cl             ;Do the shift.
            push    ax                ;Save it for later.
            and     ax,0FH            ;Mask to get our Month.
            inc     di                ;Skip past the first "-".
            mul     bh                ;Month * 3 + 1 = month name.
            add     ax,di             ;Prepare to move (ES:DI) <- (DS:SI)
            add     ax,06             ;Minor adjustment.
            mov     si,ax             ;Actual location of month name.
            movsw                     ;Copy the first two letters.
            movsb                     ;Copy the last letter.
            
            mov     cl,04             ;Move past our month's bits.
            pop     ax                ;Get the date.
            shr     ax,cl             ;Do the shift.
            add     ax,80             ;Adjustment for DOS date method.
            div     bl                ;Divide by 10.
            add     ax,3030H          ;Make the results ASCII characters.
            inc     di                ;Skip past the second "-".
            stosw                     ;Store those characters.

            pop     ax                ;Get address of our data.
            pop     si                ;Get address of our new string.
            mov     [si + 2],ax       ;Put the data address in its place.
            xchg    ax,si             ;Exit with address of new string.

      Done: pop     bp
            ret     2                 ;Pop-return past our input parameter.

IntToDate3  endp                      ;End of routine.

End


