' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
'Various tiny routines that output or input, or related, something:
'  AnsiTT
'  AutoLogoff
'  CommOut
'  CopyFile
'  DispBlockText
'  DispCRLF
'  FileAppendToLog
'  FileGetBlock$
'  FileGetLine$
'  FileGetLineR$
'  GetBlock$
'  GetLine$
'  GetYNTT
'  KillFile
'  HangUp
'  NoCarrier
'  Paused
'  PurgeComIO
'  ShowTheGauge
'  Wipe






        '* * * * * *
        ' This routine sends text to the screen (if wanted).
        '
        ' This routine is not used from Wipe or DispCRLF because
        ' neither output's anything that can be seen, and both will
        ' soon be assembly language.
        '
        ' Blanking the screen will also turn off the beeps.
        '
        ' TT or TT$ contains the text to display.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB AnsiTT

  IF BitTest(Toggles(2),2) THEN TT = 0 : _
                                EXIT SUB
  IF TT > 0 THEN IF TT < 10000 THEN TT$ = GetLine$(TT) _
                               ELSE TT$ = Short$(TT - 10000)
  TT = 0
  CALL Ansi(TT$)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will tick down 5 seconds before logging the
        ' user off--unless they hit [Enter].
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB AutoLogoff

  TT$ = Null$
  FOR K = 5 TO 1 STEP -1
    TT$ = TT$ + BlockText2(100) + STR$(K) + BlockText2(312 + (K = 1))
  NEXT
  CALL SendTT
  IF TGot < 1 THEN CALL Quote : _
                   CALL HangUp

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine output's a string to the comm port (and trap
        ' file if it's open).
        '
        ' p$  string to send
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB CommOut (p$)

  CALL BlockOut(CommPort,p$)
  IF BitTest(Toggles(2),8) OR BitTest(User.Attr,6) _
     THEN IF DriveSpc&(FileNames$(51)) > Settings.MinSpace _
             THEN CALL FilePutSEnd(Handle(1),p$)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will copy a file to another file name.
        '
        ' K   0 to just copy the file (the new file gets the same
        '       time/date stamp as the original.
        '     1 to copy the file, deleting the original.
        '
        ' p$  is the pathname to copy from.
        '
        ' p0$ is the pathname to copy to.
        '
        ' The second file is always deleted if it already exists.
        '
        ' The second file will still be deleted (if found) even if the
        ' first file isn't found.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB CopyFile (p,p$,p0$)

  CALL KillFile(p0$)
  IF FindF(p$,FFile) = 0 THEN EXIT SUB
  IF p = 1 AND AscVal(p$) = AscVal(p0$) THEN NAME p$ AS p0$ : _
                                             EXIT SUB
  k& = FFile.FSize
  k$ = SPACE$(8192)
  k = FileOpen(p$)
  k1 = FileOpen(p0$)
  k1& = 0
  WHILE K& > 8192
    CALL FileGetSLoc(k,k1&,k$)
    k1&  = k1& + 8192
    CALL FilePutSEnd(k1,k$)
    k& = k& - 8192
  WEND
  IF k& > 0 THEN k$ = LEFT$(k$,k&) : _
                 CALL FileGetSLoc(k,k1&,k$) : _
                 CALL FilePutSEnd(k1,k$)
  CALL SameDate(k,k1)
  CALL FileClose(k)
  CALL FileClose(k1)
  IF p = 1 THEN CALL KillFile(p$)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will read in a block of sequential text, that
        ' was previously stored with a two-digit identifying number in
        ' front of it.
        '
        ' p   block number to display
        '
        ' p$  valid stop and exit keys
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB DispBlockText (p,p$)

  k = FileOpen(FileNames$(7) + Form4$(3,1))
  k& = BlockText&(p) - 1
  k$ = FileGetLine$(k,k&)
  DO
    IF RIGHT$(k$,2) = Short$(250) THEN k0 = 1 : _
                                       k$ = LEFT$(k$,LEN(k$) - 2) _
                                  ELSE k0 = 0
    TT$ = Short$(152) + p$ + Short$(153) + MID$(k$,3)
    k$ = FileGetLine$(K,K&)                           'Don't CRLF last line.
    k1 = Val2&(LEFT$(k$,2))
    IF k1 = p AND k0 = 0 THEN TT$ = TT$ + C1310$
    CALL SendTT
  LOOP UNTIL k& = -1 OR k1 <> p OR TGot > 0 OR NoCarrier
  CALL FileClose(k)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will output to comm and screen a CR/LF.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB DispCRLF

  CALL CommOut(C1310$)
  CALL Ansi(C1310$)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine appends the contents of a file to the log file,
        ' and then deletes it.
        '
        ' p$ is the file to append.
        '
        ' Date last checked for perfection: Sep 22 1992
        '
SUB FileAppendToLog (p$)

  IF FindF(p$,FFile) = 0 THEN EXIT SUB
  k0 = FileIndex
  FileIndex = 1
  k = FileOpen(p$)
  k& = 0
  DO
    TT$ = FileGetLine$(k,k&)
    CALL LogTT
  LOOP UNTIL k& = -1
  CALL FileClose(k)
  CALL KillFile(p$)
  FileIndex = k0

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine gets the next 4096 block of data from a file.
        '
        ' p   file handle
        '
        ' p&  starting point (updated upon exit)
        '
        ' p0& file's size
        '
        ' Returns p& = p0& when we are at then end of the file.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION FileGetBlock$ (p,p&,p0&)

  IF p& + 4096 > p0& THEN k$ = SPACE$(p0& - p&) _
                     ELSE k$ = SPACE$(4096)
  CALL FileGetSLoc(p,p&,k$)
  k = StrSrchR(k$,10)
  IF k = 0 THEN k = p0& - p&
  p& = p& + k
  FileGetBlock$ = LEFT$(k$,k)

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine retrieves the next line of 'sequential' text
        ' from an already opened file.
        '
        ' p   file number to read from.
        '
        ' p&  location to start reading from.  p& is increased by the
        '     size of the returned string + 2.  -1 is returned at EOF.
        '
        ' If the retrieved 128 byte buffer has no CR/LF, then returns
        ' with all 128 bytes read.
        '
        ' A line with only a CR/LF on it is returned as a null.
        '
        ' The CR/LF is not included in the returned text.
        '
        ' At EOF, returned text may or may not contain text, but p&
        ' will be -1.
        '
        ' The last line read may or may not contain data (assume it
        ' does).
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION FileGetLine$ (p,p&)

  IF p& >= FileLof&(p,1) - 2 THEN FileGetLine$ = Null$ : _
                                  p& = -1 : _
                                  EXIT FUNCTION
  k$ = SPACE$(128)
  CALL FileGetSLoc(p,p&,k$)
  k = StrSrch1(k$,13)
  IF k = 0 THEN k = 128
  IF k > 0 THEN k$ = LEFT$(k$,k - 1) : _
                p& = p& + k + 1 : _
                IF p& >= FileLof&(p,1) - 2 THEN p& = -1
  FileGetLine$ = k$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine retrieves the next line of 'sequential' text
        ' from an already opened file.  However, it does it from the
        ' bottom up.
        '
        ' p   file number to read from.
        '
        ' p&  location to start reading from.  p& is decreased by the
        '     size of the returned string + 2.  -1 is returned whne
        '     the start of the file (first line) is reached.
        '
        ' The CR/LF is not included in the returned text.
        '
        ' Do a p& = FileLof&(handle%,1) before calling this the first
        ' time.
        '
        ' If the very first line of the file is also just a CR/LF, it
        ' will be ignored.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION FileGetLineR$ (p,p&)

  IF p& = FileLof&(p,1) THEN p& = p& - 2
  IF p& < 3 THEN FileGetLineR$ = Null$ : _
                 p& = -1 : _
                 EXIT FUNCTION
  IF p& > 127 THEN k = 128 : _
                   p& = p& - 128 _
              ELSE k = p& : _
                   p& = 0
  k$ = SPACE$(k)
  CALL FileGetSLoc(p,p&,k$)
  k = StrSrchR(k$,13)
  IF k > 0 THEN k$ = MID$(k$,k + 2) : _
                p& = p& + k - 1
  IF p& < 3 THEN p& = -1
  FileGetLineR$ = k$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine displays a progress graph and percentage
        ' report.
        '
        ' p&  is our total.
        '
        ' p0& is the current partial (the amount of p& that is done).
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB ShowTheGauge (p&,p0&)

  STATIC k
  k& = p& \ 20                                  'Find the 1/20th.
  IF k& = 0 THEN k& = 1
  IF k& * k > p0& THEN k = 0                    'Reset K for new gauges.
  k = k + 1                                     'Increment our 1-20 counter.
  '
  ' If the counter * 1/20th is greather than our partial, then we have
  ' incremented too soon, so exit (don't redraw the gauge).  This stops
  ' redrawing of the gauge for each call.  When p0& exceeds each 1/20th
  ' level, we do the gauge.
  '
  IF k& * k > p0& THEN k = k - 1 : _
                       EXIT SUB
  IF K > 20 THEN EXIT SUB     'Needed because of integer roundoff with small
                              'values, 21 * (p& \ 20) could still be < p&.
  k0 = k \ 2
  TT$ = Short$(251) + STRING$(k0,219)
  IF k0 * 2 <> k THEN TT$ = TT$ + Short$(264) : _
                      k0 = k0 + 1
  TT$ = TT$ + STRING$(10 - k0,32) + Short$(278) + _
        LTRIM$(STR$((k * 100) \ 20)) + Short$(144)
  CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will read in, and return with, a block of text
        ' from BLOCK.TXT.
        '
        ' p  block number to load
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION GetBlock$ (p)

  k = FileOpen(FileNames$(7) + Form4$(3,1))
  k& = BlockText&(p) - 1
  k0$ = Null$
  k$ = FileGetLine$(k,k&)
  DO
    k0$ = k0$ + MID$(k$,3)
    k$ = FileGetLine$(k,k&)
  LOOP UNTIL k& = -1 OR Val2&(LEFT$(k$,2)) <> p
  CALL FileClose(k)
  GetBlock$ = k0$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will read in, and return, a single line of text
        ' from LINES.xxx.
        '
        ' p  line number of the line to load.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION GetLine$ (p)

  IF BlockText2(p) = Short$(188) THEN GetLine$ = Null$ : _
                                      EXIT FUNCTION
  k& = CVI(RIGHT$(BlockText2(p),2)) - 1
  IF k& < 0 THEN k& = 65536 + k&
  k$ = FileGetLine$(Handle(6),k&)
  WHILE RIGHT$(k$,2) = Short$(250)
    k$ = LEFT$(k$,LEN(k$) - 2) + FileGetLine$(Handle(6),k&)
  WEND
  GetLine$ = k$

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will get a Y, N, or CR/LF.  Good for all
        ' Y/N questions which default to No.
        '
        ' TT/TT$ will be displayed first, and a '? [y/N]' is added.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION GetYNTT%

  IF TT > 0 THEN IF TT > 10000 THEN TT$ = Short$(TT - 10000) _
                               ELSE TT$ = BlockText2(TT)
  TT = 0
  TT$ = TT$ + Short$(157)
  CALL SendTT
  k$ = Short$(158) + C13$
  IF RTRIM$(User.UserName) = Null$ THEN k$ = k$ + C3$
  CALL TGet(k$)
  CALL Wipe(6)
  IF TGot = 89 THEN TT = 10159 : _
                    GetYNTT = -1 _
               ELSE TT = 10170 : _
                    GetYNTT = 0
  CALL SendTT

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will hang up the phone.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB HangUp

  WHILE NOT NoCarrier
    k = FosIntAX(CommPort,&H600)                           'Lower DTR.
    CALL DelayTiny(1)
    k = FosIntAX(CommPort,&H601)                           'Raise DTR.
    CALL DelayTiny(1)
    IF CommPort = 0 THEN CommPort = Settings.CommPort : _
                         CALL CommOut(GetLine$(627) + C1310$) 'Send ATH0.
    IF Settings.CommPort = 0 OR BitTest(Toggles(2),15) THEN EXIT SUB
  WEND
  CALL PurgeComIO(CommPort)
  CALL DelayTiny(1)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine first checks for a files existence, if there,
        ' it then deletes it.
        '
        ' p$ is the drive\path\filename to delete.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB KillFile (p$)

  IF FindF(p$,FFile) <> 0 THEN KILL p$

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will signal Yea or Nay as to the status of the
        ' carrier.
        '
        ' returns  -1 if no carrier detected
        '           0 if carrier present
        '
        ' Remember, this is 'NO Carrier'--true when no carrier is
        ' detected.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION NoCarrier%

  IF BitTest(FosIntAX(CommPort,&H300),8) OR (CommPort = 0) _
     OR BitTest(Toggles(2),15) _
     THEN NoCarrier = 0 _
     ELSE NoCarrier = -1

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will/will not display 'Paused' and wait for
        ' either the spacebar or enter key.
        '
        ' Since this is always called after something is displayed,
        ' it is assumed that TGot$ comes in null, if not null, the
        ' routine is skipped.
        '
        ' If the output ends in col 80, do SendTT before this with no
        ' CR/LF.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB Paused

  IF LEN(TGot$) = 0 THEN TT = 3 : _
                         CALL SendTT : _
                         IF LEN(TGot$) = 0 THEN CALL TGet(C32$ + C13$)
END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will purge the fossil and modem I/O buffers.
        '
        ' K0 = CommPort
        '
        ' It relies on the fossil to purge the modem buffers.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB PurgeComIO (p)

  k = FosIntAX(p,&HA00)                      'Purge the fossil's input buffer.
  k = FosIntAX(p,&H900)                      'Purge the fossil's output buffer.
  DO : k = FosIntAX(CommPort,&H2000)         'Purge the modem's input buffer.
  LOOP UNTIL k < 1

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will 'delete' a number of characters from the
        ' screen.
        '
        ' p  number of characters to delete.
        '
        ' In the future, try just a C8$ (destructive backspace).  Test
        ' with various comm programs to see what's needed/etc.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB Wipe (p)

  k$ = C8$ + C32$ + C8$
  FOR k = 1 TO p
    CALL CommOut(k$)
    CALL Ansi(k$)
  NEXT

END SUB
        '
        '* * * *

