'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
' WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
' MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
' See the documentation for additional information.
'
'
' $INCLUDE: 'BBS-VAR.BAS'
'

CLEAR,,4096                                    'Stack size (see FRE(-2)).

CALL Initialize                                'Create needed variables.

K0 = TGot

'
' Root loop.
'
K$ = Short$(906)
DO 
  CALL MainLoop(K0)
  K0 = 0
LOOP UNTIL K$ <> Short$(906)         'Quit if string space became corrupt.
                                     'Not req'd, but better than a simple loop.

END



'
'Knowledge to ponder for the future:
'
'All systems, including programming and electronics, are made up of two
'elements: piping and filtering.  Piping is data flow control.  Filtering
'is masking out, or eliminating, parts of that flow.
'
'You can reduce any amount of data to just a couple of numbers if you can
'find a solution to the following information:
'  The unknown variables range from 0 to 255 (or 1 to 256 w/+1 etc.)
'  There must be one less byte used to describe the knowns, than the
'  unknowns.
'  Example: y = Ax^2 + Bx + C
'           where 0 <= A <= 255, 0 <= B <= 255, 0 <= C <= 255,
'           and the x and y components do not use 3 full bytes (24 bits).
'  The biggest problem with solving for unknowns is factions--but if all
'  your fractions can get the same denominator, than all that needs to
'  be stored is the numerator.
'  You can use 255 individual equations.  Using one byte to say which
'  equation to use.
'  By using the offset from the previous byte/number, you gain extra
'  number(s).  Example: if A ranges from 0 to 255, then by using the
'  offset (1 to 255) from the previous number, you free up a number.  For
'  two bytes, you free up 255 numbers.  But not a single bit.  For negative
'  offset changes, use rollover (100 + 155 = 255, 100 + 156 = -1).
'  Each byte in the file is like a tick in time.  A file can graphed.
'  Curve fitting equations may be useful.  They need not be exact, but close
'  enough that a simple INT would round to the exact location.
'

'Programming is resource management.  Everyone does it all the time.


''''under construction'''' (buggy or under construction)



'didn't handle inserting into quoted text properly.  tested by attempted to
'insert between paragraphs at a blank line.
'
'test insert into a quote: "hello<ret>text text" to see if it makeshello the 
'author.

        '* * * * * *
        ' This routine, internal to EnterMsg, handles the insertion of
        ' lines of text into a message's body.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB InsertLines

  CALL FindMsgLine(0,Settings.MaxWidthOfMsg - 4,3,K$,K,K0)
  SELECT CASE K0
    CASE IS >= Settings.MaxLinesInMsg
         TT = 86
         CALL SendTT
    CASE ELSE
         TT = 659
         CALL GetNumPlusTT(Null$)
         K = Val2&(TGot$)
         SELECT CASE K
           CASE 0
                TT = 660
                CALL SendTT
           CASE IS > K0
                TT$ = Short$(971) + LTRIM$(STR$(K)) + BlockText2(661)
                CALL SendTT
           CASE ELSE
                CALL DispCRLF
                K$ = MessageBody$
                MessageBody$ = Null$
                kk = k
                CALL GetMessageText(K - 1)
                k = kk
                SWAP MessageBody$, K$
                '
                ' Re-adjust the line to insert before so that all "reply
                ' border marker" lines are bypassed.  Remember, the structure
                ' defining a reply border both is, and isn't, a single line/
                ' multiple lines.  Don't want to be inserting into the middle
                ' of this structure.  This does not prevent anyone from
                ' inserting into the middle of replys.
                '
                DO
                  CALL FindMsgLine(K,Settings.MaxWidthOfMsg - 4,1,K0$,K1,K2)
                  IF StrSrch1(K0$,220) > 0 THEN K = K - 1
                LOOP UNTIL K = 1 OR StrSrch1(K0$,220) = 0
                DO
                  CALL FindMsgLine(K,Settings.MaxWidthOfMsg - 4,1,K0$,K1,K2)
                  IF StrSrch1(K0$,223) > 0 THEN K = K + 1
                LOOP UNTIL K > K0 OR StrSrch1(K0$,223) = 0
                CALL FindMsgLine(K,Settings.MaxWidthOfMsg - 4,16,K0$,K1,K2)
                SELECT CASE K
                  CASE 1 : MessageBody$ = LEFT$(K$,LEN(K$) - 1) + MessageBody$
                  CASE IS > K0
                       MessageBody$ = LEFT$(MessageBody$,LEN(MessageBody$) - 1) + K$
                  CASE ELSE
                       '
                       ' Backup along the message string looking for C0$'s.
                       '
                       K2 = 0
                       FOR K3 = K1 - 1 TO 1 STEP -1
                         IF AscVal(MID$(MessageBody$,K3,1)) = 0 THEN K2 = K2 + 1
                         IF AscVal(MID$(MessageBody$,K3,1)) = 13 THEN EXIT FOR
                       NEXT
                       '
                       ' Actually insert the new text.
                       '
                       K$ = LEFT$(K$,LEN(K$) - 1)
'                       IF K2 > 0 THEN K$ = K$ + STRING$(K2,0) + C32$ + C13$ + _
'                                           STRING$(K2,0)
                        IF K2 > 0 _
                           THEN K$ = STRING$(K2,13) + K$ + STRING$(K2,0) + _
                                     C32$ + C13$ + STRING$(K2,0)
'think I may need: c0 c32 c13 c0 then c0 c0 c32 c13 c0c0 etc., on the other
'hand, maybe findmsgline correctly handls the "sudden jump" to a high
'number of c0's.
'make a "map" of what a message looks like.
                       IF AscVal(MID$(MessageBody$,K1 - K2 - 1,1)) <> 13 _
                          THEN K$ = C13$ + K$
                       MessageBody$ = LEFT$(MessageBody$,K1 - 1) + K$ + _
                                      MID$(MessageBody$,K1)
                END SELECT
         END SELECT
  END SELECT

END SUB
        '
        '* * * *



'best to go back to 3 integers--just too many people starting their own
'nets with zone fields.  Or maybe a remapper?  like SL's, remap to some
'internal list?
'for now:
' 8 zones (3 bits)     -high order of long int
'8192 nets (13 bits)   -       "
'32767 nodes (15 bits) -low order of long int
'
'there is an extra bit for us to use for the future.

'also handle "confusion": x:/xxx/yyy  x/yy/yy  x/yy:yy etc.
'does handle: _x_:_x_/_x_ where "_" are spaces.
'modify so it handles "a:b/c.d@e"--that is, trim off the ".d@e" before
'processing.
'
'do better carving up of the string.  Start at the end, clear off things
'after an "@", a " ", and a "." for as long as there are any (except for
'spaces like " 1 : 2 / 3"
        '* * * * * *
        '
        ' Date last checked for perfection: Sep 21 1992
        '
FUNCTION StrToAddr& (K$)
SELECT CASE LEN(K$)
  CASE 0 : StrToAddr& = 0
  CASE ELSE
'if :/ then :
'if 1/ then 1:
kz$ = k$
if left$(kz$,1) = "@" then kz$ = MID$(Kz$,2)
kz = StrSrch1(K$,64)
if kz = 0 then kz = len(kz$) + 1
kz$ = left$(kz$,kz - 1)

       kk$ = AddrToInt$(Settings.Addr,K2,K3,K4)
       K = StrSrch1(Kz$,58)
       K0 = StrSrch1(Kz$,47)
       IF K > 0 THEN K = Val2&(LEFT$(Kz$,K - 1)) ELSE K = K2
       IF K0 > 0 THEN K0 = Val2&(LEFT$(Kz$,K0 - 1)) ELSE K0 = K3
       K1 = Val2&(Kz$)
       StrToAddr& = (BitsShl(K,13) + K0) * 32768& + K1
END SELECT
END FUNCTION
        '
        '* * * *






        '* * * * * *
        ' This routine calculates what the user can download in bytes.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
FUNCTION CanDL&

  SELECT CASE User.ULBytes
    CASE IS <= 0 : K = UserSL
    CASE ELSE
         K = UserSL + 1
         DO
           K = K - 1
           K& = User.ULBytes * Levels(K).BRatio
         LOOP UNTIL K& > 0 OR K = 1
  END SELECT
  CanDL& = User.ULBytes * Levels(K).BRatio - User.DLBytes - User.MinMegs * Settings.ExchBytes

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This is the AI.  Any routines that use "smarts" are put
        ' here.
        '
        ' The routine calling this should at least function, although
        ' at a "dumber" level, without this routine.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB AI (p,p$,p4,p0,p1,p2,p3,p&,p0&)
  '
  ' The below actually is required, thus the AI routines are not
  ' independent?
  '
  SELECT CASE p
    CASE 5, 6
         '
         ' Subtract minutes used from their stats.
         '
         IF User.Elapsed + p4 > Levels(UserSL).MinsPerDay _
            THEN p4 = User.Elapsed + p4 - Levels(UserSL).MinsPerDay : _
                 User.Elapsed = Levels(UserSL).MinsPerDay : _
                 User.MinCredits = User.MinCredits - p4 _
            ELSE User.Elapsed = User.Elapsed + p4
  END SELECT
  '
  ' The independent AI routines.
  '
  IF p <> 6 AND NOT BitTest(Toggles(4),p) THEN EXIT SUB
  SELECT CASE p
    CASE 1
 'a second test that can be done on any range this routine gives up:
 'compare the Connect$ with all the .Connect's in that range, if only
 'one matches, then assume it's he.  This means a user who switches modems
 'might have troubles.
 'preferable, the connect should be the rec num of the connect.dat database
 'not just 12/24/96/etc.
         '
         ' Determine if a user name matches.  Output any unique
         ' characters.
         '
         '
         ' Find matching neighborlys' bounds.
         '
         FOR p1 = p4 - 1 TO 1 STEP -1
           CALL FileGetRec(Handle(21),p1,32,UserIDX)
           IF LEFT$(p$,p0) <> LEFT$(UserIDX.UserName,p0) THEN EXIT FOR
         NEXT
         p1 = p1 + 1
         CALL FileGetRec(Handle(21),p1,32,UserIDX)
         kz1$ = UserIDX.UserName
         FOR p2 = p4 + 1 TO FileLof&(Handle(21),32)
           CALL FileGetRec(Handle(21),p2,32,UserIDX)
           IF LEFT$(p$,p0) <> LEFT$(UserIDX.UserName,p0) THEN EXIT FOR
         NEXT
         p2 = p2 - 1
         CALL FileGetRec(Handle(21),p2,32,UserIDX)
         kz2$ = UserIDX.UserName
         '
         ' Compare the borderline (boundary) neighbors to find out how many
         ' additional matching characters exist throughout the group.
         '
         CALL FileGetRec(Handle(21),p4,32,UserIDX)
         p$ = UserIDX.UserName + C32$
         FOR p3 = p0 + 1 TO LEN(RTRIM$(p$))
           TT$ = MID$(p$,p3,1)
           IF TT$ <> MID$(kz1$,p3,1) OR TT$ <> MID$(kz2$,p3,1) THEN EXIT FOR
         NEXT
         JJ$ = p$
         CALL WordsCase(JJ$)
         TT$ = MID$(Jj$,p0 + 1,p3 - p0 - 1)
         CALL SendTT
         p0 = p3 - 1
         p$ = LEFT$(LEFT$(p$,p0) + SPACE$(31),31)
    CASE 2
         '
         ' Try to help a user with downloading by doing exchanges.
         '
         J9 = User.MinMegs
         '
         ' Do Megs-->Minutes exchanges for them if they need (and can) do so.
         '
         WHILE p& > (p4 * (ConnectCPS * 57&)) AND CanDL& >= Settings.ExchBytes
           User.MinCredits = User.MinCredits + Settings.ExchMins
           User.MinMegs = User.MinMegs + 1
           p4 = p4 + Settings.ExchMins
         WEND
         '
         ' Do Minutes-->Megs exchanges for them if they need (and can) do so.
         '
         WHILE p& > CanDL& AND User.MinCredits >= Settings.ExchMins
           User.MinMegs = User.MinMegs - 1
           User.MinCredits = User.MinCredits - Settings.ExchMins
           p4 = p4 - Settings.ExchMins
         WEND
         IF J9 <> User.MinMegs _
            THEN TT$ = Short$(936) + Commas$(CanDL&) + _
                       BlockText2(654) + STR$(p4) + BlockText2(695) : _
                 CALL SendTT
    CASE 3
         '
         ' Identify how many unqiue file names of a given string there are.
         '
         ' Find matching neighborlys' bounds.
         '
         FOR p1 = p4 - 1 TO 1 STEP -1
           CALL FileGetRec(Handle(22),p1,22,FileIDX)
           IF LEFT$(p$,p0) <> LEFT$(FileIDX.FName,p0) THEN EXIT FOR
         NEXT
         p1 = p1 + 1
         CALL FileGetRec(Handle(22),p1,22,FileIDX)
         kz1$ = FileIDX.FName
         FOR p2 = p4 + 1 TO FileLof&(Handle(22),22)
           CALL FileGetRec(Handle(22),p2,22,FileIDX)
           IF LEFT$(p$,p0) <> LEFT$(FileIDX.FName,p0) THEN EXIT FOR
         NEXT
         p2 = p2 - 1
         CALL FileGetRec(Handle(22),p2,22,FileIDX)
         kz2$ = FileIDX.FName
         '
         ' Find common additional characters among matching neighbors.
         '
         FOR p3 = p0 + 1 TO LEN(RTRIM$(p$))
           z$ = MID$(p$,p3,1)
           IF z$ <> MID$(kz1$,p3,1) OR z$ <> MID$(kz2$,p3,1) THEN EXIT FOR
         NEXT
    CASE 4
         '
         ' IF they can't DL because they've exceeded their ratio--then do an
         ' exchange for them.  Unlike Exchange, this will keep piling on
         ' negative minute-credits until they are back in balance.  Essentially
         ' borrowing against future uploads.
         '
         SELECT CASE BitTest(Toggles(4),4)
           CASE -1
                WHILE CanDL& < 0
                  User.MinMegs = User.MinMegs - 1
                  User.MinCredits = User.MinCredits - Settings.ExchMins
                WEND
         END SELECT
    CASE 5
         ' Uses p = 5, index value.
         '      p4 = minutes used.
         ' Brain shutoff only for the second section--since the first handles
         ' time reduction.  This means the program no longer functions w/o it?
         '
         ' This routine readjusts the user's minute-credits, exchanging megabytes
         ' (from the future if necessary) to eliminate negative minute-credit
         ' values.
         '
         SELECT CASE BitTest(Toggles(4),5)
           CASE -1
                WHILE User.MinCredits < 0 AND CanDL& >= Settings.ExchBytes
                  User.MinMegs = User.MinMegs + 1
                  User.MinCredits = User.MinCredits + Settings.ExchMins
                WEND
         END SELECT
    CASE 6
         K1$ = MakePathName$(Message.MsgNum,Message.MsgBase)
         K1 = FindF(K1$,FFile)
         WHILE FindF(K1$,FFile) <> 0
           User.DLBytes = User.DLBytes - FFile.FSize
         WEND
  END SELECT

END SUB
        '
        '* * * *






'stuff can add: if user is a new user   user.logons = 1
'               if user is an AI        attr and 4               USE zz above
'               if caller was a netmailer  ?
'              maybe put the above 3 as "a" "b" "c" in substype--and have
'              subs type only be from "0".."9"
'don't make this an overlay--since door sys calls and overlaying it would
'add further slowdown.  fix for a solution.
'doorsys is supposed to call this with a (1) and logout with a (0).
'go thru and make sure all sumlog totals are being done, and done correctly.
'

'if I want to do a history like exec-pc, I'll need to do this and more--might 
'as well use a database rec--start designing.

'use a "by-user" record, and use this for history and sysop's system stats
'and for stats analysis.  For door returns, just load in and keep using the
'very last record.  Either zero the recs by using a dummy first blank
'rec or resetting it (in an overlay--I guess this way is best).
'do for next release: change summary.log in paths.dat to summary.dat and
'put into system area.

        '* * * * * *
        ' Update statistical summary log.
        '
        ' p  0 to output a "&" starting character
        '    anything else to output a "1" starting character.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB UpdateSumLog (p)

  SELECT CASE p
    CASE 0, 1
         IF p = 0 THEN K4 = 222 _
                  ELSE K4 = 154
         CALL DateDMY(LogonDate,K1,K2,K3)
         TT$ = Short$(K4) + C32$ + Form4$(2,K1) + Form4$(2,K2) + _
               Form3$(SumLog.PagedSysop) + Form3$(SumLog.MsgsPosted) + _
               Form3$(SumLog.EMsgsPosted) + Form3$(SumLog.FMsgsPosted) + _
               Form3$(SumLog.NetMailSent) + Form3$(SumLog.NetMailRcvd) + _
               Form$(402,STR$(ElapsedTime(LogonTime$,K))) + _
               Form3$(SumLog.Dnlds) + Form$(602,STR$(SumLog.DLBytes \ 1024))
         TT$ = TT$ + Form$(402,STR$(SumLog.MinsDLing)) + _
               Form3$(SumLog.BadDLs) + Form3$(SumLog.Uplds) + _
               Form$(602,STR$(SumLog.ULBytes \ 1024)) + _
               Form$(402,STR$(SumLog.MinsULing)) + _
               Form3$(SumLog.BadULs) + Form3$(SumLog.Doors) + _
               Form$(766,STR$(User.SecLevel)) + User.Protocol + _
               C32$ + User.SubsType + C32$ + User.Connect + Short$(849)
         CALL SharedWriteEOF(50,0,TT$)
         SumLog.PagedSysop  = 0
         SumLog.MsgsPosted  = 0
         SumLog.EMsgsPosted = 0
         SumLog.FMsgsPosted = 0
         SumLog.Dnlds       = 0
         SumLog.DLBytes     = 0
         SumLog.MinsDLing   = 0
         SumLog.BadDLs      = 0
         SumLog.Uplds       = 0
         SumLog.ULBytes     = 0
         SumLog.MinsULing   = 0
         SumLog.BadULs      = 0
         SumLog.Doors       = 0
    CASE 3
         K = FileOpen(FileNames$(50))
         CALL FilePutSEnd(K,"3 " + IntToDate3$(LogonDate) + STR$(Settings.HiFilePtr) + C1310$)
         CALL FileClose(K)
  END SELECT

END SUB
        '
        '* * * *




'
' K$ = path and filename of the imported message.  IF K$ = "" then
' a general import of all files in Paths$(11) is done.  (create a MailDr$).
' this routine is meant to only return one message, but if any non-text
' messages are found, those are just added automatically (if no text
' message is found, a null is returned).
'
'do drive space handling.

'better define what this does, and do testing.
'for instance: when commport = 0 (at console) and hit enter.
'when type like c:\work\*.rep
'when have more than one text message
'when have one text message
'etc.

        '* * * * * *
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB ImportMessage (p$)

  MessageBody$ = Null$
  IF LEN(p$) > 0 THEN K0$ = p$ _
                 ELSE K0$ = Paths$(11) + Short$(760 + (CommPort = 0))
  IF FindF(K0$,FFile) = 0 THEN TT = 650 : _
                               CALL SendTT : _
                               EXIT SUB
  '
  ' Sysop order to import all packets.
  '
  IF LEN(p$) = 0 AND CommPort = 0 _
     THEN DO : CALL ImportFidoPacket(Paths$(11) + FFile.FName) : _
               TT$ = ">Importing " + Paths$(11) + FFile.FName : _
               CALL SendTT : _
          LOOP UNTIL FindF(K0$,FFile) = 0 : _
          MessageBody$ = Null$ : _
          EXIT SUB
  '
  ' Import a single message, or a .REP packet, or a .PKT packet.
  '
  DO
    K1$ = Paths$(11) + FFile.FName
    IF LEN(p$) > 0 THEN K1$ = p$
    SELECT CASE RIGHT$(K1$,4)

'used: p$ K0$ K1$

    CASE Short$(772)
'         '
'         ' A user created/sent, or sysop specified, .REP packet.
'         '
'         CALL ImportRepPacket(K1$)
'         MessageBody$ = Null$
'         EXIT DO
      CASE Short$(866)
           '
           ' A sysop specified .PKT packet.
           '
           IF LEN(p$) > 0 THEN CALL ImportFidoPacket(p$) : _
                               MessageBody$ = Null$ : _
                               EXIT DO
      CASE ELSE
           K = Settings.MaxWidthOfMsg
           IF BitTest(User.Toggles,2) THEN K = K - 4
           K0 = FileOpen(K1$)
           K& = 0
           K1 = 0
           DO
             K2$ = FileGetLine$(K0,K&)
             IF LEN(K2$) <= K _
                THEN IF LEN(K2$) = 0 _
                        THEN MessageBody$ = MessageBody$ + C32$ _
                        ELSE MessageBody$ = MessageBody$ + K2$ _
                ELSE MessageBody$ = MessageBody$ + K2$ : _
                     K1 = K1 + 1
                     '
                     ' The above means lines of length 128 are considered two
                     ' lines.  It is not perfect, but acceptable to the real
                     ' value that two lines = 148 or 158 continuous characters.
                     '
             IF LEN(K2$) < 128 THEN MessageBody$ = MessageBody$ + C13$
             K1 = K1 + 1
           LOOP UNTIL K& = -1 OR K1 >= Settings.MaxLinesInMsg
           CALL FileClose(K0)
           CALL KillFile(K1$)
           MessageBody$ = MessageBody$ + C13$ + C13$
           EXIT DO
    END SELECT
  LOOP UNTIL FindF(Null$,FFile) = 0

END SUB
        '
        '* * * *





 


        '* * * * * *
        ' This routine writes to the end of a file, provided no other
        ' file is doing so.
        '
        ' p   FileNames$() array location.
        '
        ' p0  .xxx based extension to use (if not 0 or negative)
        '      0 for no .xxx addition.
        '     -1 for no .xxx, but also don't add a CR/LF.
        '
        ' p$  String to write, CR/LF is added.
        '
        ' Date last checked for perfection: Sep 22 1992
        '
SUB SharedWriteEOF (p,p0,p$)

  IF p0 > 0 THEN k$ = Form4$(3,p0) _
            ELSE k$ = Null$
  k = FileOpen(FileNames$(p) + k$)
  IF p0 >= 0 THEN k$ = C1310$ _
             ELSE k$ = Null$
  CALL FilePutSEnd(k,p$ + k$)
  CALL FileClose(k)

END SUB
        '
        '* * * *


