' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' Main routines:
'  MainLoop
'  WFC
'  ReInit
'  DoEvents
'  DoEvents1
'  DoEvents2
'  Dispatcher



        '* * * * * *
        ' This routine handles menu stuff.
        '
        ' p   0 if starting up BBS.
        '    -1 if just reseting after a caller.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB MainLoop (p)

  IF p = -1 THEN CALL WFC(0)
  IF p <= 0 THEN CALL StartUp
  K$ = Menu.AnsiToDisp
  K0$ = K$
  K = Val2&(Menu.Index)
  TGot = 13                           'First thing to do: redraw the ANSI.
  '
  ' Primary command processing.
  '
  DO
    IF NoCarrier THEN EXIT DO
    K1 = BiSearch(1,K,Null$)          'Locate index block.
    IF K1 = 0 THEN K = 0 : _
                   K1 = 1
    K1$ = ValidChoice$(K) + C13$      'Allowed hot key's.
    '
    ' Redraw ANSI after each command.  Unless no ANSI.
    '
    IF TGot < 1 AND LEN(K$) > 0 _
       THEN CALL DispFile(Paths$(3) + K$ + Short$(946),K1$)
    '
    ' K0 is an internal set of flags telling what should be done before, during,
    ' and after the execution.
    ' Bit 1 ON if should show special FX.  (OFF doesn't stop '!' and '*').
    ' Bit 2 ON if should show Who's On status line.
    ' Bit 3 ON if should just redraw the screen.
    ' Bit 4 ON if user has enough SL to do the command.
    ' Bit 14 ON if should jump to another menu after executing.
    ' Bit 15 ON if should set a new ansi field, and assume a CR next cmd.
    ' Bit 16 ON if should zero the ansi field, and assume a CR next cmd.
    '
    K0 = 2                            'Default to no special FX, show who's on.
    '
    ' Wait for the user to type a valid key, if they haven't already.
    '
    SELECT CASE TGot
      CASE 13 : TGot$ = Short$(808)
      CASE IS < 1
           CALL BitSet(K0,1)        'ANSI fully sent, so will do any Special FX.
           K1$ = K1$ + C1$            'Turn protocol auto-detect on.
           IF LEFT$(K$,5) = Short$(473) THEN CALL BitClear(K0,2)
           IF LEFT$(K$,4) = Short$(947) OR LEFT$(K$,7) = Short$(948) _
              THEN CALL BitClear(K0,2) : _
                   K1$ = K1$ + C3$                   'Turn on logo time-out.
           K1$ = K1$ + AscChr$(5)                    'Turn <c>Fx detect ON.
           IF BitTest(K0,2) THEN CALL SysopLine(0)
           TT = 10442
           CALL SendTT
           CALL TGet(K1$)
           IF NoCarrier THEN EXIT DO
           IF TGot > 24000 THEN IF LEN(TT$) > 0 THEN Menu.ShouldDo = TT$ : _
                                                     CALL Dispatcher
           IF TGot$ = Short$(225) THEN FileIndex = 1 : _
                                       CALL Upload(1) : _
                                       CALL BitSet(K0,3)
           IF TGot$ = Short$(187) _
              THEN CALL BitSet(K0,3) : _
                   IF Levels(UserSL).SecLevel >= Settings.BiSL _
                      THEN FileIndex = 1 : _
                           CALL Upload(2)
           IF TGot < 1 THEN TGot$ = Short$(808)
    END SELECT
    '
    ' Process the user's selection.  Load the menu command line related to
    ' that selection.
    '
    SELECT CASE BitTest(K0,3)
      CASE 0
           K2$ = TGot$
           IF LEN(K$) > 0 THEN TT = 10920 : _
                               CALL SendTT   'Default everything to dark white.
           K2 = FileOpen(FileNames$(35))
           IF Menu.HotKey < K2$ THEN K3 = 1 _
                                ELSE K3 = -1
           WHILE K = Val2&(Menu.Index) AND Menu.HotKey <> K2$ AND K1 > 0 _
                 AND K1 <= FileLof&(K2,38)
             CALL FileGetRec(K2,K1,38,Menu)
             K1 = K1 + K3
           WEND
           K1 = K1 - K3
           IF K <> Val2&(Menu.Index) OR Menu.HotKey <> K2$ _
              THEN CALL BitSet(K0,3)
           CALL FileClose(K2)
    END SELECT
    '
    ' Process the menu command line we loaded.
    '
    SELECT CASE BitTest(K0,3)
      CASE 0
           K2$ = Null$
           K3$ = Null$
           IF AscVal(Menu.TextBody) = 62 _
              THEN CALL BitSet(K0,14) _
              ELSE K1 = FileOpen(FileNames$(63)) : _
                   K4$ = SPACE$(FileLof&(K1,1)) : _
                   CALL FileGetSLoc(K1,0&,K4$) : _
                   CALL FileClose(K1) : _
                   K1 = StrSrch(1,K4$,RIGHT$(Menu.TextBody,3) + Short$(976)) : _
                   IF K1 <> 0 _
                      THEN K2$ = MID$(K4$,K1 + 3,StrSrch(K1,K4$,C13$) - K1 - 3) : _
                           K3$ = MID$(K2$,StrSrch1(K2$,102) + 1)
           IF MID$(Menu.SpecialFX,3,1) = Short$(477) THEN CALL BitSet(K0,15)
           IF MID$(Menu.SpecialFX,3,1) = Short$(997) THEN CALL BitSet(K0,16)
           '
           ' Actually output the contents of MENUTEXT.TXT and results of
           ' the SpecialFX field.
           '
           SELECT CASE BitTest(K0,1)
             CASE -1
                  SELECT CASE AscVal(MID$(Menu.SpecialFX,3))
                    CASE 49 : K2 = 175
                    CASE 50 : K2 = 950
                    CASE 51 : K2 = 951
                    CASE 52 : K2 = 952
                    CASE ELSE : K2 = 685
                  END SELECT
                  K4$ = Short$(K2)
                  K2 = AscVal(MID$(Menu.SpecialFX,2)) + 30
                  IF K2 > 29 AND K2 < 38 _
                     THEN K4$ = K4$ + LTRIM$(STR$(K2)) + Short$(690)
                  K2 = AscVal(Menu.SpecialFX) + 40
                  IF K2 > 39 AND K2 < 48 _
                     THEN K4$ = K4$ + LTRIM$(STR$(K2)) + Short$(690)
                  MID$(K4$,LEN(K4$),1) = Short$(861)
                  IF K4$ = Short$(953) OR LEFT$(Menu.SpecialFX,3) = Short$(891) _
                     THEN K4$ = Null$
                  SELECT CASE Val2&(RIGHT$(Menu.SpecialFX,2))
                    CASE 0  : TT$ = K2$
                    CASE 1 TO 24 : TT$ = K2$ + Short$(954) + _
                                         RIGHT$(Menu.SpecialFX,2) + Short$(955)
                    CASE 99 : TT$ = Short$(956) + K2$ + Short$(65) + K2$ + _
                                    Short$(75) + K2$ + Short$(957)
                    CASE 98 : TT$ = Short$(958) + K2$ + Short$(65) + K2$ + _
                                    Short$(75) + K2$ + Short$(957)
                    CASE 97 : TT$ = Short$(958) + K2$ + Short$(957)
                    CASE 96 : TT$ = Short$(956) + K2$ + Short$(65) + K2$ + _
                                    Short$(956) + K2$ + Short$(959)
                    CASE 95 : TT$ = Short$(956) + K2$ + Short$(65) + K2$ + _
                                    Short$(956) + K2$ + Short$(960)
                    CASE 94 : TT$ = BlockText2(589) + K2$ + Short$(65) + K2$ + _
                                    Short$(958) + K2$ + Short$(961)
                    CASE 93 : TT$ = K2$ + BlockText2(718)
                    CASE 92 : TT$ = K2$ + BlockText2(719)
                    CASE 91 : TT$ = K2$ + BlockText2(720)
                    CASE ELSE : TT$ = Null$
                  END SELECT
                  TT$ = K4$ + TT$
             CASE ELSE
                  SELECT CASE Val2&(RIGHT$(Menu.SpecialFX,2))
                    CASE 0  : TT$ = K3$
                    CASE 1 TO 24 : TT$ = K3$ + Short$(685) + _
                                         RIGHT$(Menu.SpecialFX,2) + Short$(955)
                    CASE 96 : TT$ = K3$ + Short$(962)
                    CASE 95 : TT$ = K3$ + Short$(963)
                    CASE 94 : TT$ = K3$ + Short$(964)
                    CASE ELSE : TT$ = Null$
                  END SELECT
           END SELECT
           CALL SendTT
           '
           ' Confirm they have high enough SL, or the password, for the command.
           '
           FOR K1 = 1 to 5
             K2 = AscVal(MID$(Menu.NeededSL,K1,1))
             IF K2 < 48 OR K2 > 57 THEN EXIT FOR
           NEXT
           SELECT CASE K1
             CASE IS <= 5
                  TT = 605
                  IF LTRIM$(RTRIM$(UCASE$(LineEditTT$(5)))) <> LTRIM$(RTRIM$(UCASE$(Menu.NeededSL))) _
                     THEN TT = 666 : _
                          CALL BitSet(K0,4) _
                     ELSE TT = 700
                  CALL SendTT
             CASE ELSE
                  IF Levels(UserSL).SecLevel < Val2&(Menu.NeededSL) _
                     THEN CALL BitSet(K0,4)
           END SELECT
           K2 = Val2&(Menu.ShouldDo) - 1
           IF StrSrch1(Short$(883),AscVal(Menu.ShouldDo)) > 0 AND K2 > 0 _
              THEN IF CVL(MID$(UserMsgInfo$,K2 * 4 + 1,4)) < 0 _
                      AND BitTest(MsgBases(K2).SubType,4) _
                      THEN CALL BitSet(K0,4)                  'LOCKed msg base.
           '
           ' Actually do the command.  Dispatcher handles everything except
           ' menu changes ('>'), 'Bye ', and 'Swap'.
           '
           SELECT CASE BitTest(K0,4)
             CASE 0
                  SELECT CASE AscVal(Menu.ShouldDo)
                    CASE 62
                         IF LEN(RTRIM$(Menu.AnsiToDisp)) > 0 _
                            THEN K$ = Menu.AnsiToDisp : _
                                 K0$ = K$
                         K = Val2&(Menu.ShouldDo)
                    CASE ELSE
                         SELECT CASE Menu.ShouldDo
                           CASE Short$(965) : IF K$ = K0$ _
                                                 THEN K$ = Menu.AnsiToDisp _
                                                 ELSE K$ = K0$
                                              Menu.AnsiToDisp = Null$
                           CASE Short$(921) : EXIT DO
                           CASE ELSE
                                IF LEN(RTRIM$(Menu.AnsiToDisp)) > 0 _
                                   THEN IF BitTest(K0,14) _
                                           THEN K$ = Menu.AnsiToDisp : _
                                                K0$ = K$
                                Menu.AnsiToDisp = K$
                                CALL Dispatcher
                                IF Menu.ShouldDo = Short$(921) THEN EXIT DO
                         END SELECT
                  END SELECT
           END SELECT
           TGot = 0
           IF BitTest(K0,14) THEN K = Val2&(Menu.TextBody) : _
                                  IF LEN(RTRIM$(Menu.AnsiToDisp)) > 0 _
                                     THEN K$ = RTRIM$(Menu.AnsiToDisp) : _
                                          K0$ = K$
           IF BitTest(K0,15) THEN TGot = 13 : _
                                  K$ = RTRIM$(Menu.AnsiToDisp) : _
                                 K0$ = K$
           IF BitTest(K0,16) THEN K$ = Null$ : _
                                  TGot = 13 : _
                                  K0$ = Null$
      CASE ELSE : TGot = 0
    END SELECT
    '
    ' Zero out MessageBody$ so we don't waste up to 8k of string space.
    '
    MessageBody$ = Null$
  LOOP UNTIL NoCarrier
  '
  ' Say goodbye to the caller.
  '
  CALL Quote
  CALL LogOut
  '
  ' Check the events.
  '
  IF NoCarrier THEN CALL DoEvents
  '
  ' Reset the port, and wait for a caller.
  '
  IF CommPort = 0 OR NoCarrier THEN CALL WFC(0) _
                               ELSE CALL WFC(2)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine waits for a caller.  It also handles any
        ' console keys while waiting.
        '
        ' p  which operation to do next.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB WFC (p)

  k99 = 16
  K$ = RightTime$(Null$)
  DO
    LogonDate = DateToInt(DATE$)
    SELECT CASE p
      CASE 0, 1
           '
           ' Initalize the fossil and wait for a connect.  Reseting every x
           ' minutes depending on whether we just got a call--just in case
           ' something went wrong (no modem callers, calling and not hanging
           ' up, line noise, whatever.)
           '
           CALL ReInit
           p = 2
      CASE 2
           '
           ' Reset the timer, position in the help screens, and position in the
           ' callers log.
           '
           User.UserName = Null$            'Tells us that nobody is logged in.
           BaseIndex = 0
           FileIndex = 1
           K6 = FosIntAX(CommPort,&H300)    'Get the baseline fossil status.
           K0 = 1
           K1 = 1
           p = 3
      CASE 3
           '
           ' Display the drive info, help screen, and callers log.
           '
           K7 = 0
           CALL MainLoop2(1,K7,0)
           CALL MainLoop2(2,K1,0)
           TT$ = Short$(693) + STRING$(400,219) + Short$(688) + _
                 STRING$(78,223) + Short$(184)
           CALL AnsiTT
           CALL MainLoop2(3,0,K0)
           TT$ = Short$(184) + STRING$(78,220) + SHORT$(694)
           CALL AnsiTT
           IF TIME$ => Settings.NextEvent THEN CALL DoEvents
           CALL PurgeComIO(CommPort)
           IF NoCarrier THEN K3 = Settings.ResetNoConnect _
                        ELSE K3 = Settings.ResetConnect
           TT$ = GetLine$(763 + BitTest(Toggles(2),8)) + _
                 GetLine$(761 + BitTest(Toggles(1),5)) + _
                 GetLine$(614 + BitTest(Toggles(1),4))
           CALL AnsiTT
           SWork$(1) = GetLine$(750)
           SWork$(2) = GetLine$(751)
           SWork$(3) = GetLine$(752)
           SWork$(4) = GetLine$(753)
           SWork$(5) = GetLine$(754)
           SWork$(6) = GetLine$(755)
           SWork$(7) = GetLine$(756)
           SWork$(8) = GetLine$(757)
           K0$ = TIME$
           p = 4
           kzz = 0
      CASE 4
           '
           ' Update the port status line.
           '
           K2 = FosIntAX(CommPort,&H300)
           TT$ = SWork$(4 + BitTest(K2,5)) + SWork$(6 + BitTest(K2,6)) + _
                 SWork$(2 + BitTest(K2,7)) + SWork$(8 + BitTest(K2,8))
           CALL AnsiTT
           IF BitTest(K2,7) THEN K0$ = TIME$
           IF BitTest(K2,7) and kzz = 0 _
              THEN CALL PurgeComIO(CommPort) : _
                   CALL CommOut(GetLine$(625) + C1310$) : _
                   CALL DelayTiny(1) : _
                   kzz = 1
'           IF BitTest(K2,7) THEN CALL PurgeComIO(CommPort) : _
'                                 CALL CommOut(GetLine$(625) + C1310$) : _
'                                 CALL DelayTiny(1) : _
'                                 CALL PurgeComIO(CommPort)
           IF NOT NoCarrier THEN EXIT SUB
           '
           ' Update the timing status line.
           '
           K5 = ElapsedTime(K0$,K4)
           IF K2 <> K6 AND K3 = Settings.ResetNoConnect _
              THEN K3 = Settings.ResetConnect : _
                   K0$ = TIME$
           TT$ = Form$(3901,Short$(1042) + K$ + Short$(705) + STR$(K3) + Short$(706)) + _
                 Short$(368) + Form$(3833,STR$(K5) + Short$(707) + STR$(K4) + Short$(1043))
           CALL AnsiTT                                'Don't use GetLine$.
           '
           ' Handle console keys.  p=3 redraws the whole screen.
           '
           p = 0
           K2 = CommIn(-5)
           IF BitTest(Toggles(2),3) THEN K2 = 17152
           SELECT CASE K2
             CASE 17152                              'F9  Logon locally.
                  CALL HangUp
                  CALL CommOut(GetLine$(628) + C1310$)
                  K2 = FosIntAX(CommPort,&H600)
                  CALL DelayTiny(1)
                  CALL PurgeComIO(CommPort)
                  CommPort = 0
                  CALL BitClear(Toggles(2),3)
                  K0$ = TIME$
             CASE 43                                 '+  next help page
                  K1 = K1 + 1
                  CALL MainLoop2(2,K1,0)
             CASE 45                                 '+  previous help page
                  K1 = K1 - 1
                  CALL MainLoop2(2,K1,0)
             CASE 15616                              'F2  Chat availability.
                  CALL BitToggle(Toggles(1),4)
                  TT$ = GetLine$(614 + BitTest(Toggles(1),4))
                  CALL AnsiTT
             CASE 16128                              'F5  Drive/memory info.
                  K7 = - K7
                  CALL MainLoop2(1,K7,0)
             CASE 18432                              '<up>  previous log page
                  K0 = K0 - 10
                  IF K0 < 1 THEN K0 = 1
                  CALL MainLoop2(3,0,K0)
             CASE 20480                              '<down>  next log page
                  K0 = K0 + 10
                  CALL MainLoop2(3,0,K0)
             CASE 7936                               '<alt>s  shell to dos
                  CALL CommOut(GetLine$(628) + C1310$)
                  CALL ShellDos(1,Null$)
                  p = 1
             CASE 11520                              '<alt>x  exit to dos
                  K2 = FosIntAX(CommPort,&H1D00)
                  CALL SaveIndices
                  K2 = FileOpen(FileNames$(13))
                  CALL FilePutLoc(K2,2300&,2,Toggles(1))
                  CALL FilePutLoc(K2,2302&,2,Toggles(2))
                  CALL FileClose(K2)
                  CALL ShellDos(9,Null$)
             CASE 5632, 5120, 7680, 4864, 8448
                  CommPort = 0
                  SELECT CASE K2
                    CASE 5632 : CALL AlterTheUsersData '<alt>u  user maintenance
                    CASE 5120 : CALL Toggle(0)         '<alt>t  toggles
                    CASE 7680 : CALL AlterSettings     '<alt>a  alter settings
                    CASE 4864 : K1$ = Short$(708)
                                CALL RemoveFile(K1$)   '<alt>r  remove a file
                    CASE 8448 : CALL AlterTheFilesData '<alt>f  file maintenance
                  END SELECT
                  CommPort = Settings.CommPort
                  p = 3
             CASE 8192                               '<alt>d  terminal program
                  KK = -1
                  kz& = 0
                  kz$ = Null$
                  DO
                    TGot = KK
                    CALL CommProg(kz&,kz$)
                    KK = TGot
                    TGot$ = Null$
                    IF KK = 1000 THEN CALL DataBaser
                    IF KK = 1001 THEN CALL NetSendContacter(3,kz&,kz$)
                  LOOP UNTIL KK <> 1000 AND KK <> 1001
                  p = 3
             CASE 20736, 15104                    '<pgdn> or <f1> trap all toggle
                  CALL BitToggle(Toggles(2),8)
                  IF BitTest(Toggles(2),8) _
                     THEN Handle(1) = FileOpen(FileNames$(51)) _
                     ELSE CALL FileClose(Handle(1))
                  TT$ = GetLine$(763 + BitTest(Toggles(2),8))
                  CALL AnsiTT
             CASE 15360                              'F2  trap chat toggle
                  CALL BitToggle(Toggles(1),5)
                  TT$ = GetLine$(761 + BitTest(Toggles(1),5))
                  CALL AnsiTT
             CASE 16384                              'F6  Blank the screen toggle
                  TT$ = Short$(67)
                  CALL AnsiTT
                  CALL BitToggle(Toggles(2),2)
                  CALL AnsiTT
                  p = 3
             CASE 6400                               '<alt>P
                  CALL PortDebugger
                  p = 3
             CASE ELSE
                  IF K2 > 24000 THEN IF LEN(TT$) > 0 _
                                        THEN Menu.ShouldDo = TT$ : _
                                             CALL Dispatcher : _
                                             p = 1
           END SELECT
           IF p = 0 THEN IF ElapsedTime(K0$,K4) >= K3 AND NoCarrier THEN p = 1 _
                                                                    ELSE p = 4
    END SELECT
  LOOP UNTIL NOT NoCarrier

END SUB
        '
        '* * * *



        '* * * * * *
        ' Primary event handling routine.
        '
        ' For order of execution specific events, place them in the
        ' order in which they must be executed in the database.
        '
        ' DO: add 'Off Hook'/'Take phone off hook [y/N]' to
        ' events--S01, when working with, if not 'Y' or 'y' then
        ' assume 'N'.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB DoEvents

  '
  ' If the current time is less than the time we finished at last time we 
  ' called this, then we must have passed midnight.
  '
  K$ = TIME$
  kz = TodayIs
  if kz = 0 then kz = 8
  IF K$ < Settings.StartTime _
     THEN CALL DoEvents1(Settings.StartTime,Short$(378),kz - 1) : _
          CALL DoEvents1(Short$(394),K$,kz) _
     ELSE CALL DoEvents1(Settings.StartTime,K$,kz)
  Settings.StartTime = K$     'If an event was scheduled for the current TIME$,
                              'we do it on the next go-around.
  K = FileOpen(FileNames$(75) + Form4$(3,Settings.Node))
  CALL FilePutLoc(K,0&,259,Settings)
  CALL FileClose(K)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will locate and execute any events from time p$
        ' to before time p0$ (events at time p0$ aren't done yet) on
        ' day p.
        '
        ' p$   starting time to consider
        '
        ' p0$  ending time to consider
        '
        ' p    day of the week to consider
        '
        ' It also sets up settings.nextevent with the time of the next
        ' event.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB DoEvents1 (p$,p0$,p)

  kz$ = p0$
  CALL DoEvents2(p$,p)
  WHILE Settings.NextEvent < p0$
    KK = FileOpen(FileNames$(72))
    k& = -64
    FOR KK2 = 1 TO FileLof&(KK,64)
      k& = k& + 64
      J$ = SPACE$(8)
      CALL FileGetSLoc(KK,k&,J$)
      j1$ = IntToTime$(CVI(LEFT$(J$,2)))
      if j1$ = Settings.NextEvent _
         THEN jj$ = TIME$ : _
              Menu.ShouldDo = RIGHT$(J$,4) : _
              CALL Dispatcher : _
              TT$ = GetLine$(855) + RIGHT$(J$,4) + GetLine$(216) + jj$ + _
                    Short$(379) : _
              CALL LogTT
    NEXT
    CALL FileClose(KK)
    kz$ = settings.nextevent
    MID$(kz$,8,1) = AscChr$(AscVal(MID$(kz$,8,1)) + 1)
    CALL DoEvents2(Kz$,p)
  WEND

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine finds the next event to do that matches, or is
        ' greater than, p$ on day p and set settings.nextevent to it.
        '
        ' p$  is the starting time to consider
        '
        ' p is the day of the week to consider
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB DoEvents2 (p$,p)

  Settings.NextEvent = Short$(378)
  K = FileOpen(FileNames$(72))
  k& = -64
  FOR K0 = 1 TO FileLof&(K,64)
    k& = k& + 64
    K0$ = SPACE$(4)
    CALL FileGetSLoc(K,k&,K0$)
    Ka = CVI(RIGHT$(K0$,2))
    K0$ = IntToTime$(CVI(LEFT$(K0$,2)))
    IF K0$ >= p$ AND K0$ < Settings.NextEvent _
       AND BitTest(Ka,p) THEN Settings.NextEvent = K0$
  NEXT
  CALL FileClose(K)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine calls other routines.
        '
        ' It relies on Menu.ShouldDo to decide what to do.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB Dispatcher

  '
  ' Handle the global-use commands.  In some cases, this means changing them
  ' into internal commands.
  '
  DoNext = 0
  DO
    IF FileIndex < 1 OR FileIndex > DirsSize THEN FileIndex = 32767
    IF BaseIndex < 0 OR BaseIndex > BasesSize THEN BaseIndex = 32767
    K9 = Val2&(Menu.ShouldDo)
    IF StrSrch1(Short$(883),AscVal(Menu.ShouldDo)) > 0 THEN BaseIndex = K9 - 1
    SELECT CASE AscVal(Menu.ShouldDo)
      CASE 97  : Menu.ShouldDo = Short$(884)
      CASE 98  : CALL DataBaser
      CASE 100 : IF RTRIM$(User.UserName) = Null$ OR DLTime > 0 _
                    THEN CALL DoorSystem
      CASE 101 : Menu.ShouldDo = Short$(909)
      CASE 102 : FileIndex = K9
      CASE 105 : CALL MsgBaseLocker(-1)
      CASE 106 : CALL MsgBaseLocker(0)
      CASE 107 : CALL UnLockedList
      CASE 108 : FileIndex = K9
                 CALL ListDir(0)
      CASE 110 : Menu.ShouldDo = Short$(910)
      CASE 112 : Menu.ShouldDo = Short$(911)
      CASE 81, 113 : CALL Questionaire
      CASE 114 : Menu.ShouldDo = Short$(912)
      CASE 115 : Menu.ShouldDo = Short$(913)
      CASE 117 : FileIndex = K9
                 CALL Upload(1)
      CASE 122 : IF RIGHT$(Menu.ShouldDo,3) = Short$(981) _
                    THEN CALL NetSendContacter(1,0&,Null$) _
                    ELSE CALL NetSendContacter(2,Val2&(Menu.ShouldDo),Null$)
    END SELECT
    SELECT CASE LEFT$(Menu.ShouldDo,2) 
      CASE Short$(914) : CALL OfferAreas(1)
      CASE Short$(915) : CALL OfferAreas(2)
      CASE Short$(916) : CALL MNxDisplays
      CASE Short$(917) : Call DirectryView
      CASE Short$(980) : Call DispBlockText(K9,C13$)
                         CALL Paused
    END SELECT
    IF LEFT$(Menu.ShouldDo,3) = Short$(918) THEN CALL StatsDisp
    '
    ' Handle the regular commands and the internal commands.
    '
    K10 = MenuCommand(Settings.Key1,Settings.Key2,Settings.Key3,Menu.ShouldDo)
    SELECT CASE K10
      CASE 1  : CALL ResetVote
      CASE 2  : CALL UpdateSumLog(3)
      CASE 3  : CALL Archiver("")                          'Don't use Null$.
      CASE 4  : CALL AddRequest
      CASE 5  : CALL AddReview
      CASE 6  : CALL UserMsgAreasDef
      CASE 7  : IF BitTest(Toggles(1),1) _
                THEN K& = DriveSpc&(FileBases(1).Path) : _
                     IF K& < Settings.AIHelpSpace THEN CALL AIHelpWanted
      CASE 8  : FileIndex = 1
                CALL Upload(2)
      CASE 9  : CALL BM01
      CASE 10 : CALL BM02
      CASE 11 : CALL BM03
      CASE 12 : CALL BM04
      CASE 13 : CALL BM05
      CASE 14 : CALL BM06
      CASE 15 : CALL BM07
      CASE 16 : CALL BM08
      CASE 17 : CALL BM09
      CASE 18 : CALL BM10
      CASE 19 : CALL Chat
      CASE 20 : CALL DescImport
      CASE 21 : CALL DirAnyWhere
      CASE 22 : CALL DisplayNews
      CASE 23 : IF CommPort = 0 THEN K11 = 982 _
                                ELSE K11 = 983
                K$ = Short$(K11)
                CALL ExpandStr(K$)
                CALL ShellDos(1,K$)
      CASE 24 : CALL DispRequests
      CASE 25 : CALL EnterMsg(0,0,Short$(717),Null$)
      CASE 26 : CALL EnterMsg(0,0,Null$,Null$)
      CASE 27 : BaseIndex = 0
                CALL EnterMsg(0,0,MsgBases(0).MsgOp,Null$)
      CASE 28 : CALL AlterTheFilesData
      CASE 29 : TT$ = BlockText2(182) + BlockText2(158) + Short$(984)
                CALL SendTT
      CASE 30 : CALL GetProtocol
      CASE 31 : CALL Hourly(0)
                IF TGot = 84 THEN TT = 10920 : _
                                  CALL SendTT : _
                                  CALL Hourly(1)
                TT = 10920
                CALL SendTT
      CASE 32 : CALL InitNewUser
      CASE 33 : CALL DoAFreeDownload(Short$(841))
      CASE 34 : CALL SkillExchange
      CASE 35 : CALL KillAFile
      CASE 36 : CALL LifeDeath
      CASE 37 : CALL ListDir(0)
      CASE 38 : CALL CallersLog(1)
      CASE 39 : CALL GetCityState
      CASE 40 : CALL Login(K)
                IF K = -1 THEN Menu.ShouldDo = Short$(921)
      CASE 41 : CALL SetAllLastReadsHigh
      CASE 42 : CALL ListDirs(0)
      CASE 43 : CALL ListDirs2(0,2)
      CASE 44 : CALL ListUsers(1)
      CASE 45 : CALL ListUsers(2)
      CASE 46 : CALL MassMail
      CASE 47 : CALL AlterFilePtr
      CASE 48 : CALL NewStuff
      CASE 49 : CALL MakeNews
      CASE 50 : CALL Apply
      CASE 51 : CALL Reminder
      CASE 52 : CALL EnterMsg(0,0,MsgBases(BaseIndex).MsgOp,Null$)
      CASE 53 : CALL ListDirs(2)
      CASE 54 : CALL SearchFile(2)
      CASE 55 : CALL GetPassword(2)
      CASE 56 : CALL Paused
      CASE 57 : CALL Profile(K$)
                IF LEN(K$) > 0 THEN CALL ProfileSLs(1) : _
                                    CALL ProfileMsgs(K$,1)
      CASE 58 : AnyUser = User
                CALL DispFile(FileNames$(64),C13$)
                CALL Paused
      CASE 59 : AnyUser = User
                CALL DispFile(FileNames$(65),C13$)
                CALL Paused
      CASE 60 : AnyUser = User
                CALL ProfileSLs(0)
      CASE 61 : AnyUser = User
                CALL ProfileMsgs("",0)                     'Don't use Null$.
      CASE 62 : IF Levels(UserSL).SecLevel >= Settings.PRMinSL _
                   AND Levels(UserSL).SecLevel <= Settings.PRMaxSL _
                   AND NOT BitTest(User.Attr,12) _
                   THEN CALL PeerReview
      CASE 63 : IF BitTest(User.Attr,13) THEN CALL RingBackVerify
      CASE 64 : K = Toggles(2)
                CALL BitClear(Toggles(2),7)
                CALL Quote
                Toggles(2) = K
      CASE 65 : CALL Ramblings
      CASE 66 : CALL ReadMessages(2)
                IF BitTest(User.Attr,2) THEN CALL HangUp
      CASE 67 : DO
                  K$ = Null$
                  CALL RemoveFile(K$)
                LOOP UNTIL LEN(K$) = 0
      CASE 68 : CALL RemoveALine
      CASE 69 : CALL BBSReview
      CASE 70 : K11 = -3
                FOR BaseIndex = 0 TO BasesSize
                  K11 = K11 + 4
                  IF MsgBases(BaseIndex).ReadSL <= Levels(UserSL).SecLevel _
                     AND CVL(MID$(UserMsgInfo$,K11,4)) >= 0 _
                     AND NOT BitTest(MsgBases(BaseIndex).SubType,2) _
                     THEN CALL ReadMessages(4)
                NEXT
                IF BitTest(User.Attr,2) THEN CALL HangUp
      CASE 71 : FOR BaseIndex = 0 TO BasesSize
                  IF BitTest(MsgBases(BaseIndex).SubType,2) _
                     THEN CALL ReadMessages(1)
                NEXT
                IF BitTest(User.Attr,2) THEN CALL HangUp
      CASE 72 : FOR BaseIndex = 0 TO BasesSize
                  IF BitTest(MsgBases(BaseIndex).SubType,2) _
                     THEN CALL ReadMessages(0)
                NEXT
                IF BitTest(User.Attr,2) THEN CALL HangUp
      CASE 73 : CALL ListMsgs
      CASE 74 : CALL CallersLog(2)
      CASE 75 : TT = 157
                IF UCASE$(LineEditTT$(30)) <> GetLine$(158) _
                   THEN TT = 159 : _
                        CALL SendTT : _
                        CALL HangUp
      CASE 76 : CALL SearchFile(1)
      CASE 77 : CALL AlterSettings
      CASE 78 : CALL StatsCalc
      CASE 79, 80 : CALL SysopTransfer
      CASE 81 : CALL GetPhoneNumber(2)
      CASE 82 : FileIndex = 1
                CALL Upload(3)
      CASE 83 : CALL Toggle(0)
      CASE 84 : CALL TypeFile
      CASE 85 : CALL Penalize
      CASE 86 : CALL Upload(1)
      CASE 87 : CALL AlterTheUsersData
      CASE 88 : CALL GetPhoneNumber(1)
      CASE 89 : CALL Toggle(1)
      CASE 90 : K = FindF(Paths$(2) + Short$(922),FFile)
                TT$ = Short$(923) + UnSq$(PID) + BlockText2(219) + FFile.FDate + _
                      Short$(985) + UnSq$(CopyRight) + Short$(984)
                CALL SendTT
      CASE 91 : CALL Vote(0)
      CASE 92 : CALL GetAVote
      CASE 93 : CALL RingBackVerify
      CASE 94 : CALL Delay
      CASE 95 : CALL Welcome
      CASE 96 : CALL Exchange
      CASE 97 : CALL Download
      CASE 98 : FileIndex = 1
                CALL Upload(1)
      CASE 99 : CALL RaiseMessages
                IF TT = 108 THEN CALL SendTT : _
                                 CALL BuildMsgPtr : _
                                 TT = 28 : _
                                 CALL SendTT
      CASE 100 : CALL RaiseUsers
      CASE 101 : CALL CreateNodeList
      CASE 102 : CALL DoAFreeDownload(Short$(842))
      CASE 103 : CALL DoAFreeDownload(Short$(843))
      CASE 104 : CALL DoAFreeDownload(Short$(844))
'  CASE 105 : CALL MsgDownload
      CASE 106 : CALL Commander
      CASE 107 : CALL ReduceCounts
      CASE 108 : CALL SearchFile(0)
      CASE 109 : CALL PagedFileSystem(0)
      CASE 110 : CALL PagedFileSystem(1)
      CASE 111 : CALL PagedFileSystem(2)
      CASE 112 : CALL SelectMArea
      CASE 113 : CALL NextArea(1)
      CASE 114 : CALL NextArea(-1)
      CASE 115 : CALL NextArea(2)
      CASE 116 : CALL NextArea(-2)
      CASE 117 : CALL PackTheDataFiles(2)
      CASE 118 : CALL PackTheDataFiles(3)
      CASE 119 : CALL VoteSummary
      CASE 120 : CALL POMessages
      CASE 121 : CALL DLPotential
      CASE 122 : CALL PackTheDataFiles(0)
      CASE 123 : CALL AlterLD
      CASE 124 : CALL ListArrays
      CASE 125 : CALL PackTheDataFiles(1)
    END SELECT
    MessageBody$ = Null$                       'Minimize excess string space.
  LOOP UNTIL DoNext = 0 OR NoCarrier

END SUB
        '
        '* * * *


