' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
'Routines used in the handling of net mail packets.  * = in this file.
'There are five parts:
'  I/O handling:
'    *NetSendContacter
'    *NetMailInBoundHandler
'    NetMailOutBoundHandler
'  .IDX construction:
'    PacketForIndividual
'    PacketForHub
'    Addressees
'    AddEchoMailToPacket
'    AddNetMailToPacket
'  .PKT contruction:
'    NewFidoPacket
'  .IDX destruction:
'    ProcessNetPointers
'  .PKT importing
'    ImportFidoPacket
'
'Using the basic logic: when called:        when calling:
'                       Get a packet        Send a packet
'                       Send a packet       Get a packet
'                       Process what sent   Process what sent
'                       Process what got    Process what got




        '* * * * * *
        ' This routine handles the contacting of another BBS to send
        ' net mail.
        '
        ' p   1 dial up hub and exchange packets whether there is mail
        '       or not.
        '     2 process a routing file by calling all the non-HUB lines
        '       if they have a packet.  K& = message base.  EchoMail.
        '     3 send an initial packet after having previously called
        '       by hand.
        '     4 process the sending of the NetMail bases.
        '
        ' p&  address if given one.  Or message base if p = 2.
        '
        ' p$  phone if given one.
        '
        ' Date last checked for perfection: Sep 18 1992
        '
SUB NetSendContacter (p,p&,p$)

  '
  ' Give the net routines their own screen.  Expand this in the future to
  ' provide full details of what's going on, as well as debug capabilities
  ' (such as a logging toggle).
  '
  TT$ = GetLine$(146) + C1310$ + C1310$
  CALL AnsiTT
  SELECT CASE p
    CASE 1
         K0 = BiSearch(4,0,MKL$(Settings.HubAddr))
         IF K0 = 0 THEN EXIT SUB
         K0$ = IntToPhone$(Node.BBSPhone)
         CALL ContactPhoneNumber(K0$)
         IF NoCarrier THEN TT$ = GetLine$(731) + K0$ + GetLine$(732) : _
                           CALL LogTT : _
                           EXIT SUB
         '
         ' Send the packet.
         '
         K0 = PacketForHub(K0$)
         TT& = NewFidoPacket(Settings.HubAddr&,K0$)
         CALL NetMailOutBoundHandler(1,K0$)
         CALL NetMailOutBoundHandler(2,Null$)
         CALL ProcessNetPointers(K0$ + Short$(165))
    CASE 2
         K1 = p&
         K3$ = FileNames$(76) + Form4$(3,K1)
         IF FindF(K3$,FFile) = 0 THEN EXIT SUB
         K0 = 0
         DO
           K0& = 0
           K1 = FileOpen(K3$)
           FOR K2 = 1 TO K0
             K0$ = FileGetLine$(K1,K0&)
           NEXT
           IF K0& = -1 THEN CALL FileClose(K1) : _
                            EXIT SUB
           '
           ' Loop, getting the next address, until reach end.  Blank lines and
           ' HUB lines are ignored.
           '
           DO
             K0 = K0 + 1
             K0$ = FileGetLine$(K1,K0&)
           LOOP UNTIL K0& = -1 OR (MID$(K0$,3,3) <> Short$(981) AND AscVal(K0$) <> 39 AND LEN(K0$) > 0)
           CALL FileClose(K1)
           IF K0& = -1 AND (LEN(K0$) = 0 OR MID$(K0$,3,3) = Short$(981)) _
              THEN EXIT SUB
           '
           ' w xxxxxx yyyyyy zzzz
           '    K0$     K1$
           '   xxxxxx             can be HUB or phone number (actually HUB's 
           '                      are stopped earlier).
           '          yyyyyy      can be @addr or a string (actually @addr
           '                      is ignored).
           '
           ' K2$ and p& = phone number, K1$ = packet pathname (no extension)
           '
           K0$ = LTRIM$(RTRIM$(MID$(LEFT$(K0$,StrSrchR(K0$,32)),3)))
           knz = StrSrch1(K0$,32)
           SELECT CASE knz
             CASE IS > 8
                  K0$ = LEFT$(K0$,knz - 1)
                  IF knz > 9 _
                     THEN p& = Val2&(MID$(K0$,2,1) + MID$(K0$,1,1) + _
                               MID$(K0$,3,1) + MID$(K0$,5,3) + MID$(K0$,9,4)) _
                     ELSE p& = Val2&(LEFT$(K0$,3) + RIGHT$(K0$,4))
                  IF PacketForIndividual(2,p&,K1$) > 0 _
                     THEN CALL ContactPhoneNumber(K0$) : _
                          IF NOT NoCarrier _
                             THEN TT& = NewFidoPacket(p&,K1$) : _
                                  CALL NetMailOutBoundHandler(1,K1$) : _
                                  CALL NetMailOutBoundHandler(2,Null$) : _
                                  CALL ProcessNetPointers(K1$ + Short$(165))
                  CALL KillFile(K1$ + Short$(165))
           END SELECT
         LOOP UNTIL K0& = -1
    CASE 3
         IF LEN(p$) = 0 AND p& = 0 THEN EXIT SUB
'function NodeListPhoneSearch& (p$)  in ovr_junk.
'and node block help: xxx-yyyy is ok.
         SELECT CASE LEN(p$)
           CASE IS > 0
                K6 = FileOpen(FileNames$(70))
                IF LEN(p$) < 12 _
                   THEN p$ = LEFT$(IntToPhone$(Settings.Phone),3) + Short$(492) + p$
                p& = Val2&(MID$(p$,2,1) + MID$(p$,1,1) + _
                           MID$(p$,3,1) + MID$(p$,5,3) + RIGHT$(p$,4))
                K2& = FileLof&(K6,1)
                K0& = -30                    '-30 + 34 = 4
                FOR kk = 1 TO K2& \ 34
                  K0& = K0& + 34
                  CALL FileGetLoc(K6,K0&,4,K1&)
                  IF p& = K1& THEN CALL FileGetLoc(K6,K0& - 4,4,p&) : _
                                   p$ = Null$ : _
                                   EXIT FOR
                  CALL ShowTheGauge(K2&,K0&)
                NEXT
                CALL FileClose(K6)
         END SELECT
         IF NOT NoCarrier _
            THEN K0 = PacketForIndividual(2 + (LEN(P$) = 0),p&,K0$)
         TT& = NewFidoPacket(p&,K0$)
         CALL NetMailOutBoundHandler(1,K0$)
         CALL NetMailOutBoundHandler(2,Null$)
         CALL ProcessNetPointers(K0$ + Short$(165))
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' Handle inbound packets (and subsequent outbound packets)
        ' after receipt of a TSYNC at login.
        '
        ' Date last checked for perfection: Sep 18 1992
        '
SUB NetMailInBoundHandler

  IF NoCarrier THEN EXIT SUB
  TT$ = GetLine$(146) + C1310$ + C1310$ + GetLine$(733) + TIME$ + _
        GetLine$(734) + C1310$
  CALL AnsiTT
  '
  ' Receive a packet.
  '
  CALL PurgeComIO(CommPort)
  K$ = RIGHT$(Short$(865) + HEX$(LogonDate),4) + _
       RIGHT$(Short$(865) + HEX$(TimeToInt(TIME$)),4)
  CALL ShellDos(4,FileNames$(28) + Short$(992) + K$ + Short$(866))
  CALL KillFile(FileNames$(27))
  K0$ = Paths$(11) + K$ + Short$(866)
  SELECT CASE FindF(K0$,FFile)
    CASE 0 : CALL HangUp
             EXIT SUB
    CASE IS <> 0
         K = FileOpen(K0$)
         CALL FileGetRec(K,1,58,FidoPkt)
         CALL FileClose(K)
         K& = StrToAddr&(FidoForm$(FidoPkt.OrigZone,FidoPkt.OrigNet,FidoPkt.OrigNode))
         K1$ = AddrToInt$(K&,K,K0,K1)
         TT$ = GetLine$(735) + _
               FidoForm$(FidoPkt.DestZone,FidoPkt.DestNet,FidoPkt.DestNode) + _
               GetLine$(736) + K1$ + GetLine$(216) + RightTime$(TIME$) + _
               Short$(379)
         CALL LogTT
  END SELECT
  TT$ = Short$(990) + TIME$ + GetLine$(737) + C1310$
  CALL AnsiTT
  TT$ = AscChr$(21)
  CALL SendTT
  IF K& = 0 THEN CALL HangUp
  IF K& = Settings.HubAddr THEN K = PacketForHub(K2$) _
                           ELSE IF NOT NoCarrier _
                                   THEN K = PacketForIndividual(1,K&,K2$) _
                                   ELSE K = 0
  IF K > 0 THEN TT& = NewFidoPacket(K&,K2$) : _
                CALL NetMailOutBoundHandler(1,K2$) _
           ELSE TT$ = GetLine$(738) + K1$ + Short$(379) : _
                CALL LogTT
  CALL HangUp
  CALL ImportFidoPacket(K0$)
  CALL ProcessNetPointers(K2$ + Short$(165))

END SUB
        '
        '* * * *

