' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
'Routines used in the handling of net mail packets.  * = in this file.
'There are five parts:
'  I/O handling:
'    NetSendContacter
'    NetMailInBoundHandler
'    NetMailOutBoundHandler
'  .IDX construction:
'    *PacketForIndividual
'    *PacketForHub
'    *Addressees
'    *AddEchoMailToPacket
'    *AddNetMailToPacket
'  .PKT contruction:
'    NewFidoPacket
'  .IDX destruction:
'    ProcessNetPointers
'  .PKT importing
'    ImportFidoPacket
'
'Using the basic logic: when called:        when calling:
'                       Get a packet        Send a packet
'                       Send a packet       Get a packet
'                       Process what sent   Process what sent
'                       Process what got    Process what got




        '* * * * * *
        ' This routine will create a packet of all waiting messages
        ' (echo and net) to a specified node-based, or phone-based,
        ' address.
        '
        ' p   1 if should match an address
        '       p& = addr
        '     2 if should match a phone number
        '       p& = phone number
        '
        ' p$  is the file name of the packet created.
        '
        ' Date last checked for perfection: Sep 12 1992
        '
FUNCTION PacketForIndividual% (p,p&,p$)

'  IF NoCarrier THEN PacketForIndividual = 0 : _
'                    EXIT FUNCTION
  SELECT CASE p
    CASE 1 : K$ = Short$(360) + AddrToInt$(p&,K0,K1,K2)
    CASE 2 : K$ = IntToPhone$(p&)
  END SELECT
  p$ = Paths$(12) + RIGHT$(Short$(865) + HEX$(K1),4) + _
       RIGHT$(Short$(865) + HEX$(K2),4)
  CALL KillFile(p$ + Short$(165))
  K0 = FileOpen(p$ + Short$(165))
  K1 = 0
  FOR K2 = 0 TO BasesSize
    SELECT CASE BitTest(MsgBases(K2).SubType,9)
      CASE -1
           '
           ' Do EchoMail.
           '
           K1$ = FileNames$(76) + Form4$(3,K2 + 1)
           SELECT CASE FindF(K1$,FFile)
             CASE IS <> 0
                  K3 = FileOpen(K1$)
                  K0& = 0
                  DO
                    K2$ = RTRIM$(FileGetLine$(K3,K0&))
                    IF AscVal(K2$) = 39 THEN K2$ = Null$
                    SELECT CASE StrSrch(1,K2$,K$)
                      CASE IS > 0
                           FWork(1).FSize = Val2&(K2$)
                           SWork$(1) = RTRIM$(MID$(LEFT$(K2$,StrSrchR(K2$,32)),3))
                           K3$ = AddrToInt$(p&,K4,Work(1),Work(2))
                           K1 = K1 + AddEchoMailToPacket(K0,K2,1)
                           K0& = -1
                    END SELECT
                  LOOP UNTIL K0& = -1
                  CALL FileClose(K3)
           END SELECT
      CASE ELSE
           '
           ' Do NetMail.
           '
           IF BitTest(MsgBases(K2).SubType,3) _
              THEN K1 = K1 + AddNetMailToPacket(K0,K2,Addressees(K2,0),p,p&)
    END SELECT
  NEXT
  CALL FileClose(K0)
  PacketForIndividual = K1

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine builds a packet of messages for a hub delivery.
        '
        ' K$  packet name.
        '
        ' Returns with the total number of messages stored.
        '
        ' Date last checked for perfection: Sep 12 1992
        '
FUNCTION PacketForHub% (p$)

  IF NoCarrier THEN PacketForHub = 0 : _
                    EXIT FUNCTION
  TT = 730
  CALL LogTT
  K0$ = AddrToInt$(Settings.HubAddr,K,K0,K1)
  p$ = Paths$(12) + RIGHT$(Short$(865) + HEX$(K0),4) + _
       RIGHT$(Short$(865) + HEX$(K1),4)
  CALL KillFile(p$ + Short$(165))
  K = FileOpen(p$ + Short$(165))
  K0 = 0
  FOR K1 = 0 TO BasesSize
    IF BitTest(MsgBases(K1).SubType,9) _
       THEN K0 = K0 + AddEchoMailToPacket(K,K1,Addressees(K1,1)) _
       ELSE IF BitTest(MsgBases(K1).SubType,3) _
               THEN K0 = K0 + AddNetMailToPacket(K,K1,Addressees(K1,1),0,0&)
  NEXT
  CALL FileClose(K)
  PacketForHub = K0

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will build our list of addressee's to give
        ' mail too.  Just loads in the ROUTING.xxx file into a form we
        ' can work with.
        '
        ' p   is message base using.
        '
        ' p0  1 if should only include HUB entries.
        '
        ' EchoMail: Returns with the number of entries, FWork()
        ' containing last-read values, SWork$() containing phones and
        ' addresses, and Work() containing net and node values.
        '
        ' NetMail: Returns with the number of entries, FWork()
        ' containing node addresses (from @addr), and SWork$()
        ' containing the phones and addresses.
        '
        ' If p0 = 1 then only those entries with HUB in the phone slot
        ' are returned.  IF p0 <> 1 then only those entries without
        ' HUB in the phone slot are returned.  p0 only matters for
        ' EchoMail.
        '
        ' Date last checked for perfection: Sep 12 1992
        '
FUNCTION Addressees% (p,p0)

  K$ = FileNames$(76) + Form4$(3,p + 1)
  IF FindF(K$,FFile) = 0 THEN Addressees = 0 : _
                              EXIT FUNCTION
  K1 = FileOpen(K$)
  K2 = 1
  K& = 0
  DO
    K$ = RTRIM$(FileGetLine$(K1,K&))
    IF AscVal(K$) = 39 THEN K$ = Null$
    SELECT CASE BitTest(MsgBases(p).SubType,9)
      CASE -1
           '
           ' EchoMail.
           '
           IF p0 = 1 AND MID$(K$,3,3) <> Short$(981) THEN K$ = Null$
           IF p0 <> 1 AND MID$(K$,3,3) = Short$(981) THEN K$ = Null$
           '
           ' If not an empty entry, then put the last-read value in FWork(),
           ' the net and node in Work(), and the phone number and address in
           ' SWork$().
           '
           SELECT CASE LEN(K$)
             CASE IS > 0
                  FWork(K2).FSize = Val2&(K$)
                  SWork$(K2) = RTRIM$(MID$(LEFT$(K$,StrSrchR(K$,32)),3))
                  '
                  ' Extract out the net and node information.
                  '
                  K4 = StrSrch1(SWork$(K2),32)
                  IF K4 > 0 THEN K$ = LTRIM$(MID$(SWork$(K2),K4)) _
                            ELSE K$ = Null$
                  SELECT CASE AscVal(K$)
                    CASE 64
                         K$ = MID$(K$,2)
                         K4 = StrSrch1(K$,47)
                         IF K4 > 0 THEN K4 = Val2&(LEFT$(K$,K4 - 1))
                         K3 = StrSrch1(K$,64)
                         IF K3 = 0 THEN K3 = LEN(K$) + 1
                         K3 = Val2&(LEFT$(K$,K3 - 1))
                    CASE ELSE
                         K3 = 0
                         K4 = 0
                  END SELECT
                  Work(K2 * 2 - 1) = K4
                  Work(K2 * 2) = K3
                  IF LEN(SWork$(K2)) > 0 THEN K2 = K2 + 1
           END SELECT
      CASE ELSE
           '
           ' NetMail.
           '
           SELECT CASE LEN(K$)
             CASE IS > 0
                  SWork$(K2) = RTRIM$(MID$(LEFT$(K$,StrSrchR(K$,32)),3))
                  K4 = StrSrch1(SWork$(K2),32)
                  IF K4 > 0 THEN K$ = LTRIM$(MID$(SWork$(K2),K4)) _
                            ELSE K$ = Null$
                  K4 = StrSrch1(K$,32)
                  IF K4 > 0 THEN K$ = LEFT$(K$,K4)
                  IF AscVal(K$) = 64 THEN FWork(K2).FSize = StrToAddr&(K$) _
                                     ELSE FWork(K2).FSize = 0
                  IF LEN(SWork$(K2)) > 0 THEN K2 = K2 + 1
           END SELECT
    END SELECT
  LOOP UNTIL K& = -1
  CALL FileClose(K1)
  Addressees = K2 - 1

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine will add EchoMail messages from an area to a
        ' FidoNet packet.  All addresses in SWork$() will have the
        ' message(s) sent to them if they haven't already seen it.
        '
        ' p   is the .IDX file handle to write to.
        '
        ' p0  is the message base working with.
        '
        ' p1  is the number of addresses to send to.
        '
        ' Returns with the number of messages found.
        '
        ' SWork$() = phone number and addresses to send to.
        '
        ' FWork() = last read values for the addresses.
        '
        ' Work() =  the net and node values.
        '
        ' The calling routine is relied upon to verify that the
        ' message area is an EchoMail area.
        '
        ' This should not be called for both HUB and non-regular
        ' messages, one or the other at one time.
        '
        ' Date last checked for perfection: Sep 12 1992
        '
FUNCTION AddEchoMailToPacket% (p,p0,p1)

  IF p1 < 1 THEN AddEchoMailToPacket = 0 : _
                 EXIT FUNCTION                        'No addressees?
  K2 = 0
  '
  ' Find our lowest last-message-read value among the group.
  '
  K& = FWork(1).FSize
  FOR K3 = 2 TO p1
    IF FWork(K3).FSize < K& THEN K& = FWork(K3).FSize
  NEXT
  '
  ' Go through all the active messages...
  '
  FOR K9  = 0 TO ActiveMessages
    IF MsgPtr(K9).MsgBase = p0 THEN IF MsgPtr(K9).MsgNum > K& THEN EXIT FOR
  NEXT
  FOR K3  = K9 TO ActiveMessages
    SELECT CASE MsgPtr(K3).MsgBase
      CASE p0
           '
           ' Message number is greater than our lowest last-read, and it's
           ' in the same message area we want.
           '
           ' So now look at all our addressee's to see if they want it.
           '
           FOR K4 = 1 TO p1
             IF FWork(K4).FSize <= MsgPtr(K3).MsgNum _
                THEN K2 = K2 + 1 : _
                     CALL FilePutSEnd(p,MKI$(K3) + MKI$(Work(K4 * 2 - 1)) + _
                                        MKI$(Work(K4 * 2)) + SWork$(K4) + C1310$)
           NEXT
    END SELECT
  NEXT
  AddEchoMailToPacket = K2

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine stores NetMail messages to a fido packet.
        '
        ' p   is the .IDX file handle to write to.
        '
        ' p0  is the message base working with.
        '
        ' p1  is the number of routing addresses we have.
        '
        ' p2  what to do:
        '     0 = hub
        '     1 = net addr
        '     2 = phone addr
        '
        ' p&  net addr or phone number.
        '
        ' SWork$() contains phone numbers and addresses.
        '
        ' FWork() contains our destionation addresses.
        '
        ' Returns with the number of messages found.
        '
        ' Date last checked for perfection: Sep 12 1992
        '
FUNCTION AddNetMailToPacket% (p,p0,p1,p2,p&)

  K2 = 0
  '
  ' Go through all the active messages...
  '
  FOR K4  = 0 TO ActiveMessages
    SELECT CASE MsgPtr(K4).MsgBase
      CASE p0
           '
           ' Message is in the area we want.  So get its header.
           '
           CALL FileGetLoc(Handle(3),MsgPtr(K4).MsgLoc - 1,128,Message)
           SELECT CASE BitTest(Message.NetAttr,4)
             CASE 0
                  '
                  ' Message has not yet been sent.
                  '
                  K9 = 0
                  SELECT CASE p2
                    CASE 0
                         '
                         ' We are sending HUB routed mail.
                         ' Rules:
                         ' If SWork$() entry with HUB,
                         ' If node list entry without SWork$() non-HUB entry,
                         ' then send it.
                         '
                         SELECT CASE Message.DestAddr
                           CASE IS <> 0
                                K5 = BiSearch(4,0,MKL$(Message.DestAddr))
                                FOR K6 = 1 TO p1
                                  IF FWork(K6).FSize = Message.DestAddr _
                                     THEN IF LEFT$(SWork$(K6),3) <> Short$(981) _
                                             THEN K5 = 0 : _
                                                  EXIT FOR _
                                             ELSE K5 = 1 : _
                                                  EXIT FOR
                                NEXT
                                IF K5 > 0 THEN K9 = 1
                         END SELECT
                    CASE 1
                         '
                         ' We are sending to a single address.
                         '
                         IF Message.DestAddr = p& THEN K9 = 1
                    CASE 2
                         '
                         ' We are sending to a single phone number.
                         '
                         MessageBody$ = SPACE$(Message.NumOfBytes)
                         CALL FileGetSLoc(Handle(3),MsgPtr(K4).MsgLoc + 127,MessageBody$)
                         K$ = C1$ + Short$(919) + IntToPhone$(p&)
                         IF BitTest(Message.Attr,2) THEN K$ = Sq$(K$)
                         IF StrSrch(1,MessageBody$,K$) > 0 THEN K9 = 1
                  END SELECT
                  IF K9 = 1 _
                     THEN K$ = AddrToInt$(Message.DestAddr,K6,kz1,kz2) : _
                          K$ = MKI$(K4) + MKI$(kz1) + MKI$(kz2) + C1310$ : _
                          CALL FilePutSEnd(p,K$) : _
                          K2 = K2 + 1
           END SELECT
    END SELECT
  NEXT
  AddNetMailToPacket = K2

END FUNCTION
        '
        '* * * *

