' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
'Routines used in the handling of net mail packets.  * = in this file.
'There are five parts:
'  I/O handling:
'    NetSendContacter
'    NetMailInBoundHandler
'    *NetMailOutBoundHandler
'  .IDX construction:
'    PacketForIndividual
'    PacketForHub
'    Addressees
'    AddEchoMailToPacket
'    AddNetMailToPacket
'  .PKT contruction:
'    *NewFidoPacket
'  .IDX destruction:
'    *ProcessNetPointers
'  .PKT importing
'    *ImportFidoPacket
'
'Using the basic logic: when called:        when calling:
'                       Get a packet        Send a packet
'                       Send a packet       Get a packet
'                       Process what sent   Process what sent
'                       Process what got    Process what got




        '* * * * * *
        ' This routine handles the sending of a packet after first
        ' having received a packet.
        '
        ' p    1 to handle the sending of a netmail packet.
        '      2 to handle the receiving of a netmail packet.
        '
        ' p$  packet to send.
        '
        ' Date last checked for perfection: Sep 13 1992
        '
SUB NetMailOutBoundHandler (p,p$)

  IF NoCarrier THEN EXIT SUB
  SELECT CASE p
    CASE 1
         '
         ' Send a packet.
         '
         K0 = FindF(p$ + Short$(866),FFile)
         TT$ = Short$(990) + TIME$ + GetLine$(721) + C1310$
         CALL AnsiTT
         TT$ = AscChr$(174)
         CALL SendTT
         CALL ShellDos(5,FileNames$(28) + Short$(991) + p$ + Short$(866))
         CALL KillFile(p$ + Short$(866))
         K0 = FileOpen(FileNames$(27))
         K1$ = FileGetLine$(K0,0&)
         CALL FileClose(K0)
         CALL KillFile(FileNames$(27))
         IF AscVal(K1$) = 83 _
            THEN TT$ = GetLine$(722) + _
                       FidoForm$(FidoPkt.DestZone,FidoPkt.DestNet,FidoPkt.DestNode) + _
                       GetLine$(216) + RightTime$(TIME$) + GetLine$(217) + _
                       STR$(TT&) + GetLine$(218) : _
                 CALL LogTT _
            ELSE CALL HangUp : _
                 CALL KillFile(p$ + Short$(165))
    CASE 2
         '
         ' Receive a packet.  DSZ will delete it if incomplete.
         '
         CALL PurgeComIO(CommPort)
         K1$ = RIGHT$(Short$(865) + HEX$(LogonDate),4) + _
               RIGHT$(Short$(865) + HEX$(TimeToInt(TIME$)),4) + Short$(866)
         CALL ShellDos(4,FileNames$(28) + Short$(992) + K1$)
         CALL KillFile(FileNames$(27))
         K1$ = Paths$(11) + K1$
         CALL HangUp
         SELECT CASE FindF(K1$,FFile)
           CASE IS <> 0
                K6 = FileOpen(K1$)
                CALL FileGetRec(K6,1,58,FidoPkt)
                CALL FileClose(K6)
                TT$ = GetLine$(723) + _
                      FidoForm$(FidoPkt.OrigZone,FidoPkt.OrigNet,FidoPkt.OrigNode) + _
                      GetLine$(216) + RightTime$(TIME$) + Short$(379)
                CALL LogTT
                CALL ImportFidoPacket(K1$)
         END SELECT
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine starts a new packet in the FidoNet format.
        '
        ' p&  is the address the packet is going to.
        '
        ' p$  is the packet name.
        '
        ' It returns with the number of messages packed.
        '
        ' Date last checked for perfection: Sep 13 1992
        '
FUNCTION NewFidoPacket% (p&,p$)

  IF NoCarrier THEN EXIT FUNCTION
  IF FindF(p$ + Short$(165),FFile) = 0 THEN EXIT FUNCTION
  '
  ' A TYPE-2 (FTS-0001) packet,
  '
  FidoPkt.PktType  = 2
  FidoPkt.ProdCode = AscChr$(255)
  FidoPkt.Serial   = AscChr$(5)
  FidoPkt.Baud     = 0
  '
  ' leaving our current node,
  '
  K0$ = AddrToInt$(Settings.Addr,FidoPkt.OrigZone,FidoPkt.OrigNet,FidoPkt.OrigNode)
  '
  ' going to another node,
  '
  K0$ = AddrToInt$(p&,FidoPkt.DestZone,FidoPkt.DestNet,FidoPkt.DestNode)
  FidoPkt.Password = STRING$(8,0)
  '
  ' today,
  '
  CALL DateDMY(LogonDate,FidoPkt.Day,FidoPkt.Month,K)
  FidoPkt.Year = 1980 + K
  '
  ' this moment.
  '
  K0$ = TIME$
  FidoPkt.Hour    = Val2&(LEFT$(K0$,2))
  FidoPkt.Minute  = Val2&(MID$(K0$,4,2))
  FidoPkt.Seconds = Val2&(K0$)
  '
  ' Store the packet header.
  '
  CALL KillFile(p$ + Short$(866))
  K = FileOpen(p$ + Short$(866))
  CALL FilePutRec(K,1,58,FidoPkt)
  '
  ' Some Fido message constants.
  '
  FidoMsg.MsgType = 2
  FidoMsg.Cost    = 0
  '
  ' Based on our .IDX file...
  '
  K0 = FileOpen(p$ + Short$(165))
  K1 = 0
  K2 = -1
  K0& = 0
  DO
    K0$ = FileGetLine$(K0,K0&)
    SELECT CASE LEN(K0$)
      CASE IS > 0
           '
           ' Create a packet entry for each message.
           '
           K3 = CVI(LEFT$(K0$,2))
           SELECT CASE K3
             CASE IS <> K2
                  '
                  ' Load up message for first time.
                  '
                  CALL FileGetLoc(Handle(3),MsgPtr(K3).MsgLoc - 1,128,Message)
                  MessageBody$ = SPACE$(Message.NumOfBytes)
                  CALL FileGetSLoc(Handle(3),MsgPtr(K3).MsgLoc + 127,MessageBody$)
                  IF BitTest(Message.Attr,2) _
                     THEN MessageBody$ = UnSq$(MessageBody$)
                  CALL ReplaceCharacters(MessageBody$,0,Null$,62)
                  IF BitTest(MsgBases(MsgPtr(K3).MsgBase).SubType,2) _
                     THEN FidoMsg.Attr = 1 _
                     ELSE FidoMsg.Attr = 0
                  K1$ = UnSq$(Message.MsgSubject)
                  MessageBody$ = IntToDate3$(LogonDate) + Short$(867) + _
                                 TIME$ + C0$ + RTRIM$(Message.MsgTo) + C0$ + _
                                 RTRIM$(Message.MsgFrom) + C0$ + _
                                 LEFT$(K1$,71) + C0$ + MessageBody$
                  K1$ = AddrToInt$(Message.SourceAddr,K4,FidoMsg.OrigNet,FidoMsg.OrigNode)
                  K2 = K3
           END SELECT
           FidoMsg.DestNet = CVI(MID$(K0$,3,2))
           FidoMsg.DestNode = CVI(MID$(K0$,5,2))
           kz2 = StrSrch(1,MessageBody$,C1$ + Short$(929))
           nn$ = FidoForm$(0,FidoMsg.DestNet,FidoMsg.DestNode)
           IF kz2 > 0 THEN IF MID$(MessageBody$,kz2 + 8,LEN(nn$)) = nn$ _
                              THEN MessageBody$ = Null$
           SELECT CASE LEN(MessageBody$)
             CASE IS > 0
                  K0$ = MID$(K0$,7)
                  CALL FilePutLoc(K,FileLof&(K,1),14,FidoMsg)
                  SELECT CASE BitTest(MsgBases(MsgPtr(K3).MsgBase).SubType,9)
                    CASE -1
                         '
                         ' Put in our DEST line:
                         '   ^ADest: via PHONE to ADDRESS
                         '   ^ADest: via HUB to @1:154/900@FidoNet.org
                         '   ^ADest: via HUB to 1-414-643-1576 Immortality
                         '   ^ADest: via 1-414-643-1576 @1:154/900 Immortality
                         '
                         K4 = StrSrch1(K0$,32) - 1
                         IF K4 < 1 THEN K4 = LEN(K0$)
                         K1$ = C1$ + Short$(919) + LEFT$(K0$,K4) + Short$(383) + _
                               LTRIM$(MID$(K0$,K4)) + C13$ + C0$
                    CASE ELSE : K1$ = C0$
                  END SELECT
                  CALL FilePutSEnd(K,MessageBody$ + K1$)
                  K1 = K1 + 1
           END SELECT
    END SELECT
  LOOP UNTIL K0& = -1
  CALL FilePutSEnd(K,STRING$(4,0))
  CALL FileClose(K)
  CALL FileClose(K0)
  NewFidoPacket = K1

END FUNCTION
        '
        '* * * *




        '* * * * * *
        ' This routine updates the last-read and SENT
        ' pointers/attributes after successfully sending a net mail
        ' packet.
        '
        ' p$  packet .IDX file name.
        '
        ' Date last checked for perfection: Sep 13 1992
        '
SUB ProcessNetPointers (p$)

  IF FindF(p$,FFile) = 0 THEN EXIT SUB
  K = FileOpen(p$)
  K& = FileLof&(K,1)
  K0$ = FileGetLineR$(K,K&)
  WHILE K& <> -1 OR LEN(K0$) > 0
    K0 = CVI(LEFT$(K0$,2))
    SELECT CASE BitTest(MsgBases(MsgPtr(K0).MsgBase).SubType,9)
      CASE -1
           K0$ = MID$(K0$,7)
           K1$ = FileNames$(76) + Form4$(3,MsgPtr(K0).MsgBase + 1)
           K1 = FileOpen(K1$)
           K0& = 0
           DO : K2$ = LTRIM$(FileGetLine$(K1,K0&))
           LOOP UNTIL K0& = -1 OR StrSrch(1,K2$,K0$)
           SELECT CASE MsgPtr(K0).MsgNum
             CASE IS > Val2&(K2$)
                  K2 = FileOpen(FileNames$(10))
                  K0& = 0
                  DO
                    K3$ = LTRIM$(FileGetLine$(K1,K0&))
                    IF K3$ = K2$ _
                       THEN K3$ = LEFT$(K3$,StrSrchR(K3$,32)) + _
                                  LTRIM$(STR$(MsgPtr(K0).MsgNum))
                    CALL FilePutSEnd(K2,K3$ + C1310$)
                  LOOP UNTIL K0& = -1
                  CALL FileClose(K1)
                  CALL FileClose(K2)
                  CALL CopyFile(1,FileNames$(10),K1$)
             CASE ELSE : CALL FileClose(K1)
           END SELECT
      CASE ELSE
           CALL FileGetLoc(Handle(3),MsgPtr(K0).MsgLoc - 1,128,Message)
           CALL BitSet(Message.NetAttr,4)
           CALL FilePutLoc(Handle(3),MsgPtr(K0).MsgLoc - 1,128,Message)
    END SELECT
    K0$ = FileGetLineR$(K,K&)
  WEND
  CALL FileClose(K)
  CALL KillFile(p$)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will import a fido packet of messages into the
        ' MESSAGES file and into the BBS itself.
        '
        ' p$  is the pathname to import.
        '
        ' Date last checked for perfection: Sep 13 1992
        '
SUB ImportFidoPacket (p$)

  IF LEN(p$) = 0 OR FindF(p$,FFile) = 0 THEN EXIT SUB
  K3$ = C1$ + Short$(929) + AddrToInt$(Settings.Addr,a,b,c)
  '
  ' We import netmail into the first active netmail (only) area we come across.
  ' If none, we use Private Mail.
  '
  Work(1) = -1                             'Private netmail.
  Work(2) = -1                             'Public netmail.
  K2 = 2
  FOR K0 = 0 TO BasesSize
    IF BitTest(MsgBases(K0).SubType,9) _
       THEN K2 = K2 + 1 : _
            Work(K2) = K0 : _
            SWork$(K2) = Short$(878) + UCASE$(RTRIM$(MsgBases(K0).Title)) + C13$ _
       ELSE IF BitTest(MsgBases(K0).SubType,3) _
               THEN IF BitTest(MsgBases(K0).SubType,2) THEN Work(1) = K0 : _
                                                       ELSE Work(2) = K0
  NEXT
  IF Work(1) = -1 THEN Work(1) = Work(2)
  IF Work(2) = -1 THEN Work(2) = Work(1)
  IF Work(1) = -1 THEN Work(1) = 0 : _
                       Work(2) = 0
  '
  ' Get the FTS-0001 TYPE-2 packet header.
  '
  K4 = FileOpen(p$)
  '
  ' Check remaining size: 58 for header length,
  '                       14 for packet header length,
  '                       4 for message header fields (four chr$(0)'s),
  '                       3 for closing (three chr$(0)'s).
  ' If less, than what's left is garbage.
  '
  IF FileLof&(K4,1) < 79 OR DriveSpc&(FileNames$(2)) < FileLof&(K4,1) _
     THEN CALL FileClose(K4) : _
          CALL KillFile(p$) : _
          EXIT SUB
  CALL FileGetRec(K4,1,58,FidoPkt)
  '
  ' Start pumping messages into our message base.
  '
  K& = 58
  K0 = 0
  DO
    CALL FileGetLoc(K4,K&,14,FidoMsg)
    K& = K& + 14
    Message.SourceAddr = StrToAddr&(FidoForm$(0,FidoMsg.OrigNet,FidoMsg.OrigNode))
    Message.DestAddr = StrToAddr&(FidoForm$(0,FidoMsg.DestNet,FidoMsg.DestNode))
    Message.NetAttr = 0
    IF Message.DestAddr = Settings.Addr THEN CALL BitSet(Message.NetAttr,4) _
                                        ELSE CALL BitClear(Message.NetAttr,4)
    FOR K = 1 TO 5
      K1$ = Null$
      K0$ = C0$
      DO
        IF LEN(K1$) < 8192 AND K0$ <> C0$ THEN K1$ = K1$ + K0$
        CALL FileGetSLoc(K4,K&,K0$)
        K& = K& + 1
      LOOP UNTIL K0$ = C0$ OR K& > FileLof&(K4,1)
      SELECT CASE K
        CASE 1
        CASE 2 : Message.MsgTo = UCASE$(LTRIM$(K1$))
        CASE 3 : Message.MsgFrom = UCASE$(LTRIM$(K1$))
        CASE 4 : Message.MsgSubject = Sq$(LTRIM$(RTRIM$(K1$)))
        CASE 5
             IF StrSrch(1,K1$,K3$) > 0 THEN K1$ = Null$
             MessageBody$ = K1$
             K1 = StrSrch(1,MessageBody$,C13$ + C13$)
             WHILE K1 > 0
               MessageBody$ = LEFT$(MessageBody$,K1) + C32$ + _
                              MID$(MessageBody$,K1 + 1)
               K1 = StrSrch(K1,MessageBody$,C13$ + C13$)
             WEND
             Message.MsgBase = 0          'If nothing else, then Private Mail.
             K1 = StrSrch(1,K1$,Short$(878))            'Search for AREA:
             SELECT CASE K1
               CASE 0                                   'Not EchoMail.
                    IF BitTest(FidoMsg.Attr,1) THEN Message.MsgBase = Work(1) _
                                               ELSE Message.MsgBase = Work(2)
               CASE ELSE                                'EchoMail.
                    FOR K3 = 3 TO K2
                      IF StrSrch(K1,K1$,SWork$(K3)) > 0 _
                         THEN Message.MsgBase = Work(K3) : _
                              EXIT FOR
                    NEXT
             END SELECT
             CALL StrXLate(K1$,HighFilter$)
             IF RTRIM$(K1$) = Null$ THEN MessageBody$ = Sq$(MessageBody$) : _
                                         CALL BitSet(Message.Attr,2)
             CALL BitSet(Message.Attr,4)
             IF LEN(RTRIM$(MessageBody$)) > 0 THEN K0 = K0 + 1 : _
                                                   CALL AddAMessage(0)
      END SELECT
    NEXT
  LOOP UNTIL K& + 21 > FileLof&(K4,1)
  CALL FileClose(K4)
  CALL KillFile(p$)
  TT$ = GetLine$(215) + _
        FidoForm$(FidoPkt.OrigZone,FidoPkt.OrigNet,FidoPkt.OrigNode) + _
        GetLine$(216) + RightTime$(TIME$) + GetLine$(217) + STR$(k0) + _
        GetLine$(218)
  CALL LogTT

END SUB
        '
        '* * * *

