'
' to compile: BC NEWLINES.BAS /O/S;
' to link   : LINK NEWLINES,,,BCL70ENR+ASSEMBLY\JDRBBS,,
' requires  : BC.EXE, LINK.EXE, BCL70ENR.LIB, and JDRBBS.LIB
'
' note: the newest version is assumed to be longer than the others (higher
'       line numbers).
'

DEFINT A-Z
DECLARE FUNCTION AscChr$ (BYVAL Inpt%)
DECLARE SUB      FileClose (BYVAL Handle%)
DECLARE SUB      FileGetSLoc (BYVAL Handle%, BYVAL Location&, Inpt$)
DECLARE FUNCTION FileLof& (BYVAL Handle%, BYVAL Divisor%)
DECLARE FUNCTION FileOpen% (FileName$)
DECLARE SUB      FilePutSEnd (BYVAL Handle%, Inpt$)
DECLARE FUNCTION StrSrch1% (Inpt$, BYVAL Find%)
DECLARE FUNCTION FileGetLine$ (Handle%,Position&)
DECLARE FUNCTION FileGetLines$ (Handle%,Position&)

CLS
PRINT
PRINT "NewLines.                JDR_BBS upgrade utility to revise your LINES.001 file."
PRINT
PRINT "This utility will compare the LINES.001 file that came with a previous version"
PRINT "of JDR_BBS, the LINES.001 for the current version, and your LINES.001 file."
PRINT "Maintaining changes you've made, while updating the rest of the file"
PRINT "appropriately."
PRINT
PRINT "Review NEWLINES.LOG to confirm your changes were properly incorporated into the"
PRINT "new LINES.001 file."
PRINT
PRINT "Remarks are not preserved.  Lines that are not in order (such as having 201 203"
PRINT "202 204 205, or 201 202 204 205) will cause trouble--after running, fix them"
PRINT "and re-run again."
PRINT
PRINT

OldLines$ = "LINES06.001"
NewLines$ = "LINES07.001"
OrigLines$ = "LINES.001"
OutLines$ = "LINES.NEW"
PRINT "LINES.001 from previous version [" + OldLines$ + "]";
INPUT a$
IF LEN(a$) > 0 THEN OldLines$ = a$
PRINT "LINES.001 from later version [" + NewLines$ + "]";
INPUT a$
IF LEN(a$) > 0 THEN NewLines$ = a$
PRINT "LINES.001 you've been using [" + OrigLines$ + "]";
INPUT a$
IF LEN(a$) > 0 THEN OrigLines$ = a$
PRINT "New LINES.001 to be created [" + OutLines$ + "]";
INPUT a$
IF LEN(a$) > 0 THEN OutLines$ = a$
PRINT "Working..."

C1310$ = AscChr$(13) + AscChr$(10)
K1 = FileOpen(NewLines$)
K2 = FileOpen(OldLines$)
K3 = FileOpen(OrigLines$)
K4 = FileOpen(OutLines$)
K5 = FileOpen("NEWLINES.LOG")
K1& = 0
K2& = 0
K3& = 0

DO
  DO
    A$ = FileGetLines$(K1,K1&)
    IF LEFT$(A$,1) = "'" THEN CALL FilePutSEnd(K4,A$ + C1310$)
  LOOP UNTIL LEFT$(A$,1) <> "'" OR K1& < 0
  IF K2& >= 0 THEN DO : B$ = FileGetLines$(K2,K2&) : _
                   LOOP UNTIL LEFT$(B$,1) <> "'" OR K2& < 0
  IF K3& >= 0 THEN DO : C$ = FileGetLines$(K3,K3&) : _
                   LOOP UNTIL LEFT$(C$,1) <> "'" OR K3& < 0

  SELECT CASE LEFT$(A$,4)
    CASE LEFT$(B$,4), LEFT$(C$,4)
         SELECT CASE A$
           CASE B$
                SELECT CASE C$
                  CASE A$ : CALL FilePutSEnd(K4,A$ + C1310$)  'A$ = B$ = C$
                  CASE ELSE                                   '(A$ = B$) <> C$
                       TT$ = "A modification by you:" + C1310$ + _
                             "old  :  " + B$ + C1310$ + "yours:> " + C$ + _
                             C1310$ + "new  :  " + A$ + C1310$ + "||||" + _
                             C1310$
                       CALL FilePutSEnd(K5,TT$)
                       CALL FilePutSEnd(K4,C$ + C1310$)
                END SELECT
           CASE ELSE
                SELECT CASE B$
                  CASE C$ : CALL FilePutSEnd(K4,A$ + C1310$)  'A$ <> (B$ = C$)
                  CASE ELSE                                   'A$ <> B$ <> C$
                       TT$ = "**You modified and I modified:" + C1310$ + _
                             "old  :  " + B$ + C1310$ + "yours:  " + C$ + _
                             C1310$ + "new  :> " + A$ + C1310$ + _
                             "||||" + C1310$
                       CALL FilePutSEnd(K5,TT$)
                       CALL FilePutSEnd(K4,A$ + C1310$)
                END SELECT
         END SELECT
    CASE ELSE
         TT$ = "**Line Number mismatch:" + C1310$ + "old  :  " + B$ + _
               C1310$ + "yours:  " + C$ + C1310$ + "new  :> " + A$ + _
               C1310$ + "||||" + C1310$
         IF K2& > 0 OR K3& > 0 THEN CALL FilePutSEnd(K5,TT$)
         CALL FilePutSEnd(K4,A$ + C1310$)
  END SELECT
LOOP UNTIL K1& < 0

CALL FileClose(K1)
CALL FileClose(K2)
CALL FileClose(K3)
CALL FileClose(K4)
CALL FileClose(K5)
PRINT
PRINT "Now just copy " + OutLines$ + " over your old LINES.001."
PRINT

END



        '* * * * * *
        ' This routine retrieves the next line of 'sequential' text
        ' from an already opened file.
        '
        ' p   file number to read from.
        '
        ' p&  location to start reading from.  p& is increased by the
        '     size of the returned string + 2.  -1 is returned at EOF.
        '
        ' If the retrieved 128 byte buffer has no CR/LF, then returns
        ' with all 128 bytes read.
        '
        ' A line with only a CR/LF on it is returned as a null.
        '
        ' The CR/LF is not included in the returned text.
        '
        ' At EOF, returned text may or may not contain text, but p&
        ' will be -1.
        '
        ' The last line read may or may not contain data (assume it
        ' does).
        '
        ' Date last checked for perfection: Sep 10 1992
        '
FUNCTION FileGetLine$ (p,p&)

  IF p& >= FileLof&(p,1) - 2 THEN FileGetLine$ = Null$ : _
                                  p& = -1 : _
                                  EXIT FUNCTION
  k$ = SPACE$(128)
  CALL FileGetSLoc(p,p&,k$)
  k = StrSrch1(k$,13)
  IF k = 0 THEN k = 128
  IF k > 0 THEN k$ = LEFT$(k$,k - 1) : _
                p& = p& + k + 1 : _
                IF p& >= FileLof&(p,1) - 2 THEN p& = -1
  FileGetLine$ = k$

END FUNCTION
        '
        '* * * *


FUNCTION FileGetLines$ (p,p&)

  k$ = FileGetLine$(p,p&)
  k& = p&
  k0$ = FileGetLine$(p,k&)
  WHILE LEFT$(k0$,4) = "\\\\"
    k$ = k$ + AscChr$(13) + AscChr$(10) + k0$
    p& = k&
    k0$ = FileGetLine$(p,k&)
  WEND
  FileGetLines$ = k$

END FUNCTION
