' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will analyze the protocol's log file after file
        ' transfers.
        '
        ' p     1 for uploads only
        '       0 for downloads only
        '      -1 for both uploads and downloads
        '         The purpose for this is to decide where to deduct
        '         the minutes used.
        '
        ' p$   for uploads: a description if entered
        '      for downloads: returns 1 if at least one file was
        '                     sent (for auto-logoff)
        '
        ' p00$ User name (for Target)
        '
        ' p0$  transfer session's start time
        '
        ' p1$  protocol used.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB ProcessLog (p,p$,p00$,p0$,p1$)

  IF BitTest(User.Toggles,1) THEN CALL CommOut(C7$ + C7$)
  K1 = ElapsedTime(p0$,K2)
  SELECT CASE p
    CASE -1, 1
         User.MinsULing = User.MinsULing + K1
         SumLog.MinsULing = SumLog.MinsULing + K1
         IF DriveSpc&(Paths$(1)) < Settings.MinSpace _
            THEN CALL KillFile(FileNames$(11))
         '
         ' Clear the input buffer after doing uploads.  Purge and delay until we
         ' stop receiving characters.
         '
         FOR K2 = 1 to 10
           CALL Delay
           IF CommIn(0) >= 0 THEN CALL PurgeComIO(CommPort) _
                             ELSE EXIT FOR
         NEXT
         IF K2 = 11 THEN CALL HangUp
  END SELECT
  IF p < 1 THEN User.MinsDLing = User.MinsDLing + K1 : _
                SumLog.MinsDLing = SumLog.MinsDLing + K1
  CALL AdjustProtocol(p1$)
  IF FindF(MID$(TT$,54,40),FFile) = 0 THEN EXIT SUB
  K8 = FileIndex
  K5$ = TT$
  K& = Settings.HiFilePtr
  TT = 10107
  CALL SendTT
  IF p <> 0 THEN CALL KillFile(FileNames$(49))
  K3 = FileOpen(FileNames$(49))            'FNAMES.CTL
  K4 = FileOpen(MID$(K5$,54,40))           'Protocol log, usually DSZLOG
  K5 = FileOpen(FileNames$(4))             'FILELIST.
  K10 = FileOpen(FileNames$(8))            'FNAMES.DAT
  K0& = 0
  IF LEN(p$) > 3 THEN K3$ = p$ _
                 ELSE K3$ = Null$
  DO
    K4$ = FileGetLine$(K4,K0&)
    K6 = 0       'assume a neutral successful upload state.
    K7 = 0       'assume a neutral successful download state.
    K2$ = WordsGet$(K4$,CVI(MID$(K5$,14,2)),K2)
    IF StrSrch(1,RTRIM$(MID$(K5$,11,3)),K2$) > 0 _
       OR StrSrch(1,K2$,RTRIM$(MID$(K5$,11,3))) > 0 _
       THEN K7 = -1
    IF StrSrch(1,RTRIM$(MID$(K5$,7,3)),K2$) > 0 _
       OR StrSrch(1,K2$,RTRIM$(MID$(K5$,7,3))) > 0 _
       THEN K6 = -1
    IF K2$ = MID$(K5$,10,1) THEN K7 = 1
    IF K2$ = MID$(K5$,6,1) THEN K6 = 1
    TT$ = K4$
    K4$ = UCASE$(WordsGet$(K4$,CVI(MID$(K5$,16,2)),K2))
    K2 = StrSrchR(K4$,92)
    IF K2 = 0 THEN K2 = StrSrchR(K4$,47)
    IF K2 > 0 THEN K4$ = MID$(K4$,K2 + 1)
    IF LEN(K4$) = 0 THEN K4$ = Short$(902) : _
                         K9 = 0 _
                    ELSE K9 = BiSearch(3,0,FORM$(1201,K4$))
    IF K9 > 0 THEN FileIndex = FileIDX.FArea _
              ELSE FileIndex = K8
    CALL LogTT                      'Do logging here because we want FileIndex.
    '
    ' K6 could be -1 wrongly: when the file is on-line, the user fails to DL
    ' it, and the fail DL string is in the fail UL string ('E').  Fixed by
    ' checking: 1. file on-line, 2. file not incomplete.
    '
    IF K6 = -1 AND K9 > 0 _
       THEN IF NOT BitTest(FileIDX.Attr,7) THEN K6 = 0 : _
                                                K7 = -1
    SELECT CASE K7
      CASE -1
           User.BadDLs = User.BadDLs + 1
           SumLog.BadDLs = SumLog.BadDLs + 1
      CASE 1
           SELECT CASE K9
             CASE IS > 0
                  CALL FileGetRec(K5,FileIDX.FRec,119,FileList)
                  FileList.Downloaded = FileList.Downloaded + 1
                  FileList.LastDLed = LogonDate
                  CALL FilePutRec(K5,FileIDX.FRec,119,FileList)
                  p$ = Short$(903)
                  SumLog.DLBytes = SumLog.DLBytes + FileList.FSize
                  SumLog.Dnlds = SumLog.Dnlds + 1
                  IF NOT (BitTest(FileList.Attr,2) _
                     OR (BitTest(FileList.Attr,2) AND ConnectCPS >= 800)) _
                     THEN User.Dnlds = User.Dnlds + 1 : _
                          User.DLBytes = User.DLBytes + FileList.FSize _
                     ELSE K1 = K1 - FileList.FSize \ (ConnectCPS * 57&) : _
                          IF K1 < 0 THEN K1 = 0
           END SELECT
    END SELECT
    K2$ = RTRIM$(FileBases(FileIndex).Path) + K4$
    K2 = 0
    IF K6 <> 0 THEN K2 = FindF(K2$,FFile) : _
                    IF K6 = 1 AND K2 = 0 THEN K6 = -1
    SELECT CASE K6
      CASE -1
           User.BadULs = User.BadULs + 1
           SumLog.BadULs = SumLog.BadULs + 1
           IF K2 <> 0 AND K9 = 0 _ 
              THEN CALL CreateFileStuff(3,64,0,K5) : _
                   CALL FilePutRec(K5,FileLof&(K5,119) + 1,119,FileList) : _
                   K& = K& + 1 : _
                   FileBases(FileIndex).HiFilePtr = FileList.HiFilePtr : _
                   K2 = FileOpen(FileNames$(20)) : _
                   CALL FilePutRec(K2,FileIndex,184,FileBases(FileIndex)) : _
                   CALL FileClose(K2)
           '
           ' Note, we increment K& to match Settings.HiFilePtr.  We do this
           ' because we don't want to send a 'thank's for the UL's' message
           ' if there was no successful/complete UL.
           '
      CASE 1
           CALL FilePutSEnd(K3,RTRIM$(K2$) + C1310$)
           IF LEN(p00$) > 0 _
              THEN K2$ = MessageBody$ : _
                   MessageBody$ = GetLine$(441) + IntTodate3$(LogonDate) + _
                                  Short$(904) + NCR$(User.Username) + _
                                  GetLine$(142) + RTRIM$(FFile.FName) + _
                                  GetLine$(143) : _
                   CALL ComputerSend(p00$) : _
                   MessageBody$ = K2$
           IF K9 > 0 THEN IF NOT BitTest(FileIDX.Attr,7) THEN K9 = -1
           SELECT CASE K9
             CASE -1
                  '
                  ' File was already on-line, a duplicate upload.
                  '
                  TT$ = Short$(905) + Form$(1502,K4$) + BlockText2(61)
                  CALL SendTT
             CASE ELSE
                  '
                  ' IF K9 = 0 then file is new, else it's a former <incomplete>.
                  '
                  SELECT CASE K9
                    CASE 0
                         CALL CreateFileStuff(1,0,9,0)
                         FileBases(FileIndex).HiFilePtr = FileList.HiFilePtr
                         K2 = FileOpen(FileNames$(20))
                         CALL FilePutRec(K2,FileIndex,184,FileBases(FileIndex))
                         CALL FileClose(K2)
                    CASE ELSE
                         CALL FileGetRec(K5,FileIDX.FRec,119,FileList)
                         CALL BitClear(FileIDX.Attr,7)
                         CALL FilePutRec(Handle(22),K9,22,FileIDX)
                         CALL BitClear(FileList.Attr,7)
                         FileList.FSize = FFile.FSize
                  END SELECT
                  FileList.FDesc = K3$
                  CALL GetDesc(4,Short$(121),Form$(1502,K4$))
                  IF K4$ = UCASE$(RTRIM$(FileList.FDesc)) _
                     THEN FileList.FDesc = Null$
                  IF LEN(p00$) > 0 THEN FileList.LDCount = 2 _
                            ELSE CALL GiveCredit(Null$,CVI(MID$(K5$,18,2))) : _
                                 User.ULBytes = User.ULBytes + FFile.FSize : _
                                 User.Uplds = User.Uplds + 1
                  SumLog.Uplds = SumLog.Uplds + 1
                  SumLog.ULBytes = SumLog.ULBytes + FFile.FSize
                  CALL DispCRLF
                  IF (AscVal(FileList.FDesc) = 92 _
                      OR AscVal(FileList.FDesc) = 47) _
                     AND User.SecLevel >= Settings.SysopOnlyUL _
                     THEN CALL BitSet(FileList.Attr,6) : _
                          TT = 62 : _
                          CALL SendTT
                  IF K9 > 0 THEN CALL FilePutRec(K5,FileIDX.FRec,119,FileList) _
                            ELSE CALL CreateFileStuff(2,FileList.Attr,0,K5) : _ 
                                 CALL FilePutRec(K5,FileLof&(K5,119) + 1,119,FileList)
                  CALL FilePutSEnd(K2,LEFT$(ExpandFileName$(K4$),9))
           END SELECT
    END SELECT
  LOOP UNTIL K0& = -1
  CALL FileClose(K3)
  CALL FileClose(K4)
  CALL FileClose(K5)
  CALL FileClose(K10)
  CALL KillFile(MID$(K5$,54,40))
  IF K& <> Settings.HiFilePtr _
     THEN TT = 147 : _
          CALL SendTT
          K2 = FileOpen(FileNames$(75) + Form4$(3,Settings.Node)) : _
          CALL FilePutLoc(K2,0&,259,Settings) : _
          CALL FileClose(K2)
  IF p = -1 OR p = 0 THEN CALL AI(5,Null$,K1,0,0,0,0,0&,0&)
  '
  ' Handle comment insertion.
  '
  SELECT CASE p
    CASE 1, -1
         IF FindF(FileNames$(79),FFile) = 0 THEN EXIT SUB    'COMMENT.TXT
         K1 = FileOpen(FileNames$(49))                       'FNAMES.CTL
         K& = 0
         DO
           K2$ = FileGetLine$(K1,K&)
           SELECT CASE RIGHT$(K2$,4)
             CASE Short$(993)
                  K3$ = FileNames$(33) + Short$(994) + K2$ + Short$(995) + _
                        FileNames$(79)
                  K2 = FindF(K2$,FFile)
                  IF DriveSpc(K2$) > FFile.FSize + Settings.MinSpace _
                     THEN CALL ShellDos(1,K3$)
             CASE Short$(996)
                  SELECT CASE DriveSpc(K2$)
                    CASE IS > Settings.MinSpace
                         K2 = FileOpen(K2$)
                         K0& = FileLof&(K2,1)
                         IF K0& > 8192 THEN K0& = 8192
                         K3$ = SPACE$(K0&)
                         K0& = FileLof&(K2,1) - K0&
                         CALL FileGetSLoc(K2,K0&,K3$)
                         K3 = StrSrch(1,K3$,Short$(572) + AscChr$(5) + AscChr$(6))
                         SELECT CASE K3
                           CASE IS > 0
                                K0& = K0& + K3 + 19
                                K3 = FileOpen(FileNames$(79))
                                K4 = FileLof&(K3,1)
                                K3$ = SPACE$(K4)
                                CALL FileGetSLoc(K3,0&,K3$)
                                CALL FileClose(K3)
                                CALL FilePutLoc(K2,K0&,2,K4)
                                CALL FilePutSLoc(K2,K0& + 2,K3$)
                                CALL FilePutLoc(K2,K0& + 2 + K4,0,K4)
                         END SELECT
                         CALL FileClose(K2)
                  END SELECT
           END SELECT
         LOOP UNTIL K& = -1
         CALL FileClose(K1)
  END SELECT

END SUB
        '
        '* * * *

