' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will take a message in MessageBody$ and turn it
        ' into a quoted message.  One must load MessageBody$ with the
        ' message before calling this.
        '
        ' Quoting the text is relatively easy.  Working with quoted
        ' text is extremely difficult (see InsertLines, FindMsgLine,
        ' and DeleteLines).
        '
        ' If a message is near the 99 line limit, then quoting could
        ' produce a message longer than 99 lines.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB QuoteTheMessage

  CALL ExpandFileMsgs
  MessageBody$ = MessageBody$ + C13$            'Add a CR/LF for MESSAGE.xxx
                                                'files (ExpandFileMsgs strips
                                                'all trailing ones off).
  WHILE RIGHT$(MessageBody$,2) = C13$ + C13$   'Reduce to only one ending CR/LF.
    MessageBody$ = LEFT$(MessageBody$,LEN(MessageBody$) - 1)
  WEND
  MessageBody$ = C0$ + MessageBody$             'C0$ is our 'paragraph is a
                                                'quote' marker.
  CALL StripExtras
  DO
    K = StrSrch(K + 1,MessageBody$,C13$)        'Find end of paragraph.
    IF K = 0 THEN K = LEN(MessageBody$)         'Quote our last line too.
    MessageBody$ = LEFT$(MessageBody$,K) + C0$ + MID$(MessageBody$,K + 1)
                                                'Quote at the start of each
                                                'paragraph.
    K = K + 2
  LOOP UNTIL K >= LEN(MessageBody$)
  TT$ = NCR$(Message.MsgTo)                     'Credit the quote.
  IF TT$ <> Short$(402) _
     THEN TT$ = C0$ + Short$(478) + TT$ + Short$(580) + C13$ _
     ELSE TT$ = C0$ + C32$ + C13$
  MessageBody$ = TT$ + MessageBody$ + C13$

END SUB
        '
        '* * * *




        '* * * * * *
        ' Strip extra stuff out of MessageBody$.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB StripExtras

  '
  ' Eliminate ^A kludge lines.
  '
  K = StrSrch1(MessageBody$,1)
  WHILE K > 0
    K0 = StrSrch(K,MessageBody$,C13$)
    IF K0 = 0 THEN K0 = LEN(MessageBody$)
    MessageBody$ = LEFT$(MessageBody$,K - 1) + MID$(MessageBody$,K0 + 1)
    K = StrSrch(K,MessageBody$,C1$)
  WEND
  '
  ' Now we strip Origin, Tear, Area, and Seen-by lines.
  '
  FOR K1 = 878 TO 881
    K = StrSrch(1,MessageBody$,C13$ + Short$(K1))
    WHILE K > 0
      K0 = StrSrch(K + 1,MessageBody$,C13$)
      IF K0 = 0 THEN K0 = LEN(MessageBody$)
      MessageBody$ = LEFT$(MessageBody$,K) + MID$(MessageBody$,K0 + 1)
      K = StrSrch(K,MessageBody$,C13$ + Short$(K1))
    WEND
    IF LEFT$(MessageBody$,LEN(Short$(K1))) = Short$(K1) _
       THEN K0 = StrSrch1(MessageBody$,13) : _
            MessageBody$ = MID$(MessageBody$,K0 + 1)
  NEXT

END SUB
        '
        '* * * *

