' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine displays a message, and handles all the
        ' reading messages user options.
        '
        ' p  0 for reading all mail sent TO/FROM user in messages.
        '      (only used with private message bases)
        '    1 for reading NEW mail TO user in a (any) base.
        '      (only used with logon mail read)
        '    2 for reading a single or multiple letter(s) in any base.
        '    4 same as 2, except doesn't ask for a number, or N for
        '      new, question.
        '
        ' This routine relies on BaseIndex to determine what area it's
        ' in.  It doesn't alter BaseIndex.
        '
        ' Date last checked for perfection: Sep 15 1992
        '
SUB ReadMessages (p)

  IF BaseIndex = 32767 THEN EXIT SUB
  '
  ' If a sysop, and private mail, then offer them the opportunity to read any
  ' mail in the area.
  '
  IF BitTest(MsgBases(BaseIndex).SubType,2) AND p <> 1 _
     THEN IF User.UserName = MsgBases(BaseIndex).MsgOp THEN p = 2 _
                                                       ELSE p = 0
  CALL ReturnMsgInfo(K0,K1,K2,K3,K4,K5)
  '
  ' K0 = array location of first message in BaseIndex.
  ' K1 = array location of the last message in BaseIndex.
  ' K2 = array location of first message new to user in BaseIndex.
  ' K3 = array location of first message user sent or received in BaseIndex.
  ' K4 = total number of messages in BaseIndex new to the user.
  ' K5 = array location of first message TO the user in BaseIndex.
  '
  IF K0 = -1 THEN EXIT SUB                 'No messages in this message base.
  '
  ' Get the message to display first.
  '
  SELECT CASE p
    CASE 0 : K6 = K3
    CASE 1 : K6 = K5
    CASE 4 : K6 = K2
    CASE ELSE
         TT$ = BlockText2(553) + STR$(MsgPtr(K0).MsgNum) + Short$(223) + _
               STR$(MsgPtr(K1).MsgNum)
         K7 = K4
         IF K4 > 1 THEN K7 = 2 : _
                        TT$ = TT$ + Short$(227) + STR$(K4)
         TT$ = TT$ + BlockText2(554 + K7)
         CALL SendTT
         IF TGot < 1 THEN TT = 557 : _
                          CALL GetNumPlusTT(Short$(228))
         SELECT CASE TGot
           CASE 78
                TT = 10233
                CALL SendTT
                K6 = K2
           CASE ELSE
                K& = Val2&(TGot$)
                SELECT CASE K&
                  CASE 0, IS > MsgPtr(K1).MsgNum
                       TT = 559 + (K& = 0)
                       CALL SendTT
                       EXIT SUB
                  CASE ELSE
                       CALL DispCRLF
                       CALL DispCRLF
                       FOR K6 = K0 TO K1
                         IF MsgPtr(K6).MsgNum >= K& _
                            AND MsgPtr(K6).MsgBase = BaseIndex _
                            THEN EXIT FOR
                       NEXT
                END SELECT
         END SELECT
  END SELECT
  '
  ' No messages found, so exit.
  '
  IF K6 < K0 OR K6 > K1 OR (p = 1 AND K5 = -1) _
     THEN IF p = 1 OR p = 0 THEN TT = 560 : _
                                 CALL SendTT : _
                                 EXIT SUB _
                            ELSE EXIT SUB
  '
  ' Assign the hot-keys the user may use.
  '
  K$ = Short$(1024 + (UserSL = LevelsSize)) + C1$
  IF User.UserName = MsgBases(BaseIndex).MsgOp THEN K$ = K$ + Short$(364)
  '
  ' Display a message, and handle the message commands.
  '
  ' K6 = current message being processed.
  ' K7 = directional flag.
  ' K8 = checksum of user name--to speed things up.
  ' K9 = 16 Bits: 1  True if should do another ReturnMsgInfo.
  '               rest for the future
  '                                  
  K7 = 1
  K8 = StrCkSum(User.UserName)
  DO
'    IF NonStop THEN NonStop = 0 : _
'                    K0$ = Null$ _
'               ELSE 
K0$ = K$ + C13$
    MessageBody$ = Null$
    CALL DispMessage(MsgPtr(K6).MsgLoc,1,Short$(383) + K0$)
    '
    ' Some routines must have Message., so give it to them.  Doing for other
    ' commands just slows them down.
    '
    SELECT CASE TGot
      CASE 33, 47, 63, 67, 69, 70, 71, 82, 94
           CALL FileGetLoc(Handle(3),MsgPtr(K6).MsgLoc - 1,128,Message)
    END SELECT
    '
    ' Update the high-message-read pointers if the message being read is greater
    ' than that they've seen.  Special situation: at logon--only want to update
    ' the private message bases, or the public areas only if the message at is
    ' the next unread message.
    '
    K13 = (MsgPtr(K6).MsgNum > CVL(MID$(UserMsgInfo$,BaseIndex * 4 + 1,4)))
    IF p = 1 THEN IF NOT BitTest(MsgBases(BaseIndex).SubType,2) _
                     THEN IF K6 <> K2 THEN K13 = 0
    IF K13 THEN MID$(UserMsgInfo$,BaseIndex * 4 + 1,4) = MKL$(MsgPtr(K6).MsgNum)
    SELECT CASE BitTest(Message.Attr,12) + TGot
      CASE IS < 0
           K0$ = Paths$(5) + LTRIM$(STR$(Message.MsgNum)) + _
                 Short$(379) + LTRIM$(STR$(Message.MsgBase + 1)) + Short$(177)
           K99 = 0
           K9 = FindF(K0$,FFile)
           TT$ = Null$
           WHILE K9 <> 0 : _
                 TT$ = TT$ + Short$(91) + Form$(1201,FFile.FName) + _
                       Short$(97) + Form$(1266,Commas$(FFile.FSize)) + _
                       BlockText2(800)
                 K9 = FindF(Null$,FFile)
                 K99 = K99 + 1
           WEND
           IF K99 > 0 _
              THEN TT$ = BlockText2(802 + (K99 = 1)) + TT$ + Short$(109) : _
                   CALL SendTT
    END SELECT
    K9 = 0
    '
    ' Display the Reading Messages Menu.  Unless we're in continuous mail
    ' read.
    '
    K10 = TGot
'    IF (TGot > 0) _
'       OR (BitTest(User.Toggles,4) AND Message.MsgTo <> User.UserName) _
'       THEN K10 = 1
    IF K10 = -1 AND BitTest(User.Toggles,4) AND Message.MsgTo <> User.UserName _
       AND Message.MsgFrom <> User.UserName _
       THEN K10 = 1
    SELECT CASE K10
      CASE -1
           K10 = 0
           K0$ = K$
           IF UserSL = LevelsSize _
              THEN TT$ = BlockText2(562) _
              ELSE TT$ = Null$
           IF Message.MsgFrom = User.UserName OR Message.MsgTo = User.UserName _
              THEN CALL BitSet(K10,1)
           IF User.UserName = MsgBases(BaseIndex).MsgOp THEN CALL BitSet(K10,2)
           IF (BitTest(K10,1) AND NOT BitTest(MsgBases(BaseIndex).SubType,5)) _
              OR BitTest(K10,2) _
              THEN K0$ = K0$ + Short$(384) : _
                   TT$ = TT$ + BlockText2(563)
           IF K10 <> 0 THEN K0$ = K0$ + Short$(385) : _
                            TT$ = TT$ + BlockText2(564)
           IF BitTest(Message.Attr,13) AND User.UserName = Message.MsgFrom _
              THEN K0$ = K0$ + Short$(214) : _
                   TT$ = TT$ + BlockText2(803)
           IF BitTest(Message.Attr,12) _
              THEN K0$ = K0$ + Short$(932) : _
                   IF User.UserName <> Message.MsgFrom _
                      THEN TT$ = TT$ + BlockText2(805 + (K99 = 1)) _
                      ELSE TT$ = TT$ + BlockText2(806)
           TT$ = Short$(387) + K0$ + Short$(493) + TT$ + BlockText2(561) + _
                 BlockText2(566 + (Menu.ShouldDo <> Short$(386)))
           CALL GetNumPlusTT(K0$ + AscChr$(9))
           K10 = AscVal(TGot$)
    END SELECT
    IF NoCarrier THEN EXIT DO
    '
    ' Process the selected option.
    '
    IF K10 = 71 AND BitTest(Message.Attr,12) AND User.UserName = Message.MsgFrom _
       THEN K10 = 711
    IF K10 = 66 AND BitTest(Message.Attr,12) THEN K10 = 712
    IF K10 = 90 AND BitTest(Message.Attr,12) THEN K10 = 713
    '
    ' For when users do an option before the body of the message has been
    ' loaded.  These routines must have MessageBody$
    '
    SELECT CASE K10
      CASE 47, 63, 67, 69, 70, 82
           IF LEN(MessageBody$) = 0 _
              THEN MessageBody$ = SPACE$(Message.NumOfBytes) : _
                   CALL FileGetSLoc(Handle(3),MsgPtr(K6).MsgLoc + 127,MessageBody$) : _
                   IF BitTest(Message.Attr,2) THEN MessageBody$ = UnSq$(MessageBody$)
    END SELECT
    SELECT CASE K10
      CASE 1, 78, 68, 0, 80, 70, 69, 63, 47, 94, 67, 9
           '
           ' These routines do something that requires that another message be
           ' found and displayed after the operation is completed.
           '
           SELECT CASE K10
             CASE 1                      'Continuous read--direction = K7.
             CASE 78, 9 : TT = 10547
                          CALL SendTT
                          K7 = 1
             CASE 68
                  TT = 584
                  CALL SendTT
                  CALL RemoveAMessage(K6,K7)
                  CALL BitSet(K9,1)
             CASE 0
                  IF NOT BitTest(User.Toggles,4) OR TGot = -1 _
                     THEN TT = 10656 : _
                          CALL SendTT : _
                          EXIT SUB
             CASE 80 : TT = 583
                       CALL SendTT
                       K7 = -1
             CASE 70
                  CALL ForwardNoteAdd(K6,K10,K7)
                  IF K10 = -1 THEN TT = 6 : _
                                   CALL SendTT : _
                                   CALL BitSet(K9,1)
             CASE 69 : TT = 10120
                       CALL SendTT
                       CALL EditSentMessage(K6,K7)
             CASE 63
                  TT = 10135
                  CALL SendTT
                  CALL RemoveAMessage(K6,K7)
                  K10 = BiSearch(5,0,Message.MsgFrom)
                  K12 = FileOpen(FileNames$(1))
                  CALL FileGetRec(K12,K10,384,AnyUser)
                  SELECT CASE LEN(RTRIM$(AnyUser.SysopNote))
                    CASE 0
                         CALL BitSet(AnyUser.Attr,10)
                         MessageBody$ = Message.MsgFrom + Short$(231) + C13$ + _
                                        C32$ + C13$ + MessageBody$
                         K11 = 1
                         CALL SaveMessageFile(K11)
                         AnyUser.SysopNote = RIGHT$(STR$(100 + K11),2) + Short$(418)
                         CALL FilePutRec(K12,K10,384,AnyUser)
                         CALL FileClose(K12)
                         IF Settings.PRMsgStart <> Short$(891) _
                            THEN MessageBody$ = Short$(415) + Settings.PRMsgStart : _
                                 CALL ComputerSend(AnyUser.UserName)
                    CASE ELSE
                         CALL BitSet(AnyUser.Attr,10)
                         CALL FilePutRec(K12,K10,384,AnyUser)
                         CALL FileClose(K12)
                         MessageBody$ = GetLine$(463) + _
                                        C13$ + C32$ + C13$ + MessageBody$
                         K11 = FileOpen(FileNames$(39) + Short$(750) + _
                                        LEFT$(AnyUser.SysopNote,2))
                         CALL FilePutSEnd(K11,MessageBody$)
                         CALL FileClose(K11)
                  END SELECT
                  CALL BitSet(K9,1)
                  K7 = 1
             CASE 47
                  TT = 581
                  CALL SendTT
                  Message.MsgTo = Message.MsgFrom      'Quote the sender.
                  CALL QuoteTheMessage
                  K0$ = UnSq$(RTRIM$(Message.MsgSubject))
                  MessageBody$ = GetLine$(582) + K0$ + C13$ + _
                                 C32$ + C13$ + MessageBody$ + GetBlock$(7)
                  K10$ = Message.MsgFrom
                  CALL BitSet(Message.Attr,11)
                  Message.MsgTo = C2$
                  K11 = AscVal(Message.NumberReplies)
                  IF K11 < 255 THEN Message.NumberReplies  = AscChr$(K11 + 1)
                  Message.MsgCheckSum = StrCkSum(Message.MsgTo + _
                                        Message.MsgFrom + Message.MsgSubject)
                  CALL FilePutLoc(Handle(3),MsgPtr(K6).MsgLoc - 1,128,Message)
                  CALL BitSet(Message.Attr,8)
                  CALL ComputerSend(K10$)
                  CALL RemoveAMessage(K6,K7)
                  CALL BitSet(K9,1)
                  K7 = 1
             CASE 67
                  TT = 808
                  CALL SendTT
                  SELECT CASE DriveSpc&(FileNames$(2))
                    CASE IS < Settings.MinSpace
                         TT = 123
                         CALL SendTT
                    CASE ELSE
                         K71& = Message.MsgNum
                         Message.MsgNum = MsgBases(BaseIndex).NextNumber
                         Message.MsgDateSent = LogonDate
                         Work(0) = 1
                         Work(1) = 0
                         IF RTRIM$(Message.MsgTo) <> Short$(717) _
                            THEN Work(1) = BiSearch(5,0,Message.Msgto)
                         K12& = MsgBases(Message.MsgBase).NextNumber
                         CALL BitClear(Message.Attr,13)
                         CALL StripExtras
                         WHILE RIGHT$(MessageBody$,3) = C13$ + C13$ + C13$
                           MessageBody$ = LEFT$(MessageBody$,LEN(MessageBody$) - 1)
                         WEND
                         CALL EnterMsg(1,0,C0$,Null$)
                         SELECT CASE MsgBases(Message.MsgBase).NextNumber
                           CASE K12& : K6 = K6 - K7
                           CASE ELSE
                                Kz0 = BiSearch(5,0,Message.MsgTo)
                                SELECT CASE Kz0
                                  CASE IS > 0
                                       '
                                       ' Undo the inform if they haven't read
                                       ' their first message yet.
                                       '
                                       Kz$ = UserMsgInfo$
                                       Kz1 = BasesSize * 4 + Message.MsgBase + 5
                                       Kz2 = FileOpen(FileNames$(3))
                                       CALL FileGetSLoc(Kz2,1& * (Kz0 - 1) * LEN(Kz$),Kz$)
                                       Kz = AscVal(MID$(Kz$,Kz1,1))
                                       IF Kz > 1 THEN MID$(Kz$,Kz1,1) = AscChr$(Kz - 1)
                                       CALL FilePutSLoc(Kz2,1& * (Kz0 - 1) * LEN(Kz$),Kz$)
                                       CALL FileClose(Kz2)
                                END SELECT
                                IF BitTest(Message.Attr,12) _
                                   THEN CALL MoveDirectory(K71&,Message.MsgBase,K12&)
                                CALL RemoveAMessage(K6,K7)
                                CALL BitSet(K9,1)
                         END SELECT
                  END SELECT
             CASE 94 : CALL Inform
                       K7 = 1
           END SELECT
           '
           ' This routine fetches the next message.
           '
           IF BitTest(K9,1) THEN CALL ReturnMsgInfo(K0,K1,K2,K3,K4,K5)
           DO
             K6 = K6 + K7
             IF K6 < K0 OR K6 > K1 OR (p = 1 AND K5 = -1) THEN EXIT DO
             IF MsgPtr(K6).MsgBase = BaseIndex AND p <> 0 AND p <> 1 _
                THEN CALL FileGetLoc(Handle(3),MsgPtr(K6).MsgLoc - 1,128,Message) : _
                     EXIT DO
             IF MsgPtr(K6).MsgBase = BaseIndex AND (p = 0 OR p = 1) _
                AND K8 = MsgPtr(K6).MsgTo _
                THEN CALL FileGetLoc(Handle(3),MsgPtr(K6).MsgLoc - 1,128,Message) : _
                     IF Message.MsgTo = User.UserName THEN EXIT DO
             IF MsgPtr(K6).MsgBase = BaseIndex AND p = 0 _
                AND K8 = MsgPtr(K6).MsgFrom _
                THEN CALL FileGetLoc(Handle(3),MsgPtr(K6).MsgLoc - 1,128,Message) : _
                     IF Message.MsgFrom = User.UserName THEN EXIT DO
           LOOP UNTIL NoCarrier
      CASE ELSE
           '
           ' These routines, for the most part, do something, and then
           ' re-display the currently displayed message.
           '
           SELECT CASE K10
             CASE 66, 90 : EXIT SUB
             CASE 86 : CALL ViewFileAttach(K99)
             CASE 71 : CALL DLFileAttach(K99)
             CASE 711, 712, 713
                  IF K10 = 711 THEN TT = 809 : _
                                    CALL SendTT
                  TGot = K10
                  CALL DoFileAttach
             CASE 82
                  TT = 591
                  CALL SendTT
'here is a bug:
'it will incrment number of replies even when the user chooses to abort.
'confirm that entermsg returns -1 when abort is done, and then modify this
'section accordingly.
                  K10 = AscVal(Message.NumberReplies)
                  IF K10 < 255 THEN Message.NumberReplies  = AscChr$(K10 + 1)
                  CALL FilePutLoc(Handle(3),MsgPtr(K6).MsgLoc - 1,128,Message)
                  K0$ = NCR$(Message.MsgFrom)
                  IF K0$ <> Short$(507) AND K0$ <> C2$ _
                     THEN K10 = BiSearch(2,0,Message.MsgFrom) : _
                          IF K10 = 0 THEN Message.MsgFrom = Short$(538)
                  CALL EnterMsg(0,4,Message.MsgFrom,Message.MsgSubject)
'                CALL BitSet(K9,1)
'took this out so it wouldn't keep going during login when replying to the
'last message in an area--doesn't reshow it.  However, I think this was needed
'for when replyed to msgs during not a login--so that when reach end it shows
'your new messages too, rather than just ending.  See if that's true, and
'decide if it's acceptable.
'
             CASE 65 : TT = 590
                       CALL SendTT
             CASE 85
                  TT = 585
                  CALL SendTT
                  CALL AlterTheUsersData
             CASE 83
                  TT = 10541
                  CALL SendTT
                  K0$ = Menu.ShouldDo
                  Menu.ShouldDo = Short$(544)
                  CALL DataBaser
                  Menu.ShouldDo = K0$
             CASE 33
                  TT = 586
                  CALL SendTT
                  FOR K10 = 1 TO BasesSize + 1
                    SWork$(K10) = MsgBases(K10 - 1).Title
                  NEXT
                  SWork$(K10) = Null$
                  TT = 76
                  CALL MenuSystemTT
                  SELECT CASE TGot
                    CASE IS > 0
                         K10 = TGot - 1
                         K71& = Message.MsgNum
                         K72 = Message.MsgBase
                         Message.MsgBase = K10
                         MsgPtr(K6).MsgBase = K10
                         Message.MsgNum = MsgBases(K10).NextNumber
                         MsgPtr(K6).MsgNum = Message.MsgNum
                         MsgBases(K10).NextNumber = MsgBases(K10).NextNumber + 1
                         IF BitTest(Message.Attr,12) _
                            THEN CALL MoveDirectory(K71&,K72,Message.MsgNum)
                         K11 = FileOpen(FileNames$(38))
                         CALL FilePutRec(K11,K10 + 1,108,MsgBases(K10))
                         CALL FileClose(K11)
                         CALL FilePutLoc(Handle(3),MsgPtr(K6).MsgLoc - 1,128,Message)
                         CALL BitSet(K9,1)
                         TT = 6
                         CALL SendTT
                  END SELECT
             CASE 64
                  TT = 464
                  CALL SendTT
                  CALL AlterTheMessagesData(K6)
             CASE ELSE
                  K& = Val2&(TGot$)
                  SELECT CASE K&
                    CASE 0 : TT = 10545
                             CALL SendTT
                             EXIT SUB
                    CASE IS > MsgPtr(K1).MsgNum : TT = 592
                                                  CALL SendTT
                    CASE ELSE
                         p = 2
                         FOR K6 = K0 TO K1
                           IF MsgPtr(K6).MsgNum >= K& _
                              AND MsgPtr(K6).MsgBase = BaseIndex _
                              THEN EXIT FOR
                         NEXT
                  END SELECT
           END SELECT
           IF BitTest(K9,1) THEN CALL ReturnMsgInfo(K0,K1,K2,K3,K4,K5)
    END SELECT
    IF K6 > K1 OR K6 < K0 OR (p = 1 AND K5 = -1) THEN EXIT DO
  LOOP UNTIL NoCarrier
  IF K6 > K1 THEN TT = 593 : _
                  CALL SendTT
  IF K6 < K0 THEN TT = 594 : _
                  CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to ReadMessages, will use the
        ' information in Message. to update MsgPtr(). and set the
        ' delete flag on a message.
        '
        ' p   is the array location in MsgPtr(). of the message to
        '     remove.
        '
        ' p0  direction flag being used.
        '
        ' [Leave this in READMSGS.BAS because putting it in
        ' READMSG2.BAS just makes it look really slow and user will
        ' want to hit [Enter] after doing a delete.]
        '
        ' Date last checked for perfection: Sep 15 1992
        '
SUB RemoveAMessage (p,p0)
CALL FileGetLoc(Handle(3),MsgPtr(p).MsgLoc - 1,128,Message)
CALL BitSet(Message.Attr,1)
CALL FilePutLoc(Handle(3),MsgPtr(p).MsgLoc - 1,2,Message.Attr)
FOR K0 = p + 1 TO ActiveMessages
  MsgPtr(K0 - 1) = MsgPtr(K0)
NEXT
IF p0 = 0 THEN p0 = 1
p = p - p0                                 'Go one before our current message.
ActiveMessages = ActiveMessages - 1
SELECT CASE BitTest(Message.Attr,12)
  CASE -1
       K$ = MakePathName$(Message.MsgNum,Message.MsgBase + 1)
       K1 = FindF(K$ + Short$(645),FFile)
       WHILE K1 <> 0
         CALL KillFile(K$ + FFile.FName)
         K1 = FindF(K$ + Short$(645),FFile)
       WEND
       CALL DirDelete(K$)
END SELECT
END SUB
        '
        '* * * *


