' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' This file contains routines that aren't really routines.  These routines
' provide a platform to jump to the multiple overlays of some routines.
'   GetAVote
'   EnterMsg
'   Initialize
'   PointShoot
'   Upload




        '* * * * * *
        ' This routine will ask a single voting question, if the user
        ' hasn't answered them all.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB GetAVote

  K = FileOpen(FileNames$(21))
  K$ = FileGetLine$(K,0&)
  CALL FileClose(K)
  FOR K = 1 TO Val2&(K$)
    IF MID$(User.Votes,K,1) = C0$ THEN CALL Vote(K) : _
                                       EXIT FOR
  NEXT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to EnterMsg, actually input's text
        ' from the user, handles the command options, and saves the
        ' message(s).  The only things from EnterMsg are Work(),
        ' Message., and MessageBody$.
        '
        ' p   -1 if, upon return from EnterMsgHeader, we should exit.
        '     (-1 for no message sent).
        '
        ' p0  if message is a reply or not.
        '
        ' p$ <> null if just loaded a message in from file,  Otherwise
        '            show the command line.
        '
        ' p0$   REPLY line and Dest: line.
        '
        ' Work() was also passed from EnterMsg, Upload and ProcessLog
        ' doesn't seem to use it, so I suspect it causes no problems.
        '
        ' Date last checked for perfection: Sep 16 1992
        '
SUB EnterMsg (p,p0,p$,p0$)

  k$ = p$
  k0$ = p0$
  IF p = 0 THEN CALL EnterMsgHeader(p,p0,k$,k0$) : _
                IF p < 0 THEN EXIT SUB
  IF k$ = Null$ THEN K0 = 67
  CALL EnterMsg3(K0)
  IF K0 = 65 THEN EXIT SUB _
             ELSE IF K0 = 37 THEN CALL SaveMessageFile(0) _
                             ELSE CALL SaveLines(K0,k0$) : _
                                  IF TGot = 1000 OR TGot = 712 OR TGot = 713 _
                                     THEN CALL DoFileAttach

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine handles the starting up of the BBS.
        '
        ' Date last checked for perfection: Nov 2 1992
        '
SUB Initialize

  CALL Initializer1
  CALL Initializer2
  IF BitTest(Toggles(2),8) _
    THEN Handle(1) = FileOpen(FileNames$(51))   'Open session trap file.
  '
  ' Check RUN_DOOR.BAT to see if we're returning from a door.
  '
  K0 = NonStop
  SELECT CASE K0
    CASE 0
         TT$ = GetLine$(250) + DATE$ + Short$(137) + RightTime$(Null$) + _
               Short$(798)
         CALL LogTT
         K0 = -1
    CASE ELSE : CALL DoorSystemReturn(K0)
  END SELECT
  TGot = K0

END SUB
        '
        '* * * *




        '* * * * * *
        ' This is the Point & Shoot File Selection and Information
        ' System.
        '
        ' p  Toggle for whether to do P&S or not.
        '
        ' Date last checked for perfection: Sep 18 1992
        '
SUB PointShoot (p)

  IF FileIndex = 32767 THEN EXIT SUB
  IF NOT FAccessAllowed(FileIndex) THEN EXIT SUB
  DO
    CALL PointShoot2(p,K2,K5)
    SELECT CASE TGot
      CASE 1000 : EXIT SUB
      CASE 1043 : CALL NextArea(1)
      CASE 1045 : CALL NextArea(-1)
      CASE 1086 : CALL Archiver(RTRIM$(FWork(K2).FName))
      CASE 1066 : IF Levels(UserSL).SecLevel >= Settings.BiSL _
                     THEN CALL Upload(1)
      CASE 1085, 1090 : CALL Upload(1)
      CASE 1068
           CALL DLStuff(2,Null$,0&)
           IF TGot = 1001 THEN CALL ShellDownload(1)
    END SELECT
  LOOP UNTIL NoCarrier OR FileIndex > FileLof&(Handle(22),22) OR FileIndex < 1
  CALL KillFile(FileNames$(49))
  FileIndex = 1

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine handles the processing for shelling to DOS,
        ' downloading something and then calling processlog.
        '
        ' p  What to do:
        '    1 delete FNAMES.CTL when done.
        '    2 to shelldos at line 19 and return -1 if file sent.
        '    3 to use NULL in the description parameter.
        '
        ' Date last checked for perfection: Nov 2 1992
        '
SUB ShellDownload (p)

  CALL SendTT
  CALL SysopLine(16)
  K0$ = TIME$
  IF p = 3 THEN K1$ = Null$ _
           ELSE K1$ = Short$(628)
  IF p = 2 THEN CALL ShellDos(7,ProtocolDn$) _
           ELSE CALL ShellDos(1,ProtocolDn$)
  CALL ProcessLog(0,K1$,Null$,K0$,User.Protocol)
  IF p = 1 THEN CALL KillFile(FileNames$(49))
  IF p = 2 AND K1$ <> Short$(628) THEN p = -1

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will do the processing up to and through the
        ' various upload protocols.   See ProcessLog for processing
        ' after the protocol.
        '
        ' p  1 for upload with current protocol.  (TGot$ = ZMODEM or
        '      BIMODEM for an auto-detect upload.)
        '    2 for BiModem
        '    3 for Targeted Upload
        '
        ' Date last checked for perfection: Sep 22 1992
        '
SUB Upload (p)

  zz = FileIndex
  CALL Upload2(p,K$,K,K0$,K00$,K1$,K2$)
  IF p > 0 THEN CALL ShellDos(8,K$) : _
                CALL ProcessLog(K,K0$,K00$,K1$,K2$)
  FileIndex = zz

END SUB
        '
        '* * * *

