' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will output text to comm and screen.
        '
        ' TT$  is the string to output (includes other information).
        '
        ' TT   is the LINES.xxx referenced string to use (overrides
        '      TT$).
        '
        ' TGot$ = NULL if string completely outputed, otherwise = the
        ' valid key hit.
        '
        ' TGot = -1 if string completely outputed, otherwise = the
        ' valid key hit.
        '
        ' The above are global, making them parameters uses too much
        ' unnecessary space.
        '
        ' The initial logic is so:  IF TT = 0 THEN use TT$
        '                                     ELSE get TT$ based on TT
        '
        ' A loss of carrier returns TGot$ = C13$ and TGot = 13 (as if
        ' the user hit [Enter]--which by design aborts most things, or
        ' issues the 'no' default to a question).
        '
        ' Rather than the awkward '|' + C13$ + '|' just use a '~' to
        ' represent a C13$ (that [Enter] is a valid option).
        ' Example: '|~|'.
        '
        ' Date last checked for perfection: Sep 16 1992
        '
SUB SendTT

  IF NoCarrier THEN TGot$ = C13$ : _
                    TGot = 13 : _
                    TT = 0 : _
                    EXIT SUB
  '
  ' K1  Bit 1 ON, Pause allowed.
  '     Bit 2 ON, Look for abort keys.
  '
  K1 = 0
  K0$ = Null$
  '
  ' If TT is not 0, then load in TT$ from LINES.TXT.  If TT is 0, then go
  ' through TT$ looking for our 'load from file' CHR$(3) codes, and load those
  ' lines in from LINES.TXT.
  '
  ' Note, this routine could be improved by loading in the string before it's
  ' actually outputted.  But because the 'first two' TT$ codes may also need
  ' to be loaded, I've concluded that the amount of extra work here isn't worth
  ' the improvement (which only occurs when a user aborts a string part-way).
  '
  SELECT CASE TT
    CASE IS > 10000
         TT$ = Short$(TT - 10000)
         TT = 0
    CASE 0
         K = StrSrch1(TT$,3)
         WHILE K > 0
           K& = CVI(MID$(TT$,K + 1,2)) - 1
           IF K& < 0 THEN K& = 65536 + K&
           K$ = FileGetLine$(Handle(6),K&)
           WHILE RIGHT$(K$,2) = Short$(250)
             K$ = LEFT$(K$,LEN(K$) - 2) + FileGetLine$(Handle(6),K&)
           WEND
           TT$ = LEFT$(TT$,K - 1) + K$ + MID$(TT$,K + 3)
           K = StrSrch(K,TT$,C3$)
           WEND
      CASE ELSE
           K& = CVI(RIGHT$(BlockText2(TT),2)) - 1
           IF K& < 0 THEN K& = 65536 + K&
           TT$ = FileGetLine$(Handle(6),K&)
           WHILE RIGHT$(TT$,2) = Short$(250)
             TT$ = LEFT$(TT$,LEN(TT$) - 2) + FileGetLine$(Handle(6),K&)
           WEND
           TT = 0
    END SELECT
  IF LEN(TT$) = 0 THEN EXIT SUB
  '
  ' Better speed would be gained by putting the CALL Ansi at the end (after the
  ' text has been fully outputed and before the delay's) since the Ansi routine
  ' could handle the full text at once [CALL Ansi(MID$(TT$,K0))]--instead of
  ' calling it for each character.  The trouble: you don't get a real-time
  ' display of what the user is getting, if they hit a key, you don't get the
  ' text they already got.
  '
  ' I don't check for loss of carrier in the loop because it would unnecessarily
  ' slow the loop down.  What happens, then, is that loss of carrier will be
  ' detected after the line is outputted.  The fossil handles loss of carrier
  ' correctly and won't try to send these post-hangup characters out the port.
  ' But they will get displayed.
  '
  TGot$ = Null$                                   'Exit with a Null.
  TGot = -1                                       'Exit with a -1.
  K = 1                                           'Start of to-be-output text.
  K4 = LEN(TT$)                                   'End of to-be-output text.
  WHILE K <= K4                                   'Do until reach the end.
    K$ = MID$(TT$,K,1)                            'Get the character.
    K2 = AscVal(K$)
    '
    ' We're looking for smart text.
    '
    K2$ = Null$
    IF BitTest(User.Toggles,15) _
       THEN IF MID$(TT$,K + 1,3) = K$ + K$ + K$ _
               THEN K3 = K : _
                    DO : K = K + 1 : _
                    LOOP UNTIL MID$(TT$,K + 1,1) <> K$ : _
                    K2$ = AscChr$(25) + K$ + AscChr$(K - K3 + 1) : _
                    K$ = STRING$(K - K3 + 1,K2) : _
                    K2 = 0
    SELECT CASE K2
      '
      ' First we look for our internal ASCII 20 codes.
      '
      CASE 20
           '
           ' A '' smart designator was found.
           '
           K2 =  AscVal(MID$(TT$,K + 1,1))
           SELECT CASE K2
             CASE 33 : K$ = Form$(20,Settings.Sysop) '!  Sysop's first.
             CASE 62 : K$ = C1310$                   '>  CR/LF.
             CASE 63 : K$ = Form$(20,User.UserName)  '?  User's first.
             CASE 42 : CALL Delay                    '*  Pause 1 second.
                       K$ = Null$
             CASE 43 : CALL BitSet(K1,1)             '+  Pause allowed.
                       CALL BitSet(K1,2)
                       K$ = Null$
             CASE 45 :                               '-  Draw 'top box'.
                  K$ = Short$(380) + _
                       STRING$(Val2&(MID$(TT$,K + 2,2)),196) + Short$(381) + _
                       C1310$
                  K = K + 2
             CASE 231 : K$ = GetLine$(1)             '  Insert title.
             CASE 124                                '|  Define abort keys.
                  Kz = StrSrch(K + 2,TT$,Short$(153))
                  IF Kz > 0 THEN K0$ = MID$(TT$,K + 2,Kz - K - 2) : _
                                 CALL BitSet(K1,2) : _
                                 K = kz - 1: _
                                 K$ = Null$ : _
                                 Kz = StrSrch1(K0$,126) : _
                                  IF Kz > 0 AND NOT NonStop THEN MID$(K0$,Kz,1) = C13$
             CASE 64                                 '@  Display file.
                  Kz = StrSrch(K + 2,TT$,Short$(360))
                  IF Kz > 0 THEN Kn$ = MID$(TT$,K + 2,Kz - K - 2) : _
                                 CALL DispFile(Kn$,Null$) : _
                                 K = kz - 1: _
                                 K$ = Null$
             CASE ELSE : K = K - 1
           END SELECT
           K = K + 1
      '
      ' Next look for ANSI ASCII 27 codes.
      '
      CASE 27
           '
           ' An ANSI <esc> designator was found.
           '
           CALL AnsiProcessor(TT$,K$,K2$,K)
    END SELECT
    IF LEN(K2$) = 0 THEN CALL CommOut(K$) _
                    ELSE CALL CommOut(K2$)
    IF NOT BitTest(Toggles(2),2) THEN CALL Ansi(K$)              'To the screen.
    DO
      '
      ' If we're to look for keys, then do so, and process what we find.
      '
      SELECT CASE BitTest(K1,2)
        CASE -1
             K2 = CommIn(0)
             SELECT CASE K2 
               CASE IS >= 0
                    IF BitTest(K1,1) AND (K2 = 32 OR K2 = 9) _
                       THEN TGot$ = TIME$ : _
                            DO : TGot = CommIn(0) : _
                            LOOP UNTIL TGot = 32 OR TGot = 13 OR TGot = 9 OR NoCarrier _
                                       OR ElapsedTime(TGot$,K2) = Settings.TimeOut : _
                            K2 = -1 : _
                            TGot = -1
                    IF K2 > 96 THEN CALL BitClear(K2,6)  'Uppercase it.
                    IF StrSrch1(K0$,K2) > 0 _
                       THEN TGot$ = AscChr$(K2) : _
                            TGot = K2 : _
                            CALL PurgeComIO(CommPort) : _
                            TT$ = Short$(68) : _
                            CALL CommOut(TT$) : _
                            CALL AnsiTT : _
                            K = K4              'We want to exit our WHILE loop.
             END SELECT
      END SELECT
      '
      'Loop until the buffer is clear (characters were sent) or a valid
      'key was entered or if we're local.  No need for NoCarrier because
      'that will clear the buffer too.
      '
    LOOP UNTIL BitTest(FosIntAX(CommPort,&H300),15) OR TGot > 0 OR CommPort = 0
    K = K + 1
  WEND
  IF TGot > 0 THEN EXIT SUB
  IF NoCarrier THEN TGot$ = C13$ : _
                    TGot = 13 : _
                    EXIT SUB

END SUB
        '
        '* * * *

