; Copyright (c) 1991-1992, John David Rohner.  All rights reserved.

;
; This routine returns the display length of a string--ignoring ANSI codes
; and "x" codes.  It only knocks off 2 for "|" codes though.
;
; Usage:  Result% = StripLen(Input$)
; Declare:  DECLARE FUNCTION StripLen% (Input$)
;
; Where Result% is the display length, and Input$ is the string to use.
;
; It does the codes on the cheap (all }x codes, not just }1 to }9), so fix
; this up in the future.
;

.Model Medium, Basic
.Code


DGROUP      group   _DATA

_DATA       segment word public 'DATA'

AnsiCodes   DB      'fmCsuJKHABDR'

_DATA       ends


            PUBLIC  StripLen          ;Make this routine available to LINK.

StripLen    proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp
            cld

            mov     si,[bp + 06]      ;Descriptor of Input$.
            lodsw                     ;Get the length,
            xchg    cx,ax             ; into CX.
            lodsw                     ;Get the address,
            xchg    si,ax             ; and put it in SI.
            mov     bx,cx
            jcxz    Done

            push    ds                ;Copy DS,
            pop     es                ;to ES for the string operations.
            xor     dx,dx

        R1: lodsb
            cmp     dx,0
            jge     R4
            cmp     al,48
            jl      R4
            cmp     al,91
            jg      R4

            cmp     al,59
            je      R4
            cmp     al,60
            je      R4
            cmp     al,61
            je      R4
            cmp     al,62
            je      R4
            cmp     al,63
            je      R4
            dec     bx
            dec     bx
            xor     dx,dx

        R4: cmp     dx,0
            jle     R5
            push    cx
            mov     cx,12
            lea     di,AnsiCodes
            repne   scasb             ;Compare AL until find (or not) a match.
            je     R6                ;match found, exit.
            pop     cx
            inc     dx
            jmp     R5
        R6: pop     cx
            sub     bx,dx
            xor     dx,dx

        R5: cmp     al,20
            jne     R2
            mov     dx,-1
        R2: cmp     al,27
            jne     R3
            mov     dx,2
        R3: cmp     al,125
            jne     R7
            mov     dx,-1
        R7: loop    R1

      Done: xchg    ax,bx
            pop     bp
            ret     2                 ;Pop-return past our input parameter.

StripLen    endp                      ;End of routine.

End


