; Copyright (c) 1991-1992, John David Rohner.  All rights reserved.

;
; This routine will replace the characters in one string with the characters
; in in another, defining, string.
;
; Usage:  CALL StrXLate(String$, DefString$)
; Where String$ is the text to work on, and DefString$ is a 256 length
; string containing the new values.  String$ is mapped to DefString$ by
; it's ASCII value.  Thus an "a", CHR$(97), will get the character stored
; in position 97 of DefString$--could be "a", "A", or any other of the
; 256 ASCII codes.
;
; DefString$ need not be 256 characters in length.  But since no sophisticated
; checking is done, be very sure the ASCII values of your input string don't
; contain values greater then the length of DefString$ if you use a length
; less than 256 characters.
;

.Model Medium, Basic
.Code

            PUBLIC  StrXLate          ;Make this routine available to LINK.

StrXLate    proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp
            cld                       ;We'll move forward in the string.
            mov     si,[bp + 08]      ;Get String$'s descriptor.
            lodsw                     ;Get it's length
            xchg    cx,ax             ; in CX.
            jcxz    Done              ;If zero, then exit.
            lodsw                     ;Address of String$
            xchg    si,ax             ; -> SI.
            mov     bx,[bp + 06]      ;Get DefString$'s descriptor.
            mov     bx,[bx + 02]      ;Address of DefString$ -> BX.
        R1: lodsb                     ;Get a byte from SI into AL.
            xlat                      ;AL = [BX + AL]  That is, get the value
                                      ;of our DefString$ at position AL (ASCII
                                      ;number) and move it to AL.  BX is the
                                      ;location of DefString$, AL an offset.
            mov [si - 01],al          ;Lodsb +1'd to SI, so we need to
                                      ;subtract before replacing the original
                                      ;ASCII value.
            loop    R1                ;Decrement CX, repeat until zero.
      Done: pop     bp
            ret     4                 ;Pop-return past our input parameters.

StrXLate    endp                      ;End of routine.

End

