' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will get a character from the user.
        '
        ' p$  list of valid/accepted keys.
        '     The following are special attention codes:
        '       CHR$(1) means to accept a protocol auto-detect string.
        '       CHR$(2) don't do the usual purge of I/O after a valid key.
        '       CHR$(3) means to use the LOGO inactivity delay
        '       CHR$(4) means to also check for arrow keys.
        '       CHR$(5) means to accept <ctrl>Fx keys.
        '
        ' TGot$/TGot returns with the valid key hit, an enter or loss
        ' of carrier will return a NULL and -1, respectively.
        ' TGot$ may also contain the special purpose output strings
        ' ZMODEM and BIMODEM for when the auto-detect sequence related
        ' to these protocols was detected.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB TGet (p$)

  K0$ = p$
  K2 = 0
  FOR K = 1 TO 5
    K0 = StrSrch1(K0$,K)
    IF K0 > 0 THEN CALL BitSet(K2,K) : _
                   K0$ = LEFT$(K0$,K0 - 1) + MID$(K0$,K0 + 1)
  NEXT
  IF BitTest(K2,3) THEN K1 = Settings.LogoTimeOut * 100 _
                   ELSE K1 = Settings.Timeout * 100
  K0 = K1 - 70
  K1$ = TIME$
  DO
    '
    ' Check our inactivity.
    '
    K = ElapsedTime(K1$,K3)
    SELECT CASE K * 100 + K3
      CASE K1
           CALL Quote
           CALL HangUp
           TGot$ = Null$
           TGot = -1
           EXIT SUB
      CASE K0
           TT$ = GetLine$(172) + STR$(K1 - 40 - K0) + GetLine$(173)
           CALL CommOut(TT$)
           CALL AnsiTT
           K0 = K0 + 10
    END SELECT
    '
    ' Check the keyboard and the port.
    '
    IF NOT BitTest(K2,5) THEN TGot = CommIn(0) _
                         ELSE TGot = CommIn(-4) : _
                              IF TGot > 24000 THEN EXIT SUB
    '
    ' Check keyboard arrow keys.
    '
    SELECT CASE BitTest(K2,4)
      CASE -1
           SELECT CASE TGot
             CASE 19200 : TGot$ = Short$(1004)
                          TGot = 8
                          EXIT SUB
             CASE 18432 : TGot$ = Short$(1001)
                          TGot = 8
                          EXIT SUB
             CASE 19712 : TGot$ = Short$(1003)
                          TGot = 32
                          EXIT SUB
             CASE 20480 : TGot$ = Short$(1002)
                          TGot = 32
                          EXIT SUB
           END SELECT
    END SELECT
    '
    ' Check incoming arrow keys.
    '
    SELECT CASE BitTest(K2,4)
      CASE -1
           K = 1
           WHILE TGot = AscVal(MID$(Short$(178),K,1)) AND K < 3
             DO : TGot = CommIn(0)
             LOOP UNTIL TGot >= 0 OR NoCarrier
             K = K + 1
             SELECT CASE K
               CASE 3
                    DO : zz = CommIn(0)
                    LOOP UNTIL zz >= 0 OR NoCarrier
                    SELECT CASE zz
                      CASE 65 : TGot = 8
                      CASE 66 : TGot = 32
                      CASE 67 : TGot = 32
                      CASE 68 : TGot = 8
                      CASE ELSE : TGot = zz
                    END SELECT
                    IF zz <> TGot THEN TGot$ = Short$(1066 - zz) : _
                                       EXIT SUB
             END SELECT
           WEND
    END SELECT
    '
    ' Check incoming protocol auto-detect strings.
    '
    SELECT CASE BitTest(K2,1)
      CASE -1
           '
           ' Check BiModem auto upload string: '' (also + '')
           '
           K = 1
           WHILE TGot = AscVal(MID$(Short$(183),K,1)) AND K < 5
             DO : TGot = CommIn(0)
             LOOP UNTIL TGot >= 0 OR NoCarrier
             K = K + 1
             IF K = 5 THEN TGot$ = Short$(187) : _
                           TGot = 1 : _
                           EXIT SUB
           WEND
           '
           ' Check ZModem auto upload string:
           '        'rzCHR$(13)**CHR$(24)B' (also + '0...')
           '
           SELECT CASE TGot
             CASE 114
                  '
                  ' We have an 'r', but since menu commands also start with 'r',
                  ' we need to get the next character.  What I did was just grab
                  ' the next port check.  This could/may be too fast on faster
                  ' machines or with HST's.  If so, add some sort of delay--such
                  ' as looping for 100 iterations to see if another character
                  ' comes down the line--because 'r' menu commands won't have
                  ' any other characters.
                  '
                  K = CommIn(0)
                  IF K >= 0 THEN TGot = K
                  K = 2
                  K1$ = Short$(207) + C13$ + Short$(210) + AscChr$(24) + Short$(211)
                  WHILE TGot = AscVal(MID$(K1$,K,1)) AND K < 8
                    DO : TGot = CommIn(0)
                    LOOP UNTIL TGot >= 0 OR NoCarrier
                    K = K + 1
                    IF K = 8 THEN TGot$ = Short$(225) : _
                                  TGot = 1 : _
                                  EXIT SUB
                  WEND
           END SELECT
    END SELECT
    IF TGot = 127 THEN TGot = 8
    IF TGot > 96 THEN CALL BitClear(TGot,6) _
                 ELSE IF TGot < 0 THEN TGot = 0
  LOOP UNTIL StrSrch1(K0$,TGot) > 0 OR NoCarrier
  TGot$ = AscChr$(TGot)
  IF TGot = 13 OR NoCarrier THEN TGot$ = Null$ : _
                                 TGot = -1
  IF NOT BitTest(K2,2) THEN CALL PurgeComIO(CommPort)

END SUB
        '
        '* * * *

